

function uM_translation (array) {
    var array_ = array.split(','); 
    _uM_m1 = array_[0];
    _uM_m2 = array_[1];
    _uM_m3 = array_[2];
    _uM_m4 = array_[3];
    _uM_m5 = array_[4];
    _uM_m6 = array_[5];
    _uM_m7 = array_[6];
    _uM_m8 = array_[7];
    _uM_m9 = array_[8];
    _uM_m10 = array_[9];
    _uM_m11 = array_[10];
    _uM_m12 = array_[11];
    _uM_m13 = array_[12];
    _uM_m14 = array_[13];
    _uM_m15 = array_[14];
}


function uM_u_GridInit() {

	require(['dojo/ready','dojo/parser','dojo/dom','dojo/dom-style','dojo/dom-class','dojo/on','dojox/grid/DataGrid','dijit/Tooltip',
	         'dojox/data/QueryReadStore','dijit/form/Select','dojo/_base/xhr','dojo/query','dijit/form/Form','dijit/form/Button',
	         'dijit/form/FilteringSelect','dijit/form/ComboBox','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

        function(ready, parser, dom, domStyle, domClass, on, DataGrid, Tooltip, QueryReadStore, Select, xhr, query){
        
        _uM_grid_loading = '1';
        
        ready(function(){ 

            _selection = 'users';
            _toSearch = '';

            xhr.post({
                url: './loadDatabase/check',
                handleAs: 'json',
                preventCache: true

            }).then(function(jsonData){
        
                var numRows = jsonData.numRows.toString();
                var existsProfile = jsonData.existsProfile.toString();
                
                var uM_U_h1 = jsonData.uM_U_h1.toString();
                var uM_U_h2 = jsonData.uM_U_h2.toString();
                var uM_U_h3 = jsonData.uM_U_h3.toString();
                var uM_U_h4 = jsonData.uM_U_h4.toString();
                var uM_U_h5 = jsonData.uM_U_h5.toString();
                var uM_U_h6 = jsonData.uM_U_h6.toString();
                var uM_U_h6_1 = jsonData.uM_U_h6_1.toString();
                var uM_U_h6_2 = jsonData.uM_U_h6_2.toString();
                var uM_U_h7 = jsonData.uM_U_h7.toString();
                var uM_U_h8 = jsonData.uM_U_h8.toString();
                var uM_U_h8_1 = jsonData.uM_U_h8_1.toString();
                var uM_U_h8_2 = jsonData.uM_U_h8_2.toString();
                var uM_U_h9 = jsonData.uM_U_h9.toString();

                if (numRows != '0') {

		            var userStore = new QueryReadStore({
	   	                url: './loadDatabase/',
	   	                requestMethod: 'post'
	                });

	                if (existsProfile == '0') {
	            
                        var gridUserLayout = [
                            {type: 'dojox.grid._CheckBoxSelector', width: '3em', scroll: true},
                            {cells: [[
                                { width: '170px' },
			                    { width: '48px' },
			                    { width: '80px' }, 
                                { width: '75px' },
                                { width: '75px' }, 
                                { width: '140px' },
                                { width: '85px' },
                                { width: '110px' },
                                { width: '120px' }
                            ],[
                                { name: uM_U_h1, rowSpan: 2, headerClasses: 'userHeaderGrid', styles:'padding-left:8pt;text-align:left;' },
			                    { name: uM_U_h2, rowSpan: 2, headerClasses: 'userHeaderGrid' },
			                    { name: uM_U_h3, rowSpan: 2, headerClasses: 'userHeaderGrid' },
                                { name: uM_U_h4, rowSpan: 2, headerClasses: 'userHeaderGrid' },
                                { name: uM_U_h5, rowSpan: 2, headerClasses: 'userHeaderGrid' },
                                { name: uM_U_h7, rowSpan: 2, headerClasses: 'userHeaderGrid' }, 
                                { name: uM_U_h8, colSpan: 2, styles:'text-align:center', headerClasses: 'userHeaderGrid' },
                                { name: uM_U_h9, rowSpan: 2, headerClasses: 'userHeaderGrid' }
                                
                            ],[
                                { name: ' ', field: 'user', headerClasses: 'userHeaderGrid', cellClasses: 'dojoxGridStyle', styles:'padding-left:8pt;text-align:left;', formatter: uM_inputTextUsernameFormat },
			                    { name: ' ', field: 'status', headerClasses: 'userHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_statusIconFormat },
			                    { name: ' ', field: 'gen_perm', headerClasses: 'userHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_userTypeFormat },
                                { name: ' ', field: 'pass', headerClasses: 'userHeaderGrid', cellClasses: 'dojoxGridStyle' },
                                { name: ' ', field: 'id_cert', headerClasses: 'userHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_userCertViewFormat },
                                { name: ' ', field: 'ldate', headerClasses: 'userHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_lastVisitedFormat },
                                { name: ' ', field: 'user_perm', headerClasses: 'userHeaderGrid', cellClasses: 'dojoxGridStyle' },
                                { name: ' ', field: 'user_perm_page', headerClasses: 'userHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_permPageDetailsFormat },
                                { name: ' ', field: 'cdate', headerClasses: 'userHeaderGrid', cellClasses: 'dojoxGridStyle' } 
                            ]],
                            onBeforeRow : function(inDataIndex, inSubRows) {
			                    inSubRows[0].invisible = true;
                            },
                            onAfterRow : function(inDataIndex, inSubRows) {
                                query('#usersGridHdr16.userHeaderGrid' + ' div.dojoxGridSortNode').forEach(function(node, index, arr){
	                                node.innerHTML = uM_U_h8_1;
                                });
                                query('#usersGridHdr17.userHeaderGrid' + ' div.dojoxGridSortNode').forEach(function(node, index, arr){
	                                node.innerHTML = uM_U_h8_2;
                                });
                                domClass.add('usersGridHdr9', 'dojoxGridEditableNode');
                            }}
                        ];
                    
                    } else {
                    
                        var gridUserLayout = [
                            {type: 'dojox.grid._CheckBoxSelector', width: '3em', scroll: true},
                            {cells: [[
                                { width: '170px' },
			                    { width: '48px' },
			                    { width: '80px' }, 
                                { width: '75px' },
                                { width: '75px' }, 
                                { width: '120px' },
                                { width: '40px' },
                                { width: '140px' },
                                { width: '85px' },
                                { width: '85px' },
                                { width: '110px' }
                            ],[
                                { name: uM_U_h1, rowSpan: 2, headerClasses: 'userProfileHeaderGrid', styles:'padding-left:8pt;text-align:left;' },
			                    { name: uM_U_h2, rowSpan: 2, headerClasses: 'userProfileHeaderGrid' },
			                    { name: uM_U_h3, rowSpan: 2, headerClasses: 'userProfileHeaderGrid' },
                                { name: uM_U_h4, rowSpan: 2, headerClasses: 'userProfileHeaderGrid' },
                                { name: uM_U_h5, rowSpan: 2, headerClasses: 'userProfileHeaderGrid' },
                                { name: uM_U_h6, colSpan: 2, headerClasses: 'userProfileHeaderGrid' },
                                { name: uM_U_h7, rowSpan: 2, headerClasses: 'userProfileHeaderGrid' },
                                { name: uM_U_h8, colSpan: 2,  headerClasses: 'userProfileHeaderGrid' },
                                { name: uM_U_h9, rowSpan: 2, headerClasses: 'userProfileHeaderGrid' }
                            ],[
                                { name: ' ', field: 'user', headerClasses: 'userProfileHeaderGrid', cellClasses: 'dojoxGridStyle', styles:'padding-left:8pt;text-align:left;', formatter: uM_inputTextUsernameFormat },
			                    { name: ' ', field: 'status', headerClasses: 'userProfileHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_statusIconFormat },
			                    { name: ' ', field: 'gen_perm', headerClasses: 'userProfileHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_userTypeFormat },
                                { name: ' ', field: 'pass', headerClasses: 'userProfileHeaderGrid', cellClasses: 'dojoxGridStyle' },
                                { name: ' ', field: 'id_cert', headerClasses: 'userProfileHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_userCertViewFormat },
                                { name: ' ', field: 'group', headerClasses: 'userProfileHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_groupDataFormat },
                                { name: ' ', field: 'id_profile', headerClasses: 'userProfileHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_u_profileViewFormat },
                                { name: ' ', field: 'ldate', headerClasses: 'userProfileHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_lastVisitedFormat },
                                { name: ' ', field: 'user_perm', headerClasses: 'userProfileHeaderGrid', cellClasses: 'dojoxGridStyle' },
                                { name: ' ', field: 'user_perm_page', headerClasses: 'userProfileHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_permPageDetailsFormat },
                                { name: ' ', field: 'cdate', headerClasses: 'userProfileHeaderGrid', cellClasses: 'dojoxGridStyle' }
                            ]],
                            onBeforeRow : function(inDataIndex, inSubRows) {
			                    inSubRows[0].invisible = true;
                            },
                            onAfterRow : function(inDataIndex, inSubRows) {
                                query('#usersGridHdr20.userProfileHeaderGrid' + ' div.dojoxGridSortNode').forEach(function(node, index, arr){
	                                node.innerHTML = uM_U_h6_1;
                                });
                                query('#usersGridHdr21.userProfileHeaderGrid' + ' div.dojoxGridSortNode').forEach(function(node, index, arr){
	                                node.innerHTML = uM_U_h6_2;
                                });
                                query('#usersGridHdr22.userProfileHeaderGrid' + ' div.dojoxGridSortNode').forEach(function(node, index, arr){
	                                node.innerHTML = uM_U_h8_1;
                                });
                                query('#usersGridHdr23.userProfileHeaderGrid' + ' div.dojoxGridSortNode').forEach(function(node, index, arr){
	                                node.innerHTML = uM_U_h8_2;
                                });
                                domClass.add('usersGridHdr11', 'dojoxGridEditableNode');
                            }}
                        ];
                    }
                    
                    ready(function(){ 

                        uGrid = new DataGrid({
                            store: userStore,
                            structure: gridUserLayout,
                            rowsPerPage: 20,
	                        query: { query: '*' },
	                        queryOptions: {ignoreCase: true},
	                        noDataMessage: "<span class='dojoxGridNoData'>" + _uM_m11 + "</span>",
	                        onRowClick: function(e) {
	                           this.edit.rowClick(e);
	                        }
                        }, 'usersGrid');
                        
                        uGrid.on('HeaderCellClick', function(evt) {
                            evt.stopPropagation();
	                        query('#usersGrid th.dojoxGridCellFocus').forEach(function(node, index, arr){
	                            domClass.remove(node,'dojoxGridCellFocus');
                            });
                        }, true);
                        
                        uGrid.on('RowClick', function(event){
	                        query('#usersGrid td.dojoxGridCellFocus').forEach(function(node, index, arr){
	                            domClass.remove(node,'dojoxGridCellFocus');
                            });
                            
	                        var idx = event.rowIndex;
                            item = this.getItem(idx);
                            var id = this.store.getValue(item, 'id');
                            var inputWidget = dijit.byId('u_' + id); 
                            if (inputWidget) { inputWidget.focus(); }
                            var tooltip = dijit.byId('t_u_' + id);
                            if (tooltip) { 
                                var label = tooltip.get('label');
                                if (label != '') { Tooltip.show(label,'widget_u_' + id); } 
                            }
                        }, true);
                    
                        uGrid.on('SelectionChanged', function(){
			                var c_items = this.selection.getSelected();
			                store = this.store;

			                if (c_items.length == '0') {
			                    dijit.byId('uManagerB_p').set('disabled','disabled');
			                    dijit.byId('uManagerB_a').set('disabled','disabled');
			                    dijit.byId('uManagerB_ia').set('disabled','disabled');
			                    dijit.byId('uManagerB_d').set('disabled','disabled');
                	            
            	                dom.byId('selUser').setAttribute('value','');

			                } else {
    			            
			                    if (c_items.length == '1') {
			                        dijit.byId('uManagerB_p').set('disabled',false);
			                    } else {
			                        dijit.byId('uManagerB_p').set('disabled','disabled');
			                    }
			                    dijit.byId('uManagerB_d').set('disabled',false);

                                e_st = 1;
			                    dojo.forEach(c_items, function(item, i){
			                        var id = store.getValue(item,'id');
		      	                    var username = store.getValue(item,'user');
                                    var inputWidget = dijit.byId('u_' + id);
                                    if (inputWidget && inputWidget.get('value') == '') {
                                        inputWidget.focus();
			                            inputWidget.set('value',username);
                                    }
                                    var status = store.getValue(item,'status');
                                    if (i == '0') { 
                                        st = status; 
                                    } else {
                                        if ( status != st ) { e_st = 0; }
                                    }
                                    var i = i + 1;
			                    });
    			                
			                    if (e_st) {
			                        if (st == 'active') { 
			                            dijit.byId('uManagerB_a').set('disabled','disabled');
			                            dijit.byId('uManagerB_ia').set('disabled',false);
			                        } else if (st == 'inactive') {
			                            dijit.byId('uManagerB_a').set('disabled',false);
			                            dijit.byId('uManagerB_ia').set('disabled','disabled');
			                        } else {
			                            dijit.byId('uManagerB_a').set('disabled',false);
			                            dijit.byId('uManagerB_ia').set('disabled',false);
			                        }  
			                    } else {
			                        dijit.byId('uManagerB_a').set('disabled',false);
			                        dijit.byId('uManagerB_ia').set('disabled',false);
			                    }
			                }
		                }, true);

		                uGrid.on('StyleRow',function(e) {        
                            domStyle.set(e.node.children[0].children[0].rows[1],'display','none');
                        }, true);
                    });

                } else {
                    noDataMessage = "<span class='dojoxGridNoData'>" + _uM_m11 + "</span>";
                    uGrid.showMessage(noDataMessage);
                }
            
                uGrid.canSort = function(){ return false }; 
                uGrid.startup();
                uGrid.resize();
                
                var handle = dojo.connect(uGrid, '_onFetchComplete', function(e) {
                    _uM_grid_loading = '0';   
                    dojo.disconnect(handle);
                });

                ready(function(){ fM_hidePL(); });	
                dijit.byId('managerB_undo').set('disabled','disabled');
            });
        });
    });
}


function uM_u_action() {

    require(['dojo/dom','dojo/query'], function(dom, query) {

        var uGrid = dijit.byId('usersGrid');

        var c_items = uGrid.selection.getSelected(); 
	    var usersData = new Array();
	    
        if (c_items.length) {
            dojo.forEach(c_items, function(item){
                var id = uGrid.store.getValue(item, 'id');
		        var username = uGrid.store.getValue(item, 'user');
		        var inputWidget = dijit.byId('u_' + id);
		        if (inputWidget) { var username = inputWidget.get('value'); } 
		        if (username == '') { var username = 'null'; }
		        var perm = uGrid.store.getValue(item, 'gen_perm');
		        usersData.push(id);
		        usersData.push(username);
		        usersData.push(perm);
	        });
	        usersData.join();
	        dom.byId('selUser').setAttribute('value',usersData.toString());
	        uM_u_doAction();
	        
         } else {
            action = dom.byId('userAction').getAttribute('value');
            if (action == 'managePerm') { uM_u_doAction(); };
         }
    });
}


function uM_u_doAction() {

    if (this._timeout) { 
        clearTimeout(this._timeout); 
    }
    
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {

	    uM_clearStatus();
        uM_showPL();

        // create a new delay before sending the request (i.e. reset the 500ms timer each time a key is pressed) 
        this._timeout = setTimeout(function(){ uM_u__doAction(); }, 500);  
    }); 
}


function uM_u__doAction() {

    require(['dojo/ready','dojo/dom','dojo/dom-style','dojo/keys','dojo/on','dojo/_base/xhr','dojo/_base/fx',
             'dojox/grid/DataGrid','dojox/data/QueryReadStore','dojo/query','dijit/Dialog','dojo/_base/json','dijit/Tooltip',
             'dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

        function(ready, dom, domStyle, keys, on, xhr, fx, DataGrid, QueryReadStore, query, dialog, json, Tooltip){
        
        ready(function(){ 

			var usersDialog = dijit.byId('usersDialog');
            if (usersDialog) { usersDialog.destroyRecursive(); }
		    
		    uGrid = dijit.byId('usersGrid');

            dom.byId('usersGrid').focus();
		    
		    action = dom.byId('userAction').getAttribute('value');
		    var activeUser = dom.byId('activeUser').getAttribute('value');

		    if (action == 'create') {
		    
		        xhr.post({
                    url: './../login/create',
                    postData: { 'what': 'users' },
                    handleAs: 'text',    
                    load: function(data) {
                    
                        uM_hidePL();
                    
                        var dlg = new dialog({ 
	                        id: 'usersDialog',
		                    'class': 'usersDialog',
		                    executeScripts: true, 
		                    refreshOnShow: true,
		                    content: data
	                    });
	                    
	                    dlg.startup();
	                    
	                    query('#usersDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr){    
                            var titleBar = "<span class='dijitIcon usersProfileIcon'></span><span class='dijitTitleName'>Users management</span>";
                            node.innerHTML = titleBar;
                        }); 

	                    on(dom.byId('loginButton'), 'click', function() {
	                    
	                        uM_dialogClearStatus();
				            uLR_showPL();
	                        
	                        var adminInput = dijit.byId('administrator');
                            if ( adminInput == null ) {
                                var command = 'create_admin';
                            } else {
	                            var checked = dijit.byId('administrator').get('checked');
		                        if (checked == false) {
		                            var command = 'create';
		                        } else {
		                            var command = 'create_admin';
		                        }
		                    }
		                    
	                        xhr.post({
                                url: './../login/' + command,
                                handleAs: 'json',
                                form: dom.byId('login'),
                                load: function(jsonData) {
                                    uM_XHRdialogRespond(jsonData, dlg);
                                }
                            });
	                    });
	                    
                        on(dom.byId('login'), 'keydown', function(e){
                            if (e.keyCode == keys.ENTER) {
                                dom.byId('loginButton').click();
                            }
                        });

                        on(dom.byId('loginButtonCancel'), 'click', function(){    
	                        dom.byId('userAction').setAttribute('value','');
	                        dlg.hide();
	                    });
	                 
	                    cu_dlgShow(dlg);
	                }
                });

		    } else if (action == 'managePerm') {

                var selUser = dom.byId('selUser').getAttribute('value');
                var id = selUser.split(',')[0];
		        var user = selUser.split(',')[1];
		        var perm = selUser.split(',')[2];
		        
		        var block = 0;
		        //if (perm == 'Administrator' && user != activeUser) {
		        //    var block = 1;
		        //}
		        
		        if (!block) {
                    xhr.post({
                        url: './../login/manage',
                        postData: { 'what': 'users', 'id': id, 'username': user},
                        handleAs: 'text',    
                        load: function(data) {

                            uM_hidePL();

                            var dlg = new dialog({ 
	                            id: 'usersDialog',
		                        'class': 'usersDialog',
		                        executeScripts: true, 
		                        refreshOnShow: true,
		                        content: data
	                        });
	                        
	                        var c_items = uGrid.selection.getSelected();
			                if (c_items.length == '1') {
	                            domStyle.set('userPermissionTable','display','');
			                    domStyle.set('userPagePermissionTable','display','');
			                    
			                    on(dom.byId('loginButton'), 'click', function() {
  	                                uM_u_genPerm();
  	                                uM_u_perm();
	                            });
			                    
			                } else {
			                    domStyle.set('userPermissionTable','display','none');
			                    domStyle.set('userPagePermissionTable','display','none');
			                    
			                    on(dom.byId('loginButton'), 'click', function() {
			                        uM_genPerm
  	                                uM_u_genPerm();
	                            });
			                }
  	                        dlg.startup();
  	                        
  	                        query('#usersDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr){    
                                var titleBar = "<span class='dijitIcon usersProfileIcon'></span><span class='dijitTitleName'>Users management</span>";
                                node.innerHTML = titleBar;
                            });

                            on(dom.byId('loginButtonCancel'), 'click', function() {
			                    dom.byId('userAction').setAttribute('value','');
	                            dlg.hide();
	                        });
	                        
			                setTimeout(function(){ cu_dlgShow(dlg); }, 200);
	                    }
                    });
                
                } else {
                    var msgError = '<b>' + user + '</b> ' + _uM_m5;
                    uM_XHRerror(msgError);
                } 

            } else if (action == 'password') {
            
                var selUser = dom.byId('selUser').getAttribute('value');

                var id = selUser.split(',')[0];
		        var user = selUser.split(',')[1];
		        var perm = selUser.split(',')[2];
		        
		        var block = 0;
		        //if (perm == 'Administrator' && user != activeUser) {
		        //    var block = 1;
		        //}

		        if (!block) {
		        
                    xhr.post({
                        url: './../login/change_password',
                        postData: { 'what': 'users', 'id': id, 'username': user},
                        handleAs: 'text',    
                        load: function(data) {
                    
                            uM_hidePL();
                        
                            if ((data.match(/opResult*/))) {
                                require(['dojo/_base/json'], function(json){
                                    var jsonData = json.fromJson(data);
                                    var msgError = jsonData.error.toString();
                                    uM_XHRerror(msgError);
                                });
                                
                            } else {

                                var dlg = new dialog({ 
	                                id: 'usersDialog',
		                            'class': 'usersDialog',
		                            executeScripts: true, 
		                            refreshOnShow: true,
		                            content: data
	                            });
	                            
	                            dlg.startup();
	                            
	                            query('#usersDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr){    
                                    var titleBar = "<span class='dijitIcon usersProfileIcon'></span><span class='dijitTitleName'>Users management</span>";
                                    node.innerHTML = titleBar;
                                });

	                            on(dom.byId('loginButton'), 'click', function() {
	                            
	                                uM_dialogClearStatus();
	                                uLR_showPL();

	                                var userAdmin = 0;
	                                if (dom.byId('convert_administrator')) {
	                                    var userAdmin = dom.byId('convert_administrator').getAttribute('value');
	                                } 

	                                if (userAdmin.toString() == '1') {
			                            uM_u_convAdmin();
			                        } else {

	                                    xhr.post({
                                            url: './../login/change_password',
                                            handleAs: 'json',
                                            form: dom.byId('login'),
                                            load: function(jsonData) {
                                    	        uM_XHRdialogRespond(jsonData, dlg);
                                            }
                                        });
                                    }
	                            });

                                on(dom.byId('login'), 'keydown', function(e){
                                    if (e.keyCode == keys.ENTER) {
                                        dom.byId('loginButton').click();
                                    }
                                });
                            
                                on(dom.byId('loginButtonCancel'), 'click', function(){
	                                dom.byId('userAction').setAttribute('value','');
	                                dlg.hide();
	                            }); 
	                        
	                            setTimeout(function(){ cu_dlgShow(dlg); },200);
	                        }
	                    }
                    });
                    
                } else {
                    var msgError = '<b>' + user + '</b> ' + _uM_m5;
                    uM_XHRerror(msgError); 
	            }

            } else if (action == 'delete') {

                var selUser = dom.byId('selUser').getAttribute('value'); 
		        var selUser_ = selUser.split(',');        

		        var block = 0;
		        
		        //for (var i=2; i<selUser_.length; i=i+3){
		        //    if (selUser_[i] == 'Administrator' && selUser_[i-1] != activeUser) {
		        //        var block = 1;
		        //        var user = selUser_[i-1]; 
		        //        var msgErr = '<b>' + user + '</b> ' + _uM_m5;
		        //        break
		        //    } 
		        //}

		        if (!block) {
		            var usersDataId = new Array();
		            for (var i=0; i<selUser_.length; i=i+3){
		                usersDataId.push(selUser_[i]);
		                usersDataId.push(selUser_[i]);
		            }
		            usersDataId.join();
		            var usersDataId = usersDataId.toString();
		        		    
		            xhr.post({
                        url: './../login/delete',
                        handleAs: 'json',
                        postData: { 'what': 'users', 'data': usersDataId, 'action': action },
                        load: function(jsonData) {
                            uM_XHRrespond('delete', jsonData);
		                }
                    });
                
                } else {
                    uM_XHRerror(msgErr); 
                } 
                
            } else if (action == 'activate' || action == 'inactivate') {
                var selUser = dom.byId('selUser').getAttribute('value'); 
		        var selUser_ = selUser.split(',');        

		        var block = 0;
		        var msgErrData = new Array();
		        for (var i=1; i<selUser_.length; i=i+3){
		            if (action == 'activate') {
		                if (selUser_[i] == 'null') { 
		                    var block = 1;
		                    var msgErr = _uM_m6;
                            msgErrData.push(selUser_[i-1]);
                            msgErrData.push(selUser_[i]);
                            msgErrData.push(msgErr);
		                }
		            } else {
		                //if ( selUser_[i+1] == 'Administrator' && selUser_[i] != activeUser ) {
		                //    var block = 1;
		                //    var user = selUser_[i]; 
		                //    var msgErr = '<b>' + user + '</b> ' + _uM_m5;
		                //    break
		                //} 
		            }
		        }

		        if (!block) {
		            var usersData = new Array();
		            for (var i=0; i<selUser_.length; i=i+3){
		                usersData.push(selUser_[i]);
		                usersData.push(selUser_[i]);
		                usersData.push(selUser_[i+1]);
		            }
		            usersData.join();
		            var usersData = usersData.toString();
		            xhr.post({
                        url: './../login/' + action,
                        handleAs: 'json',
                        postData: { 'what': 'users', 'data': usersData, 'action': action },
                        load: function(jsonData) {
                            uM_XHRrespond(action, jsonData);
		                }
                    });
                    
                } else {
                    if (action == 'activate') {
			            uM_XHRwarning(msgErrData.join());
			        } else {
			            uM_XHRerror(msgErr);
			        }
                }
	        }
	        clearTimeout(this._timeout); 
	    });
	});
}


function uM_u_convAdmin() {

    require(['dojo/dom','dojo/dom-style','dojox/data/QueryReadStore','dojo/_base/xhr'], 
    
    function(dom, domStyle, QueryReadStore, xhr){

	    var selUser = dom.byId('selUser').getAttribute('value');
	    var user = selUser.split(',')[1];

	    xhr.post({
             url: './../login/manage_admin',
             handleAs: 'json',
             postData: {'username': user, 'action': action },
             load: function(jsonData) {
                 uM_XHRdialogRespond(jsonData, dijit.byId('usersDialog'));
             }
        });
    });
}


function uM_u_genPerm() {

    require(['dojo/dom','dojo/dom-style','dojo/_base/xhr'], 
    
    function(dom, domStyle, xhr){
    
        uM_dialogClearStatus();
        uLR_showPL();

        var userPerm = dijit.byId('permGenSelection').get('value');    
              
	    xhr.post({
             url: './../login/manage_general',
             handleAs: 'json',
             postData: {'perm': userPerm, 'action': action },
             load: function(jsonData) {
                 uM_XHRdialogRespond(jsonData, dijit.byId('usersDialog'));
             }
        });
    });
}

	
function uM_u_perm() {

    require(['dojo/dom','dojo/dom-style','dojo/_base/xhr'], 
    
    function(dom, domStyle, xhr){
    
        uM_dialogClearStatus();
        uLR_showPL();
    
	    var selUser = dom.byId('selUser').getAttribute('value');
	    var user = selUser.split(',')[1];
        var userPerm = dijit.byId('userPermSelection').get('value');    
              
	    xhr.post({
             url: './../login/manage_username',
             handleAs: 'json',
             postData: {'username': user, 'perm': userPerm, 'action': action },
             load: function(jsonData) {
                 uM_XHRdialogRespond(jsonData, dijit.byId('usersDialog'));
             }
        });
    });
}


function uM_u_permPage() {

    require(['dojo/dom','dojo/dom-style','dojo/_base/xhr'], 
    
    function(dom, domStyle, xhr){
    
        uM_dialogClearStatus();
        uLR_showPL();
    
	    var selUser = dom.byId('selUser').getAttribute('value');
	    var user = selUser.split(',')[1];
        var userPage = dijit.byId('userPageSelection').get('value'); 
        var userPermPage = dijit.byId('userPermPageSelection').get('value');   
               
	    xhr.post({
             url: './../login/manage_username_page',
             handleAs: 'json',
             postData: {'username': user, 'userpage': userPage, 'perm': userPermPage, 'action': action },
             load: function(jsonData) {
             
                var msg = jsonData.msg.toString();
                uM_showStatus('true', text)

                uM_XHRdialogRespond(jsonData, '');
             }
        });
    });
}


function uM_XHRrespond(action, jsonData) {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
    
        if (_selection == 'users') {
            var _Grid = dijit.byId('usersGrid');
            dom.byId('userAction').setAttribute('value','');
            dom.byId('selUser').setAttribute('value','');
        } else {
            var _Grid = dijit.byId('certsGrid');
            dom.byId('certAction').setAttribute('value','');
            dom.byId('selCert').setAttribute('value','');
        } 

        var opResult = jsonData.opResult.toString();

	    if (opResult.match(/^ERROR/)) {
            var msgError = jsonData.error.toString();
            uM_XHRerror(msgError); 
                                
	    } else {
	        var msg = jsonData.msg.toString();
            var msgError = jsonData.msgErr.toString();
	        if (action == 'delete') {
		        uM_doSearch();
		        
		    } else {
		        uM_gridUpdate();
		    }
            uM_showStatus('true', msg);
            
            uM_updateCntrlTabs(action);

            if (msgError != '') {
                if (action == 'activate') {
                    if (msg != '') {
                        var handle = dojo.connect(_Grid, '_onFetchComplete', function(e) {
                            setTimeout(function(){ uM_XHRwarning(msgError); }, 200); 
                            dojo.disconnect(handle);
                        });   
                    } else {
                        uM_XHRwarning(msgError);
                    }
                    
                } else {
                    var msgErr_ = msgError.split(',');
                    var errMsg = msgErr_[2];
                    uM_XHRerror(errMsg); 
                }
            } 
        }
    });
}


function uM_updateCntrlTabs(action) {

    require(['dojo/dom'], function(dom) {

        if (_selection == 'certificates' || _selection == 'profile') {
		    dom.byId('usersSelectionControl').innerHTML = 'reload';
		            
		} else if (_selection == 'users') {
		    if (dom.byId('certificateSelectionControl').innerHTML == 'loaded') {
		        dom.byId('certificateSelectionControl').innerHTML = 'reload';
		    }

		    if (dom.byId('usersProfileSelectionControl') && dom.byId('usersProfileSelectionControl').innerHTML == 'loaded') {
		        if (action == 'create' || action == 'delete') {
		            dom.byId('usersProfileSelectionControl').innerHTML = 'reload';
		        }
		    }
		}
    }); 
}


function uM_XHRwarning(msgErr) {

    require(['dojo/dom','dojo/dom-class','dijit/Tooltip','dojox/fx/scroll'], function(dom, domClass, Tooltip) {
    
        if (_selection == 'users') {
            var _prefix = 'u_';
            var _Grid = dijit.byId('usersGrid');
        } else {
            var _prefix = 'c_';
            var _Grid = dijit.byId('certsGrid');
        }
    
        uM_hidePL();

        var msgErr_ = msgErr.split(',');
        block = 0;
        for(var i=0; i<msgErr_.length; i=i+3) {
            var errId = msgErr_[i];
            var errUsername = msgErr_[i+1];
            if (errUsername == 'null') { var errUsername = ''; }
            var errMsg = msgErr_[i+2];
            _Grid.store.fetchItemByIdentity({
                identity: errId,
                onItem : function(item, request) {
                    _Grid.selection.addToSelection(_Grid.getItemIndex(item));
                    var id = _Grid.store.getValue(item,'id');
                    var iTUn = _prefix + id;
                    var inputWidget = dijit.byId(iTUn);  
                    if (inputWidget) {
                        inputWidget.set('value',errUsername);
                        setTimeout(function(){
                            domClass.add('widget_' + iTUn, 'dijitTextBoxError dijitValidationTextBoxError');
                            dijit.byId('t_' + iTUn).set('label',errMsg); 
                            if (block == 0) {

                                dojox.fx.smoothScroll({
                                    node: 'usersGrid',
                                    win: window,
                                    duration: 500
                                }).play(); 

                                setTimeout(function(){ Tooltip.show(errMsg, 'widget_' + iTUn); }, 700);
                                block = 1;
                            }
                        }, 150); 
                    } 
                }
            });
        }
    });
}

function uM_XHRdialogRespond(jsonData, dlg) {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        if (_selection == 'users') {
            dom.byId('userAction').setAttribute('value','');
            dom.byId('selUser').setAttribute('value','');
        } else {
            dom.byId('certAction').setAttribute('value','');
            dom.byId('selCert').setAttribute('value','');
        } 

        var opResult = jsonData.opResult.toString();
    
        uM_dialogClearStatus();
        uLR_showPL();
                                
	    if (opResult.match(/^ERROR/)) {
	    
	        var msgError = jsonData.error.toString();
            uM_dialogShowStatus('false', msgError);
                                        
	    } else {
		    uM_gridUpdate();
	        if (dijit.byId(dlg)){ dlg.hide(); }

		    var msg = jsonData.msg.toString();
            uM_showStatus('true', msg);
            
            uM_updateCntrlTabs(action);
	    }
	});
}


function uM_XHRerror(msgError) {

    require(['dojo/dom','dojo/query','dijit/Dialog','dojo/_base/fx'], function(dom, query, dialog, fx) {
    
        if (_selection == 'users') {
            dom.byId('userAction').setAttribute('value','');
            dom.byId('selUser').setAttribute('value','');
        } else {
            dom.byId('certAction').setAttribute('value','');
            dom.byId('selCert').setAttribute('value','');
        } 
    
        uM_hidePL();
        
        var errorDialog = dijit.byId('formErrorDialog');

        if (msgError != '') {
            dom.byId('errorDialogStatus').innerHTML = msgError;
        } else {
            dom.byId('errorDialogStatus').innerHTML = 'There has been an unexpected error';
        }

	    query('#formErrorDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr) {    
            var titleBar = "<span class='dijitIconError'></span><span class='dijitTitleName'>Error</span>";
            node.innerHTML = titleBar;
        });

	    fx.fadeIn({
            node: 'formErrorDialog',
            duration: 300,
            onEnd: function() { cu_dlgShow(errorDialog); }
        }).play();
    });
}

function uM_AutoInit(selection) {

    require(['dojo/ready','dojo/dom'], function(ready, dom) {

	    ready(function() {
	        _uM_grid_loading = '0';
            uM_select(selection);
        });
    });
}


function uM_select(selection) {

    require(['dojo/dom','dojo/dom-class','dojo/dom-style','dojo/dom-construct','dojox/grid/DataGrid','dojox/data/QueryReadStore',
             'dojo/_base/xhr','dojo/query','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

        function(dom, domClass, domStyle, domConstruct, DataGrid, QueryReadStore, xhr, query) { 
        
        if (_uM_grid_loading == '1') { return }

        _selection = selection;

        uM_clearStatus();
	    uM_hidePL();

        clearTimeout(this._timeout); 
        
        if (_selection == 'users') {
        
            domStyle.set('usersTitle','display','');
            domStyle.set('profileTitle','display','none');
            domStyle.set('certsTitle','display','none');
            domStyle.set('sigsTitle','display','none');

            domClass.remove('usersSelection', 'pf_sh_c');
            domClass.add('usersProfileSelection', 'pf_sh_c');
            domClass.add('certificateSelection', 'pf_sh_c');
            domClass.add('signatureSelection', 'pf_sh_c');

            domStyle.set('usersManagerPane','display','');
            domStyle.set('usersProfileManagerPane','display','none');
	        domStyle.set('certsManagerPane','display','none');
	        domStyle.set('sigsManagerPane','display','none');
	        
	        domStyle.set('usersGrid','display','');
            domStyle.set('usersProfileGrid','display','none');
	        domStyle.set('certsGrid','display','none');
	        domStyle.set('sigsGrid','display','none');
	        
	        dijit.byId('filter_by').removeOption(dijit.byId('filter_by').getOptions());
            dijit.byId('filter_by').addOption({label:'Status',value:'status',selected:true});
            dijit.byId('filter_by').addOption({label:'Type',value:'type'});
            dijit.byId('filter_by').addOption({label:'Group',value:'group'});
            dijit.byId('filter_by').addOption({label:'Certificate',value:'certificate'});
            dijit.byId('filter_by').addOption({label:'Password',value:'password'});
            
            query('.gridUsernameWidget').forEach(function(node, index, arr){
		        var widget_id = node.getAttribute('id');
		        var id = widget_id.replace(/widget_/, '');
		        dijit.byId(id).destroyRecursive();
	        });

	        domStyle.set('usersGrid', 'height', '35em');

            var uMCntrl = dom.byId('usersSelectionControl').innerHTML;

            if (uMCntrl == 'init') {
                uM_u_GridInit();
                dom.byId('usersSelectionControl').innerHTML = 'loaded';
                
            } else if (uMCntrl == 'reload') {
                uM_u_GridUpdate();
                dom.byId('usersSelectionControl').innerHTML = 'loaded';
                
            } else {
                uM_filterBy('init');
            }

        } else if (_selection == 'profile') {

            domStyle.set('usersTitle','display','none');
            domStyle.set('profileTitle','display','');
            domStyle.set('certsTitle','display','none');
            domStyle.set('sigsTitle','display','none');

            domClass.add('usersSelection', 'pf_sh_c');
            domClass.remove('usersProfileSelection', 'pf_sh_c');
            domClass.add('certificateSelection', 'pf_sh_c');
            domClass.add('signatureSelection', 'pf_sh_c');

            domStyle.set('usersManagerPane','display','none');
            domStyle.set('usersProfileManagerPane','display','');
	        domStyle.set('certsManagerPane','display','none');
	        domStyle.set('sigsManagerPane','display','none');

	        domStyle.set('usersGrid','display','none');
            domStyle.set('usersProfileGrid','display','');
	        domStyle.set('certsGrid','display','none');
	        domStyle.set('sigsGrid','display','none');

            dijit.byId('filter_by').removeOption(dijit.byId('filter_by').getOptions());
            dijit.byId('filter_by').addOption({label:'Group',value:'group'});
            
            query('.gridUsernameWidget').forEach(function(node, index, arr){
		        var widget_id = node.getAttribute('id');
		        var id = widget_id.replace(/widget_/, '');
		        dijit.byId(id).destroyRecursive();
	        });

	        domStyle.set('usersProfileGrid', 'height', '35em');
	        
	        var uMCntrl = dom.byId('usersProfileSelectionControl').innerHTML;
	        
	        if (uMCntrl == 'init') {
	            uM_p_GridInit();
	            dom.byId('usersProfileSelectionControl').innerHTML = 'loaded';
	            
	        } else if (uMCntrl == 'reload') {
                uM_p_GridUpdate();
                dom.byId('usersProfileSelectionControl').innerHTML = 'loaded';

	        } else {
	            uM_filterBy('init');
	        }
            
        } else if (_selection == 'certificates') {

            domStyle.set('usersTitle','display','none');
            domStyle.set('profileTitle','display','none');
            domStyle.set('certsTitle','display','');
            domStyle.set('sigsTitle','display','none');
            
            domClass.add('usersSelection', 'pf_sh_c');
            domClass.add('usersProfileSelection', 'pf_sh_c');
            domClass.remove('certificateSelection', 'pf_sh_c');
            domClass.add('signatureSelection', 'pf_sh_c');
            
            domStyle.set('usersManagerPane','display','none');
            domStyle.set('usersProfileManagerPane','display','none');
	        domStyle.set('certsManagerPane','display','');
	        domStyle.set('sigsManagerPane','display','none');
	        
	        domStyle.set('usersGrid','display','none');
            domStyle.set('usersProfileGrid','display','none');
	        domStyle.set('certsGrid','display','');
	        domStyle.set('sigsGrid','display','none');
	        
	        dijit.byId('filter_by').removeOption(dijit.byId('filter_by').getOptions());
            dijit.byId('filter_by').addOption({label:'Status',value:'status',selected:true});
            
            query('.gridUsernameWidget').forEach(function(node, index, arr){
		        var widget_id = node.getAttribute('id');
		        var id = widget_id.replace(/widget_/, '');
		        dijit.byId(id).destroyRecursive();
	        });

		    domStyle.set('certsGrid', 'height', '35em');

	        var uMCntrl = dom.byId('certificateSelectionControl').innerHTML;

	        if (!dijit.byId('certsGrid') && uMCntrl == 'init') {
	            uM_c_GridInit();
	            dom.byId('certificateSelectionControl').innerHTML = 'loaded';
	            
	        } else if (uMCntrl == 'reload') {
                uM_c_GridUpdate();
                dom.byId('certificateSelectionControl').innerHTML = 'loaded';
	            
	        } else {
	            uM_filterBy('init'); 
	        }
        
        } else if (_selection == 'signatures') {
        
            domStyle.set('usersTitle','display','none');
            domStyle.set('profileTitle','display','none');
            domStyle.set('certsTitle','display','none');
            domStyle.set('sigsTitle','display','');
            
            domClass.add('usersSelection', 'pf_sh_c');
            domClass.add('usersProfileSelection', 'pf_sh_c');
            domClass.add('certificateSelection', 'pf_sh_c');
            domClass.remove('signatureSelection', 'pf_sh_c');
            
            domStyle.set('usersManagerPane','display','none');
            domStyle.set('usersProfileManagerPane','display','none');
	        domStyle.set('certsManagerPane','display','none');
	        domStyle.set('sigsManagerPane','display','');
	        
	        domStyle.set('usersGrid','display','none');
            domStyle.set('usersProfileGrid','display','none');
	        domStyle.set('certsGrid','display','none');
	        domStyle.set('sigsGrid','display','');
	        
	        dijit.byId('filter_by').removeOption(dijit.byId('filter_by').getOptions());
            dijit.byId('filter_by').addOption({label:'Status',value:'status',selected:true});
            
            query('.gridUsernameWidget').forEach(function(node, index, arr){
		        var widget_id = node.getAttribute('id');
		        var id = widget_id.replace(/widget_/, '');
		        dijit.byId(id).destroyRecursive();
	        });

	        domStyle.set('sigsGrid', 'height', '35em');

	        var uMCntrl = dom.byId('signatureSelectionControl').innerHTML;

	        if (!dijit.byId('sigsGrid') && uMCntrl == 'init') {
	            uM_s_GridInit();
	            dom.byId('signatureSelectionControl').innerHTML = 'loaded';
	            
	        } else {
	            uM_filterBy('init');
	        }
        }
    });
}


function uM_checkFilter() {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle){
    
        var value = dijit.byId('filter_check').get('checked');

        if (value == true) {
            domStyle.set('filterLabelRegion','opacity','1');
            domStyle.set('filterSelect1','opacity','1');
	        domStyle.set('filterSelect2','opacity','1');
            dijit.byId('filter_by').set('disabled',false);
            dijit.byId('filter_what').set('disabled',false);
            
        } else {
            domStyle.set('filterLabelRegion','opacity','0.5');
            domStyle.set('filterSelect1','opacity','0.6');
	        domStyle.set('filterSelect2','opacity','0.6');
            dijit.byId('filter_by').set('value','status');
            dijit.byId('filter_by').set('disabled','disabled');
            dijit.byId('filter_what').set('disabled','disabled');
            uM_filterBy('load');
        }                       
    });
}


function uM_filterBy(mode) {

    require(['dojo/dom','dojo/_base/xhr','dojo/query'], 

    function(dom, xhr, query){
    
        dijit.byId('filter_what').removeOption(dijit.byId('filter_what').getOptions());

        if ( mode == 'load' && dijit.byId('filter_check').get('checked') == true) {
            query('#filter_what span.dijitSelectLabel').forEach(function(node, index, arr){
	            node.innerHTML = "<i style='font-size:8pt;color:#084B8A'>" + _uM_m10 + "</i>";
            });
        } 

        if (_selection == 'users') {
            var url = '.';
        } else {
            var url = './' + _selection;
        }

        var filterBy = dijit.byId('filter_by').get('value');
		    
	    xhr.post({
            url: url + '/filterOptions',
            postData: { 'filter_by': filterBy, 'action': 'filter' },
            handleAs: 'json',    
            load: function(jsonData) {

                if (jsonData.optionsList.length > 0) {
                    dijit.byId('filter_what').removeOption(dijit.byId('filter_what').getOptions());
                    for(var i=0; i<jsonData.optionsList.length; i++) {
                        var option = jsonData.optionsList[i];
                        dijit.byId('filter_what').addOption(option);
                    }

                } else {
                    query('#filter_what span.dijitSelectLabel').forEach(function(node, index, arr){
	                    node.innerHTML = '';
                    });
                }
                
                if (mode == 'load') { uM_filter(); }
            }
        });
    });   
}


function uM_filterWhat() {
    uM_filter();
}


function uM_filter() {

    if (this._timeout) { 
        clearTimeout(this._timeout); 
    }

    if (_selection == 'users') {
        var _Grid_id = 'usersGrid';
        var _Grid = dijit.byId('usersGrid');
    } else if (_selection == 'profile') {
        var _Grid_id = 'usersProfileGrid';
        var _Grid = dijit.byId('usersProfileGrid');
    } else if (_selection == 'certificates') {
        var _Grid_id = 'certsGrid';
        var _Grid = dijit.byId('certsGrid');
    } else {
        var _Grid_id = 'sigsGrid';
        var _Grid = dijit.byId('sigsGrid');
    }

    require(['dojo/ready', 'dojo/dom','dojo/dom-style','dojo/query'], function(ready, dom, domStyle, query) {
    
        ready(function(){ 
            query('#' + _Grid_id + ' .dojoxGridHeader').forEach(function(node, index, arr){      
                domStyle.set(node, 'opacity', '0'); 
            });

            loadingMessage = "<span class='dojoxGridLoading'>" + _uM_m10 + "</span>";
            _Grid.showMessage(loadingMessage);
    
            // create a new delay before sending the request (i.e. reset the 200ms timer each time a key is pressed) 
            this._timeout = setTimeout(function(){ uM_doSearch(); }, 200);
        });
    }); 
}

function uM_search() {

    if (this._timeout) { 
        clearTimeout(this._timeout); 
    }
    
    require(['dojo/dom','dojo/dom-style','dojo/query'], function(dom, domStyle, query) {

        if (_selection == 'users') {
            var _Grid_id = 'usersGrid';
        } else if (_selection == 'profile') {
            var _Grid_id = 'usersProfileGrid';
        } else if (_selection == 'certificates') {
            var _Grid_id = 'certsGrid';
        } else {
            var _Grid_id = 'sigsGrid';
        }

        var _Grid = dijit.byId(_Grid_id);

        var toSearch = dijit.byId('to_search').get('value');
        if (toSearch == _toSearch) { return }

        query('#' + _Grid_id + ' .dojoxGridHeader').forEach(function(node, index, arr){      
            domStyle.set(node, 'opacity', '0'); 
        });

        query('#' + _Grid_id + ' .dojoxGridScrollbox').forEach(function(node, index, arr){      
            domStyle.set(node, 'display', 'none'); 
        });

        loadingMessage = "<span class='dojoxGridLoading'>Loading...</span>";
        _Grid.showMessage(loadingMessage);

        // create a new delay before sending the request (i.e. reset the 500ms timer each time a key is pressed) 
        this._timeout = setTimeout(function(){ uM_doSearch() }, 500);
    }); 
}


function uM_doSearch() {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojox/grid/DataGrid','dojox/data/QueryReadStore',
             'dojo/_base/xhr','dojo/query','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

    function(dom, domStyle, domClass, DataGrid, QueryReadStore, xhr, query){

        uM_clearStatus();
        clearTimeout(this._timeout);

        if (_selection == 'users') {
            var url = '.';
            var _Grid_id = 'usersGrid';
        } else if (_selection == 'profile') {
            var url = _selection;
            var _Grid_id = 'usersProfileGrid';
        } else if (_selection == 'certificates') {
            var url = _selection;
            var _Grid_id = 'certsGrid';
        } else {
            var url = _selection;
            var _Grid_id = 'sigsGrid';
        }

        var _Grid = dijit.byId(_Grid_id);

        var toSearch = dijit.byId('to_search').get('value');  
        _toSearch = toSearch; 
        if (toSearch == '') { _Grid.selection.clear(); }

        var filterBy = 'status';
        var filterWhat = '';
        if (dijit.byId('filter_check').get('checked') == true) {
            var filterBy = dijit.byId('filter_by').get('value');
            if (dijit.byId('filter_what').get('value') != 'all') {
                var filterWhat = dijit.byId('filter_what').get('value');
            }
        }

        xhr.post({
            url: url + '/loadDatabase/check',
	        handleAs: 'json',
	        preventCache: true,
            content: { query: toSearch + '*', filter_by: filterBy, filter_what: filterWhat }

        }).then(function(jsonData){

                var _Grid = dijit.byId(_Grid_id);

	            var numRows = jsonData.numRows.toString();
                if (_selection != 'profile') {
                    var uM_U_nt = jsonData.uM_U_nt.toString();
                    var uM_C_nt = jsonData.uM_C_nt.toString();
                    var uM_S_nt = jsonData.uM_S_nt.toString();

                    uM_notifications(uM_U_nt, uM_C_nt, uM_S_nt);
                }

            if (numRows != '0') {
                _Grid.setQuery({query: toSearch + '*', filter_by: filterBy, filter_what: filterWhat});
                userStore = new QueryReadStore({
                    url: './' + _selection + '/loadDatabase/',
	                requestMethod: 'post'  
                });
                
                query('#' + _Grid_id + ' .dojoxGridHeader').forEach(function(node, index, arr){    
                    domStyle.set(node, 'opacity', '1'); 
                });

            } else {
                if (dijit.byId('filter_check').get('checked') == true || toSearch != '') {
                    noDataMessage = "<span class='dojoxGridNoData'>" + _uM_m15 + "</span>";
                } else {
                    if (_selection == 'users') {
                        var msg = _uM_m11;
                    } else if (_selection == 'profile') {
                        var msg = _uM_m12;
                    } else if (_selection == 'certificates') {
                        var msg = _uM_m13;
                    } else if (_selection == 'signatures') {
                        var msg = _uM_m14;
                    } else {
                        var msg = 'No items in database';
                    }   
                    noDataMessage = "<span class='dojoxGridNoData'>" + msg + "</span>";
                }
                _Grid.showMessage(noDataMessage);
            }
             
            query('#' + _Grid_id + ' .dojoxGridScrollbox').forEach(function(node, index, arr){  
                domStyle.set(node, 'display', ''); 
            });      
        });
    });    
}


function uM_u_GridUpdate() {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojox/grid/DataGrid','dojox/data/QueryReadStore',
             'dojo/_base/xhr','dojo/query','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

    function(dom, domStyle, domClass, DataGrid, QueryReadStore, xhr, query) {
    
        var _Grid = dijit.byId('usersGrid');
    
        _Grid.setQuery({query: '*', filter_by: 'status', filter_what: ''});

        userStore = new QueryReadStore({
            url: './users/loadDatabase/',
	        requestMethod: 'post'  
        });
    });
}


function uM_p_GridUpdate() {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojox/grid/DataGrid','dojox/data/QueryReadStore',
             'dojo/_base/xhr','dojo/query','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

    function(dom, domStyle, domClass, DataGrid, QueryReadStore, xhr, query) {
    
        var _Grid = dijit.byId('usersProfileGrid');
    
        _Grid.setQuery({query: '*', filter_by: 'status', filter_what: ''});

        userStore = new QueryReadStore({
            url: './profile/loadDatabase/',
	        requestMethod: 'post'  
        });
    });
}


function uM_gridUpdate() {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojox/grid/DataGrid','dojox/data/QueryReadStore',
             'dojo/_base/xhr','dojo/query','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

    function(dom, domStyle, domClass, DataGrid, QueryReadStore, xhr, query) {
        
        uM_clearStatus();
        clearTimeout(this._timeout);

        if (_selection == 'users') {
            var url = _selection;
            var _Grid_id = 'usersGrid';
        } else if (_selection == 'profile') {
            var url = 'users/profile';
            var _Grid_id = 'usersProfileGrid';
        } else if (_selection == 'certificates') {
            var url = _selection;
            var _Grid_id = 'certsGrid';
        } else {
            var url = _selection;
            var _Grid_id = 'sigsGrid';
        }

        var _Grid = dijit.byId(_Grid_id);

        var filterBy = 'status';
        var filterWhat = '';
        if (dijit.byId('filter_check').get('checked') == true) {
            var filterBy = dijit.byId('filter_by').get('value');
            if (dijit.byId('filter_what').get('value') != 'all') {
                var filterWhat = dijit.byId('filter_what').get('value');
            }
        }

        var toSearch = dijit.byId('to_search').get('value');  
        _toSearch = toSearch; 
        if (toSearch == '') { _Grid.selection.clear(); }
        
        _Grid.setQuery({query: toSearch + '*', filter_by: filterBy, filter_what: filterWhat});
        userStore = new QueryReadStore({
            url: './' + _selection + '/loadDatabase/',
	        requestMethod: 'post'  
        });
                
        query('#' + _Grid_id + ' .dojoxGridHeader').forEach(function(node, index, arr){      
            domStyle.set(node, 'opacity', '1'); 
        });  
        
        query('#' + _Grid_id + ' .dojoxGridScrollbox').forEach(function(node, index, arr){      
            domStyle.set(node, 'display', ''); 
        });
    });
}


function uM_notifications(uM_U_nt, uM_C_nt, uM_S_nt) {
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
	    dom.byId('users_nCount').innerHTML = uM_U_nt;
        if ( uM_U_nt == '0') { domStyle.set('users_nCount', 'visibility', 'hidden'); }
	    dom.byId('certs_nCount').innerHTML = uM_C_nt;
	    if ( uM_C_nt == '0') { domStyle.set('certs_nCount', 'visibility', 'hidden'); }
        dom.byId('sigs_nCount').innerHTML = uM_S_nt;
	    if ( uM_S_nt == '0') { domStyle.set('sigs_nCount', 'visibility', 'hidden'); }
    });
}



function usersHovered() {
    require(['dojo/dom','dojo/dom-class'], function(dom, domClass) {
        domClass.add('loginMenuUsers', 'dijitMenuItemHover dijitHover');
        cu_fadeQuickIn('usersIcon');
        cu_fadeQuickIn('usersText');
    });
}


function usersUnHovered() {
    require(['dojo/dom','dojo/dom-style','dojo/dom-class'], function(dom, domStyle, domClass) {
        domClass.remove('loginMenuUsers', 'dijitMenuItemHover dijitHover');
        domStyle.set('usersIcon', 'opacity', '');
        domStyle.set('usersText', 'opacity', '');
        if (dojo.isIE && (dojo.isIE <= 8)) {
            dom.byId('usersIcon').removeAttribute('style');
            dom.byId('usersText').removeAttribute('style');
        }
    });
}


function searchUsersClear() { 
    dijit.byId('to_search').reset(); 
}


function searchUsersHovered() {
    require(['dojo/dom','dojo/dom-style','dijit/focus'], function(dom, domStyle){
        domStyle.set('usersManagerSearchInput', 'border', '1px solid #769DC0');
        var id = document.activeElement.getAttribute('id');
        if (id == 'to_search') {
            domStyle.set('usersManagerSearchInput', 'border', '1px solid #B5BCC7');
        }
    });
}


function searchUsersUnHovered() {
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle){
        domStyle.set('usersManagerSearchInput', 'border', '1px solid #B5BCC7');
    });
}


function formsHovered() {
    require(['dojo/dom','dojo/dom-class'], function(dom, domClass) {
        domClass.add('loginMenuForms', 'dijitMenuItemHover dijitHover');
        cu_fadeQuickIn('formsIcon');
        cu_fadeQuickIn('formsText');
    });
}


function formsUnHovered() {
    require(['dojo/dom','dojo/dom-style','dojo/dom-class'], function(dom, domStyle, domClass) {
        domClass.remove('loginMenuForms', 'dijitMenuItemHover dijitHover');
        domStyle.set('formsIcon', 'opacity', '');
        domStyle.set('formsText', 'opacity', '');
        if (dojo.isIE && (dojo.isIE <= 8)) {
            dom.byId('formsIcon').removeAttribute('style');
            dom.byId('formsText').removeAttribute('style');
        }
    });
}


function uM_certDialog(event, id) {

    event.stopPropagation();

    require(['dojo/dom','dojo/dom-style','dojo/on','dojo/io/iframe','dojo/query','dijit/Dialog','dojo/_base/fx'], 
    
        function(dom, domStyle, on, ioIframe, query, dialog, fx){

        uM_clearStatus();
        uM_showPL();

        if (_selection == 'users' || _selection == 'certificates') {
            var _url = 'certificates';
            var what = 'Certificate';
        } else {
            var _url = 'signatures';
            var what = 'Signature';
        }

        ioIframe.send({
	        url: './' + _url + '/view',
	        handleAs: 'html',
	        preventCache: true,
	        content: { id: id },
	        load: function(data) {

                var certsDialog = dijit.byId('certsDialog');
                if (certsDialog) { certsDialog.destroyRecursive(); }

                data = data.body.innerHTML;
                var ldata = data.split('-*/*-');

                if ( ldata[0] == 'OK' ) {
                
                    var dlg = new dialog({ 
		                id: 'certsDialog',
		                'class': 'certsDialog',
                        executeScripts: true,
                        scriptHasHooks: true,
                        content: ldata[1]
	                });
	                
	                var lstatus = ldata[2];
	                
	                if (lstatus == 'active') {
                        var print = what + ' active';
                        var src = './../int/js/custom/images/true.png';
                    } else if (lstatus == 'revoked') {
                        var print = what + ' revoked';
                        var src = './../int/js/custom/images/false.png';
                    } else {
                        var print = what + ' pending to validate';
                        var src = './../int/js/custom/images/new.png';
                    }
                   
                    var icon = "<img width='14' height='14' src='" + src + "'></img>";
                    dom.byId('certD_val').innerHTML = "<table><td class='certInfoStatus'>" + print + "</td><td>" + icon + "</td></table>";

                    var lexp = ldata[3].split(';');
                
                    if ( lexp[0] == 'expired' ) {
                        var exp_cert_id = lexp[1];
                        var exp_date = lexp[2];
                        var exp_cert_node = 'certD_id_' + lexp[1];
                        var exp_cert_name = dom.byId(exp_cert_node).innerHTML;
                        var exp_text1 = '<span>Certificate <b>' + exp_cert_name + '</b></span>';
                        var exp_text2 = "<span style='color:red;font-weight:bold'> expired on " + exp_date + "</span>";
                        dom.byId('certD_exp').innerHTML = exp_text1 + ' ' + exp_text2;
                    }

                    query('#certsDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr){    
                        var titleBar = "<span class='dijitIcon certsProfileIcon'></span><span class='dijitTitleName'>" + _uM_m7 + "</span>";
                        node.innerHTML = titleBar;
                    });

	                on(dom.byId('certButtonClose'), 'click', function(){
	                    dlg.hide();
			        });
			        
			        dlg.startup();
	                uM_hidePL();
	                cu_dlgShow(dlg);

                } else {
                
                    var msgError = ldata[1];
                    var dlg = dijit.byId('formErrorDialog');
                    dom.byId('errorDialogStatus').innerHTML = msgError;
		            fx.fadeIn({
                        node: 'formErrorDialog',
                        duration: 200,
                        onEnd: function(){ 
                            cu_dlgShow(dlg);
                            uM_hidePL();
                        }
                    }).play();
                } 
	        }
        });
    });
}


function uM_inputTextUsernameFormat(username, id) {

    if (_selection == 'users') {
        var _Grid = dijit.byId('usersGrid');
    } else {
        var _Grid = dijit.byId('certsGrid');
    } 

    var item = _Grid.getItem(id);
    var id_ = _Grid.store.getValue(item, 'id');
                        
    if (_selection == 'users') {
        var iTUn = 'u_' + id_;
    } else {
        var iTUn = 'c_' + id_;
    } 

    var inputWidget = dijit.byId(iTUn);

	if (_Grid._isLoaded) {
	    isSelected = _Grid.selection.isSelected(id);
	    if (isSelected) {
	        var item = _Grid.getItem(id);
	        var status = _Grid.store.getValue(item,'status');
		    if (status != 'active') {
		        if (!inputWidget) {      
				    var inputWidget = new dijit.form.ValidationTextBox({
				        id: iTUn,
					    name: iTUn,
					    onKeyUp: uM_usernameWidgetUpdate,
					    onChange: uM_usernameWidgetUpdate,
					    'class': 'gridUsernameWidget'
				    });
				}
				if (username == '') {
				    require(['dijit/Tooltip'], function(Tooltip){
				        var tooltip = dijit.byId('t_' + iTUn);
                        if (!tooltip) {
                            new Tooltip({
                                id: 't_' + iTUn,
                                connectId: 'widget_' + iTUn,
                                label: ''
                            });
                        }
				    });
				}
				
	            return inputWidget;
	        } else {
	            return username;
	        } 
	            
	    } else {
	        if (inputWidget) { inputWidget.destroyRecursive(); }
	        require(['dijit/Tooltip'], function(Tooltip){
	            var tooltip = dijit.byId('t_' + iTUn);
	            if (tooltip) { Tooltip.hide('widget_' + iTUn) }
	        });
	        if (username == '') { var username = "<i style='color:grey'>" + _uM_m8 + "</i>"; } 
	        return username;
	    }

	} else {
	    if (username == '') { var username = "<i style='color:grey'>" + _uM_m8 + "</i>"; } 
	    return username;
	}      	                
}


function uM_usernameWidgetUpdate() {
    var iTUn = this.id;
    require(['dojo/dom-class', 'dijit/Tooltip'], function(domClass, Tooltip){

        var value = dijit.byId(iTUn).get('value');
        var tooltip = dijit.byId('t_' + iTUn);
        if (!tooltip) {
            new Tooltip({
                id: 't_' + iTUn,
                connectId: 'widget_' + iTUn,
                label: ''
            });
        }
        
        if (value == '') {
            dijit.byId('t_' + iTUn).set('label',_uM_m6);
            domClass.add('widget_' + iTUn, 'dijitTextBoxError dijitValidationTextBoxError');
        } else {
            Tooltip.hide('widget_' + iTUn);
            domClass.remove('widget_' + iTUn, 'dijitTextBoxError dijitValidationTextBoxError');
        }
    });
}


function uM_statusIconFormat(status) {
    if (status == 'active') {
        var icon = "<img width='13' height='13' src='./../int/js/custom/images/true.png'></img>";
    } else if (status == 'inactive' || status == 'revoked') {
        var icon = "<img width='13' height='13' src='./../int/js/custom/images/false.png'></img>";
    } else {
        var icon = "<img width='15' height='15' src='./../int/js/custom/images/new.png'></img>";
    }
    var data = "<span class='gridStatusIcon'>" + icon + "</span>";
    return data;
}


function uM_userTypeFormat(gen_perm) {
    if (gen_perm == 'Administrator') {
        var data = _uM_m3;
    } else {
        var data = _uM_m4;
    }
    return data; 
}


function uM_userCertViewFormat(id_cert, id) {

    if (id_cert != '') {
        var icon = "<img width='17' height='17' onclick='uM_certDialog(event," + id_cert + ")' src='./../int/js/custom/images/info.png'></img>";
        var data = "<span class='userCertificateInfo'>" + icon + "</span>";
    } else {
        var data = _uM_m2;
    }
    return data;
}


function uM_userCertSigner(subject_CN) {

    if (subject_CN != '') {
        var data = subject_CN;
    } else {
        var data = '--';
    }
    return data;
}


function uM_permPageDialog(id) {

    require(['dojo/dom','dojo/dom-style','dojo/data/ItemFileWriteStore','dojox/grid/DataGrid',
             'dojo/query','dojo/_base/xhr','dijit/Dialog'],

        function(dom, domStyle, ItemFileWriteStore, DataGrid, query, xhr, dialog){
        
        uM_showPL();
        
        query('.permInfoDialog').forEach(function(node, index, arr){
	        var id = node.getAttribute('id');
	        dijit.byId(id).destroyRecursive();
	    });

        xhr.post({
            url: './permissionsDetails/' + id,
            handleAs: 'json',
            preventCache: true

        }).then(function(jsonData){

            var data = "<table class='permsGrid'><tr><td class='permsGridTitle'><h4>Permissions per page</h4></td></tr>"
            var data = data + "<tr><td class='permsGrid'><div id='permsGrid'></div>";
            var script = "<script type='dojo/method' data-dojo-event='onClick'data-dojo-args='evt'>dijit.byId('permInfoDialog').hide();</script></button></div>";
            var button = "<div class='permInfoDialogButton'><button data-dojo-type='dijit.form.Button' type='button'><xsl:text>Close</xsl:text>" + script + "</td></tr>"; 
            var data = data + button;
            
            uM_hidePL();
            
            var dlg = new dialog({ 
	            id: 'permInfoDialog',
		        'class': 'permInfoDialog',
                executeScripts: true,
                scriptHasHooks: true,
                content: data
	        });

	        dlg.startup();
	        cu_dlgShow(dlg);

            var permData = {items: []};
            for(var i=0; i<jsonData.items.length; i++){
                permData.items.push(jsonData.items[i]);
            }

            permStore = new ItemFileWriteStore({data: permData});
	            
            gridPermLayout = [
                {cells: [
                    { name:'Page', editable:false, field:'page', width:'70%', styles: 'font-size:8pt;' },
                    { name:'Permissions', editable:false, field:'perm', width:'30%', styles: 'font-size:8pt;' }         
                ]}
            ];
                
            permGrid = new DataGrid({
                store: permStore,
                structure: gridPermLayout
            }, 'permsGrid');
 
            permGrid.startup();
        });
    });
}


function uM_permPageDetailsFormat(user_perm_page) {

    if (user_perm_page.match(/^--/)) {
        var user_perm_page = user_perm_page.replace(/^--/, ' ');
        var data = "<span>" + user_perm_page + "</span>";
    } else {
        var id = user_perm_page;
        var icon = "<img width='14' height='14' onclick='uM_permPageDialog(" + id + ")' src='./../int/js/custom/images/info.png'></img>";
        var data = "<span>" + _uM_m1 + "</span><span class='certificateInfo' style='padding-left:15pt'>" + icon + "</span>";
    }
    return data;
}


function uM_lastVisitedFormat(ldate) {
    if (ldate == '') {
        var data = "<i style='color:grey'>" + _uM_m9 + "</i>";
    } else {
        var data = ldate;
    }
    return data;
}


function uM_cnvAdminUpdate() {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle){
    
        var value = dijit.byId('convert_administrator').get('checked');
    
        if (value == true) {
            dom.byId('convert_administrator').setAttribute('value','1');
            this._prev_rmPass = dijit.byId('remove_password').get('disabled');
            dijit.byId('remove_password').set('disabled','disabled');
            dijit.byId('password_').set('disabled','disabled');
            dijit.byId('password2_').set('disabled','disabled');
            
        } else {
            dom.byId('convert_administrator').setAttribute('value','0');
            dijit.byId('remove_password').set('disabled',this._prev_rmPass);
            dijit.byId('password_').set('disabled',false);
            dijit.byId('password2_').set('disabled',false);
        }                          
    });
}


function uM_rmPassUpdate() {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle){
    
        var value = dijit.byId('remove_password').get('checked');

        if (value == true) {
            dom.byId('remove_password').setAttribute('value','1'); 
            dijit.byId('password_').set('disabled','disabled');
            dijit.byId('password2_').set('disabled','disabled');
        
        } else {
            dom.byId('remove_password').setAttribute('value','0'); 
            dijit.byId('password_').set('disabled',false);
            dijit.byId('password2_').set('disabled',false);
        }
    });                          
}


function uM_p_GridInit() {

	require(['dojo/ready','dojo/dom','dojo/dom-style','dojo/dom-class','dojo/on','dojox/grid/DataGrid','dijit/Tooltip',
	         'dojox/data/QueryReadStore','dijit/form/Select','dojo/_base/xhr','dojo/query','dijit/form/Form',
	         'dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

        function(ready, dom, domStyle, domClass, on, DataGrid, Tooltip, QueryReadStore, Select, xhr, query){
        
        _uM_grid_loading = '1';
        
        ready(function(){ 
        
            xhr.post({
                url: './profile/loadDatabase/check',
                handleAs: 'json',
                preventCache: true

            }).then(function(jsonData){

                var numRows = jsonData.numRows.toString();
                var nameFields = jsonData.nameFields.toString();
                var titleFields = jsonData.titleFields.toString();
                
                var lnameFields = nameFields.split(/,/);
                var ltitleFields = titleFields.split(/,/);
                
		        var cells = [{name:'View', field:'id', width: '40px', headerClasses: 'profileHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_p_viewFormat }];
                for (var i=1; i<lnameFields.length; i=i+1){   
	                cells.push({name:ltitleFields[i], field:lnameFields[i], width: '150px', headerClasses: 'profileHeaderGrid', cellClasses: 'dojoxGridStyle', styles:'padding-left:8pt;text-align:left;', formatter: uM_groupDataFormat });
                }

		        var profileStore = new QueryReadStore({
	   	            url: './profile/loadDatabase/',
	   	            requestMethod: 'post'
	            });

                pGrid = new DataGrid({
                    store: profileStore,
	                query: { query: '*' },
	                rowsPerPage: 100,
	                queryOptions: {ignoreCase: true},
                    noDataMessage: "<span class='dojoxGridNoData'>" + _uM_m12 + "</span>",
                    structure: [{type: 'dojox.grid._CheckBoxSelector', width: '3em', scroll: true},
                                {cells: cells }]
                }, 'usersProfileGrid');

                pGrid.on('SelectionChanged', function(){
	                var c_items = this.selection.getSelected();
	                store = this.store;
	            
                    dom.byId('managerStatus_image').innerHTML = '';
                    dom.byId('managerStatus_text').innerHTML = '';

			        if (c_items.length == '0') {
				        dijit.byId('ugManagerB_e').set('disabled','disabled');
				        dom.byId('selUserProfile').setAttribute('value',''); 
				         
			        } else {
                        if (c_items.length == '1') {
			                dijit.byId('ugManagerB_e').set('disabled',false);
			            } else {
			                dijit.byId('ugManagerB_e').set('disabled','disabled');
			            }
                    }
                }, true);

                if (numRows == '0') {
	                query('#usersProfileGrid .dojoxGridHeader').forEach(function(node, index, arr){      
                        domStyle.set(node, 'opacity', '0'); 
                    });
                } 

                pGrid.canSort = function(){ return false }; 
                pGrid.startup();
                pGrid.resize();
                
                var handle = dojo.connect(pGrid, '_onFetchComplete', function(e) {
                    _uM_grid_loading = '0';   
                    dojo.disconnect(handle);
                });
            });
        });
    });
}


function uM_u_profileViewFormat(id_profile) {
     if (id_profile != '') {
        var icon = "<img width='19' height='20' onclick='uM_p_dialog(" + id_profile + ")' src='./../int/js/custom/images/usersProfile.png'></img>";
        var data = "<span class='profileInfo'>" + icon + "</span>";
     } else {
        var data = "<span style='color:grey'>--</i>";
     }
     return data;
}


function uM_p_viewFormat(id) {
     var icon = "<img width='17' height='17' onclick='uM_p_dialog(" + id + ")' src='./../int/js/custom/images/info.png'></img>";
     var data = "<span class='profileInfo'>" + icon + "</span>";
     return data;
}


function uM_groupDataFormat(field) {
    if (field == '') {
        var data = "<i style='color:grey'>" + _uM_m8 + "</i>";
    } else {
        var data = field;
    }
    return data;
}


function uM_p_dialog(id) {

    require(['dojo/dom','dojo/dom-style','dojo/dom-construct','dojo/on','dojo/_base/xhr','dojo/query','dijit/Dialog','dojo/_base/fx'], 
    
        function(dom, domStyle, domConstruct, on, xhr, query, dialog, fx){

        uM_clearStatus();
        uM_showPL();

        xhr.post({
	        url: './profile/profileForm',
	        handleAs: 'text',
	        postData: { 'id': id, 'dialog': '1' },
	        load: function(data) {

	            var usersDialog = dijit.byId('usersDialog');
                if (usersDialog) { usersDialog.destroyRecursive(); }

                var ldata = data.split('-*/*-');

                var edit_choose_name = ldata[0];
                var gfield = ldata[1];
                var name = ldata[2];
                var isadmin = ldata[3];
                var status = ldata[4];
                var contents = ldata[5];

                var contents = contents.replace(/&apos;/g, "'");

	            var dlg = new dialog({ 
		            id: 'usersDialog',
		            'class': 'usersDialog manageProfileDialog',
                    executeScripts: true,
                    scriptHasHooks: true,
                    content: contents
	            });

                query('#Form_d_Profile input.hidden' ).forEach(function(node, index, arr){  
                    var name = node.getAttribute('name');
                    if (name != 'p_profile_d_' + edit_choose_name) {
                        domConstruct.destroy(node);
                    }
	            });

                query('#' + edit_choose_name ).forEach(function(node, index, arr){
                    domStyle.set(node,'fontWeight','bold');
	            });

                query('#usersDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr){    
                    var titleBar = "<span class='dijitIcon usersProfileIcon'></span><span class='dijitTitleName'>Users profile</span>";
                    node.innerHTML = titleBar;
                });
                
                on(dom.byId('d_editButton'), 'click', function(){
                    uM_p_edit(edit_choose_name);         
                });

                on(dom.byId('d_closeButton'), 'click', function(){
			        uM_p_reset();
			        uM_clearStatus();
                    uM_hidePL();
	                dlg.hide();
                });
 
                on(dom.byId('d_submitButton'), 'click', function(){
			        uM_p_submit();
                });
                
                on(dom.byId('d_resetButton'), 'click', function(){
			        uM_p_reset();
                });

                var selUserProfile = dom.byId('selUserProfile').getAttribute('value');
                if (selUserProfile != '') { uM_p_edit(edit_choose_name); }

	            dlg.startup(); 
                uM_hidePL(); 
                cu_dlgShow(dlg);      
	        }
        });
    });
}


function uM_p_action() {

    require(['dojo/dom','dojo/query'], function(dom, query) {

        var pGrid = dijit.byId('usersProfileGrid');

        dom.byId('usersProfileGrid').focus();

        var c_items = pGrid.selection.getSelected(); 
	    var usersProfileData = new Array();
	    
        if (c_items.length) {
            dojo.forEach(c_items, function(item){
                var id = pGrid.store.getValue(item, 'id');
		        usersProfileData.push(id);
	        });
	        usersProfileData.join();
	        dom.byId('selUserProfile').setAttribute('value', usersProfileData.toString());

                uM_p_dialog(usersProfileData.toString());  
         } 
    });
}


function uM_p_edit(edit_choose_name) {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojo/query'], function(dom, domStyle, domClass, query){

        var msg = dom.byId('managerStatus_text').innerHTML;
        if (msg != 'Profile empty') { uM_clearStatus(); }
        
        dom.byId('post_key_1').setAttribute('name','edit');
        
        query('#Form_d_Profile .dijitDisabled' ).forEach(function(node, index, arr){  
            var id = node.getAttribute('id');
            if (dijit.byId(id)) {
                if (id == 'profile_d_' + edit_choose_name) {
                   dijit.byId(id).set('disabled','disabled');
                } else {
                    domClass.add(node, 'usersProfileInputWidget'); 
                    dijit.byId(id).set('disabled',false);
                }
            }
	    });
        
        query('#Form_d_Profile .dijitDisabled input' ).forEach(function(node, index, arr){  
            var id = node.getAttribute('id');
            if (dijit.byId(id)) {
                if (id == 'profile_d_' + edit_choose_name) {
                    dijit.byId(id).set('disabled','disabled');
                } else {
                    domClass.add(node, 'usersProfileInputWidget'); 
                    dijit.byId(id).set('disabled',false);
                }
            }
	    });
	    
	    domStyle.set('d_managerEditionPane', 'visibility', 'hidden');
	    domStyle.set('d_managerClosePane', 'display', 'none');
        domStyle.set('d_managerConfirmPane', 'display', '');
    });
}


function uM_p_reset() {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojo/query'], function(dom, domStyle, domClass, query){
    
        dijit.byId('Form_d_Profile').reset(); 
        
        query('.usersProfileInputWidget').forEach(function(node, index, arr){  
            var id = node.getAttribute('id');
            dijit.byId(id).set('disabled','disabled');
        });
	    domStyle.set('d_managerEditionPane', 'visibility', 'visible');
	    domStyle.set('d_managerClosePane', 'display', '');
        domStyle.set('d_managerConfirmPane', 'display', 'none');
    });
}


function uM_p_close() {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojo/query'], function(dom, domStyle, domClass, query){
    
        query('.usersProfileInputWidget').forEach(function(node, index, arr){  
            var id = node.getAttribute('id');
            dijit.byId(id).set('disabled','disabled');
	    });
	    
	    domStyle.set('d_managerEditionPane', 'visibility', 'hidden');
	    domStyle.set('d_managerClosePane', 'display', '');
        domStyle.set('d_managerConfirmPane', 'display', 'none');
    });
}


function uM_p_submit() {

    require(['dojo/dom','dojo/dom-style','dojo/_base/xhr','dojo/query'], function(dom, domStyle, xhr, query){
    
        if (dijit.byId('Form_d_Profile').validate()) { 
        
            uM_clearStatus();
            uM_showPL();

            var grid = dijit.byId('usersGrid');
            var usersDialog = dijit.byId('usersDialog');
            
            usersDialog.hide();

            xhr.post({
                url: './profile/profileForm/submit',
                form: dom.byId('Form_d_Profile'),
                handleAs: 'json',
                load: function(jsonData) {
            
                    var opResult = jsonData.opResult.toString();
	                if (opResult.match(/^ERROR/)) {
                        var msgError = jsonData.msgError.toString();
                        uM_showStatus('false', msgError);
                                
	                } else {
                        if (grid) { uM_gridUpdate(); } 
	                    var msg = jsonData.msg.toString();
	                    
	                    uM_showStatus('true', msg);
	                    uM_updateCntrlTabs('update');
                    }
                }
            });
        } 
    });
}

function uM_showPL() {
    uM_clearStatus();
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        domStyle.set('managerPL', 'display', '');
    });
}


function uM_hidePL() {
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        domStyle.set('managerPL', 'display', 'none');
    });
}

function uM_showStatus(tick, text) {

    require(['dojo/dom'], function(dom) {
    
        if (tick == 'false') {
            var src = './../int/js/custom/images/false.png';  
        } else {
            var src = './../int/js/custom/images/true.png';  
        }
        var icon = "<img width='13' height='13' src='" + src + "'></img>";
         
        dom.byId('managerStatus_image').innerHTML = icon;
        dom.byId('managerStatus_text').innerHTML = text;
        uM_hidePL();  
        cu_fadeIn('managerStatus_image');
        cu_fadeIn('managerStatus_text');             
    });
}

function uM_clearStatus() {
    cu_fadeQuickOut('managerStatus_image');
    cu_fadeQuickOut('managerStatus_text');
}

function uM_dialogShowStatus(tick, text) {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
    
        if (tick == 'false') {
            domStyle.set('usersDialogStatus_icon_false', 'display', 'block');
	        domStyle.set('usersDialogStatus_icon_true', 'display', 'none');
        } else {
            domStyle.set('usersDialogStatus_icon_true', 'display', 'block');
	        domStyle.set('usersDialogStatus_icon_false', 'display', 'none');
        }

        dom.byId('usersDialogStatus_text').innerHTML = text;
        uLR_hidePL();  
        cu_fadeIn('usersDialogStatus_icon');
        cu_fadeIn('usersDialogStatus_text');      
    });
}

function uM_dialogClearStatus() {
    cu_fadeQuickOut('usersDialogStatus_icon');
    cu_fadeQuickOut('usersDialogStatus_text');
    cu_fadeQuickOut('usersDialogStatus_info');
    
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        domStyle.set('usersDialogStatus_info', 'display', 'none');
    });
}





function uM_undo() {

    if (this._timeout) { 
        clearTimeout(this._timeout); 
    }

    require(['dojo/dom','dojo/dom-style','dojox/grid/DataGrid','dojox/data/QueryReadStore','dojo/_base/xhr',
             'dojox/grid/cells/dijit', 'dojox/grid/_CheckBoxSelector'],

        function(dom, domStyle, DataGrid, QueryReadStore, xhr){
        
	    uM_clearStatus();
        uM_showPL();

        xhr.post({
            url: './undo',
            handleAs: 'json',
            postData: {'action': action, 'ajax': '1' },
            load: function(jsonData) {
            
                uM_hidePL();
            
                var opResult = jsonData.opResult.toString();
                var undo = jsonData.undo.toString();

	    	    if (opResult.match(/^ERROR/)) {
                     var src = './../int/js/custom/images/' + false + '.png';
            		 var dialog_check = "<img width='13' height='13' src='" + src + "'></img>";
            		 dom.byId('managerStatus_image').innerHTML = dialog_check;
	    		     dom.byId('managerStatus_text').innerHTML = jsonData.error.toString();
	    		     
	    	    } else {
	    	    
	    	         xhr.post({
                         url: './loadDatabase/check',
                         handleAs: 'json',
                         preventCache: true
                         
                     }).then(function(jsonData){
	                     var genPerm = jsonData.genPerm.toString();
                         dom.byId('generalPermissions').innerHTML = genPerm;
                     });
                     
                     var userStore = null;
		             userStore = new QueryReadStore({
	   	                 url: './loadDatabase/?',
	   	                 requestMethod: 'post'
	                 });
	                 
	                 if (undo == '1') {
                         //dijit.byId('managerB_undo').set('disabled',false);
                         //dijit.byId('managerT_undo').set('label',jsonData.msgUndo.toString());
                     } else {
                         //dijit.byId('managerB_undo').set('disabled','disabled');
                         //dijit.byId('managerT_undo').set('label','');
                         //dijit.byId('managerT_undo').close();
                     }
                     
	                 dijit.byId('usersGrid').setStore(userStore); 
	    		     var src = './../int/js/custom/images/true.png';
            		 var icon = "<img width='13' height='13' src='" + src + "'></img>";
            		 
            		 dom.byId('managerStatus_image').innerHTML = icon;
	    		     dom.byId('managerStatus_text').innerHTML = jsonData.msg.toString();
                }
                
                uM_showStatus();

                dom.byId('userAction').setAttribute('value','');
                
                clearTimeout(this._timeout); 
		    }
    	});
    }); 
}



	        