@echo off
rem    OutputFile: %2\%1.flavia.inf
rem    WarningFile: %2\%1.flavia.war
rem    ErrorFile: %2\%1.flavia.err
rem    OutFile: %2\%1.flavia.out

del "%2\%1.flavia.res"
del "%2\%1.flavia.err"
del "%2\%1.flavia.war"

del "%2\damping_matrix.dat"
del "%2\DiffractionForce.tec"
del "%2\ExcitationForce.tec"
del "%2\Fe.dat"
del "%2.IRF.dat"
del "%2\hydrodynamic_restoration_matrix.dat"
del "%2\added_mass_matrix.dat"
del "%2\%1.Raos.res"
del "%2\%1.Raos_phase.res" 
del "%2\Nemoh_output"

cd "%2"

if not exist "%2\mesh" md %2\mesh
if not exist "%2\results" md %2\results
if not exist "%2\Kochin" md %2\Kochin 

%3\exec\Seabem.exe -r "%2" "%1" >> "%2\%1.flavia.out"

if not exist "%2\%1.flavia.res" if not exist "%2\Nemoh_output" echo "Program failed" >> "%2\%1.flavia.err"

if not exist "%2\Nemoh_output" md %2\Nemoh_output
if exist "%2\mesh" MOVE "%2\mesh" %2\Nemoh_output
if exist "%2\Normalvelocities.dat" MOVE "%2\Normalvelocities.dat" %2\Nemoh_output
if exist "%2\results" MOVE "%2\results" %2\Nemoh_output
if exist "%2\%1.cal" copy "%2\%1.cal" "%2\Nemoh_output\Nemoh.cal"


