#------------------------------------------Remote calculations-----------------------------

set GidProcWin(clientversion) 3.1
set GidProcWin(serverversion) 0.0 ;#later, server will inform us
set GidProcWin(requiredserverversion_compress) 2.0 ;#first version using compression
set GidProcWin(requiredserverversion_encrypt) 3.0 ;#first version using encrypt

if { ![info exists GidProcWin(securemode)] } {
    set GidProcWin(securemode) "BF"
   # "NONE" for not encripted connection
   # "BF" Blowfish encrtypted
}

if { ![info exists GidProcWin(remoteresultsdownload)] } {
    set GidProcWin(remoteresultsdownload) "Automatic"
}
if {
    ![info exists GidProcWin(remoteresultsdelete)] } {
    set GidProcWin(remoteresultsdelete) "Automatic"
}

proc PWAskForServer { w title text buttonlabel {onlypassword 0 } } {
    #check if have all data and then is not necessary to open the window to ask the user
    global GidProcWin
    set GidProcWin(newpass) ""
    set oldargs Password,$GidProcWin(remoteserver),$GidProcWin(remotegroup),$GidProcWin(remoteuser)
    if { [info exists GidProcWin($oldargs)] } {
	if { [catch { set GidProcWin(newpass) [encrypter BF decode kah45fd93ak74ngfu [encrypter BASE64 decode $GidProcWin($oldargs)]]} err] } {
	    set GidProcWin(newpass) ""
	    unset GidProcWin($oldargs)
	}
    }
    set ok 1
    if { $GidProcWin(remoteserver) == "" } {
	set ok 0
    } elseif { $GidProcWin(remotegroup) == "" } {
	set ok 0
    } elseif { $GidProcWin(remoteuser) == "" } {
	set ok 0
    } elseif { $GidProcWin(newpass) == "" } {
	set ok 0
    }
    if { $ok } {
	set GidProcWin($oldargs) $GidProcWin(newpass)
	unset GidProcWin(newpass)
	set GidProcWin(exec) 1
    } else {
	PWAskForServerWindow $w $title $text $buttonlabel $onlypassword
    }
}

proc PWAskForServerWindow { w title text buttonlabel {onlypassword 0 } } {
    global GidProcWin

    InitWindow $w $title ProcViewRemoteWindowGeom "" "" 1
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

    ttk::label $w.l0 -text $text -wraplength 150 -justify left
    #bind $w.l0 <Configure> { %W configure -wraplength [winfo width %W] }
    ttk::label $w.l1 -text [_ "Remote server"]
    ttk::entry $w.e1 -textvar GidProcWin(remoteserver)
	# -relief sunken
	
    ttk::label $w.l2 -text [_ "Group"]
    ttk::entry $w.e2 -textvar GidProcWin(remotegroup)
    # -relief sunken

    ttk::label $w.l3 -text [_ "User"]
    ttk::entry $w.e3 -textvar GidProcWin(remoteuser)
    # -relief sunken

    if { $onlypassword } {
	$w.e1 configure -state disabled
	$w.e2 configure -state disabled
	$w.e3 configure -state disabled
    }

    ttk::label $w.l4 -text [_ "Password"]
    ttk::entry $w.e4 -textvar GidProcWin(newpass) -show *
    # -relief sunken

    ttk::frame $w.buts -style BottomFrame.TFrame
    #-borderwidth 0
    ttk::button $w.buts.calc -text $buttonlabel -command "set GidProcWin(exec) 1" \
	    -style BottomFrame.TButton -underline 0
    bind $w <Alt-c> "$w.buts.calc invoke"
    ttk::button $w.buts.cancel -text Cancel -command "set GidProcWin(exec) 0" \
	    -underline 1
	    # -width 9
    bind $w <Alt-a> "$w.buts.cancel invoke"
    pack $w.buts.calc $w.buts.cancel -side left -anchor center -expand 1 -pady 2

    grid $w.l0 -column 1 -row 1 -sticky ew -columnspan 2 -pady 3
    grid $w.l1 -column 1 -row 2
    grid $w.e1 -column 2 -row 2 -sticky ew
    grid $w.l2 -column 1 -row 3
    grid $w.e2 -column 2 -row 3 -sticky ew
    grid $w.l3 -column 1 -row 4
    grid $w.e3 -column 2 -row 4 -sticky ew
    grid $w.l4 -column 1 -row 5
    grid $w.e4 -column 2 -row 5 -sticky ew
    grid $w.buts -column 1 -row 6 -columnspan 2 -sticky ew -pady 0
    if { $::tcl_version >= 8.5 } { grid anchor $w.buts center }
    grid columnconf $w 2 -weight 1

    bind $w <Return> "$w.buts.calc invoke"
    bind $w <Escape> "$w.buts.cancel invoke"

    tkwait visibility $w
    grab $w
    if { $onlypassword } {
	tkTabToWindow $w.e4
    } else {
	tkTabToWindow $w.e1
    }
    focus $w
    set ok 0
    while { !$ok } {
	vwait GidProcWin(exec)
	set ok 1
	if { $GidProcWin(exec) == 1 } {
	    if { $GidProcWin(remoteserver) == "" } {
		WarnWin [_ "It is necessary to enter a server name"]
		set ok 0
	    } elseif { $GidProcWin(remotegroup) == "" } {
		WarnWin [_ "It is necessary to enter a group name"]
		set ok 0
	    } elseif { $GidProcWin(remoteuser) == "" } {
		WarnWin [_ "It is necessary to enter a user name"]
		set ok 0
	    } elseif { $GidProcWin(newpass) != "" &&
		![regexp {^[-#_a-zA-Z0-9]+$} $GidProcWin(newpass)] } {
		WarnWin [_ "Password not valid. Only valid characters: 'a-zA-Z0-0#-_'"]
		set ok 0
	    }
	}
    }
    if { [info exists GidProcWin(newpass)] } {
	set GidProcWin(newpass) [encrypter BASE64 encode [encrypter BF encode kah45fd93ak74ngfu $GidProcWin(newpass)]]
	if { [info exists GidProcWin(remoteserver)] && [info exists GidProcWin(remotegroup)]} {
	    set GidProcWin(Password,$GidProcWin(remoteserver),$GidProcWin(remotegroup),$GidProcWin(remoteuser)) $GidProcWin(newpass)
	}
	unset GidProcWin(newpass)
    }

    destroy $w
}

proc PWCalcRemote { w basename directory ProblemType otherargs } {
    global GidProcWin env

    if { ![info exists GidProcWin(remoteport)] } {
	set GidProcWin(remoteport) 2048
    }
    set port $GidProcWin(remoteport)

    if { [info exists env(PROCSERVER_PORT)] } {
	set port $env(PROCSERVER_PORT)
    }

    PWAskForServer $w [_ "Remote calculate"] \
	[_ "Enter the server to perform the remote calculation"]: [_ "Calculate"]

    if { $GidProcWin(exec) == 0 } {
	return "end [clock seconds]"
    }



    if { [catch {
	set channel [socket -async $GidProcWin(remoteserver) $port]
	catch { unset GidProcWin(userkey,$channel) } ;#until encrypted transmission must be unset
    } err] } {
	WarnWin [_ "Connection to server has failed (%s). Try again" $err]
	return "end [clock seconds]"
    }
    set type "OPENING [PWGetNumNodes]"

    fconfigure $channel -blocking 0
    fileevent $channel readable [list PWReadFromSocket $channel $type \
	     $basename \
	    $directory $ProblemType $GidProcWin(remotegroup) $GidProcWin(remoteuser) \
	    $GidProcWin(Password,$GidProcWin(remoteserver),$GidProcWin(remotegroup),$GidProcWin(remoteuser)) \
	    $otherargs]

    if { ![info exists GidProcWin(remotetimeout)] } {
	set GidProcWin(remotetimeout) 30
    }

    PWTimeout $channel $type
    return [list remote [clock seconds] $GidProcWin(remoteserver) [list $GidProcWin(remotegroup) $GidProcWin(remoteuser)] \
	    $channel OPENING $directory $ProblemType $otherargs [clock seconds]]
}

# checkerror 1: To be used when GiD opens first time
# checkerror 2: to update info an error files
proc PWCheckIfAlive { w basename checkerror } {
    global RunProcInfo GidProcWin env

    PWdebugprint "Entering PWCheckIfAlive checkerror=$checkerror"

    if { ![info exists GidProcWin(remoteport)] } {
	set GidProcWin(remoteport) 2048
    }
    set port $GidProcWin(remoteport)

    if { [info exists env(PROCSERVER_PORT)] } {
	set port $env(PROCSERVER_PORT)
    }

    set found 0
    set ipos 0
    set i ""
    foreach i $RunProcInfo {
	set name [lindex $i 0]
	if { $name == $basename } {
	    set found 1
	    break
	}
	incr ipos
    }
    if { !$found } { return }

    set channel [lindex $i 8]

    set state [lindex $i 9]
    if { $state == "EXECUTING UPDATE" &&  $checkerror == 2} {
	return
    } elseif { [lindex $state 0] == "FILETOCLIENT" || [lindex $state 0] == "ENDFILETOCLIENT" } {
	return
    }

    if { ![info exists GidProcWin(dessesperateupdate)] } {
	set GidProcWin(dessesperateupdate) 0
    }
    if { $checkerror == 2 } {
	incr GidProcWin(dessesperateupdate)
    }

    if { [lindex $state 0] == "RESULTSINSERVER" } {
	set tmpremotemessages $GidProcWin(remotemessages)
	set GidProcWin(remotemessages) [_ "Calculation finished. You can download the remote results" ]
	update
	after 2000 [list set GidProcWin(remotemessages) $tmpremotemessages]
	return
    }

    if { $GidProcWin(dessesperateupdate) >= 5 && $channel != "" } {
	if { [string length $state] > 20 } {
	    set partstate [string range $state 0 17]...
	} else {
	    set partstate $state
	}
	set msg [_ "Program is now communicating with the server."]
	if { [info exists GidPriv(Configuration)] && $GidPriv(Configuration) == "debug" } {
	    append msg " state=$partstate checkerror=$checkerror."
	}
	append msg " " [_ "Do you want to stop communication and perform the Update?"]
	set retval [tk_dialogRAM .gid.errorwin [_ "Dialog window"] $msg \
	    warning 1 [_ "Yes"] [_ "Cancel"]]
	if { $retval == 0 } {
	    #if { [string match ENDFILETOCLIENT* $state] } {
	    #    set state EXECUTING
	    #    SetServerInfoState $channel EXECUTING
	    #}
	    CloseChannel $channel
	    set state "OPENING"
	    SetServerInfoState $channel "OPENING"
	    set channel ""
	} else {
	    set GidProcWin(dessesperateupdate) 0
	}
    }

    if { $channel != "" } { return }
    set GidProcWin(dessesperateupdate) 0
    if { [lindex $state 0] != "EXECUTING" } {
	if { $checkerror == 2 } {
	    set tmpremotemessages $GidProcWin(remotemessages)
	    set GidProcWin(remotemessages) [_ "Update not possible. Current state is: %s" [lindex $state 0]]
	    update
	    after 1000 [list set GidProcWin(remotemessages) $tmpremotemessages]
	}
	return
    }

    set timeaccess [lindex $i 13]

    if { ![info exists GidProcWin(remoteauto)] } {
	set GidProcWin(remoteauto) 1
    }
    if { ![info exists GidProcWin(remotetime)] } {
	set GidProcWin(remotetime) 10
    }
    if { !$checkerror && !$GidProcWin(remoteauto) } {
	return
    }
    if { !$checkerror  && \
	    [expr [clock seconds]-$timeaccess] < $GidProcWin(remotetime) } {
	return
    }

    PWdebugprint "continue PWCheckIfAlive"

    set GidProcWin(remoteserver) [lindex $i 6]
    set GidProcWin(remotegroup) [lindex [lindex $i 7] 0]
    set GidProcWin(remoteuser) [lindex [lindex $i 7] 1]
    if { ![info exists GidProcWin(Password,$GidProcWin(remoteserver),$GidProcWin(remotegroup),$GidProcWin(remoteuser))] } {
	update
	PWAskForServer $w [_ "Password for remote server"] \
	    [_ "Enter the remote server for problem '%s'" $basename]: [_ "OK"] 1
	if { $GidProcWin(exec) == 0 } {
	    set msg [_ " Automatic update has been disabled."]
	    append msg " "
	    append msg [_ "To update later, use the button 'Remote' in the Calculate window."]
	    tk_dialogRAM .gid.errorwin [_ "Warning info"] $msg warning 0 [_ "OK"]
	    set GidProcWin(remoteauto) 0
	    return
	}
    }
    if { !$checkerror } {
	set type EXECUTING
    } else {
	set type EXECUTINGFORCE
    }


    set GidProcWin(remotemessages) [_ "Connecting"]...
    if { [catch {
	set channel [socket -async $GidProcWin(remoteserver) $port]
	catch { unset GidProcWin(userkey,$channel) } ;#until encrypted transmission must be unset
    } err] } {
	ErrorInSocket $channel $type \
	  [_ "Connection to server '%s' for project '%s' has failed (%s)." $GidProcWin(remoteserver) $basename $err]
	return
    }
    set newi [lreplace $i 8 8 $channel]
    if { $checkerror == 1 } {
	set newi [lreplace $newi 9 9 "EXECUTING CHECK"]
    } elseif { $checkerror == 2 } {
	set newi [lreplace $newi 9 9 "EXECUTING UPDATE"]
    }
    set RunProcInfo [lreplace $RunProcInfo $ipos $ipos $newi]

    set directory [lindex $i 10]
    set ProblemType [lindex $i 11]
    set otherargs [lindex $i 12]

    fconfigure $channel -blocking 0
    fileevent $channel readable [list PWReadFromSocket $channel $type $basename \
	    $directory $ProblemType $GidProcWin(remotegroup) $GidProcWin(remoteuser) \
	    $GidProcWin(Password,$GidProcWin(remoteserver),$GidProcWin(remotegroup),$GidProcWin(remoteuser)) \
	    $otherargs]

    if { ![info exists GidProcWin(remotetimeout)] } {
	set GidProcWin(remotetimeout) 30
    }
    PWTimeout $channel $type
}

# type can be: OPENING ; EXECUTING ; EXECUTINGFORCE ; KILLING ; KILLINGFORCE
proc ErrorInSocket { channel type text } {
    global GidProcWin
    PWdebugprint "enter ErrorInSocket, type=$type state=[GiveServerInfoState $channel]"

    switch -glob $type {
	OPENING* {
	    append text " " [_ "Check your internet connection and try later."]
	    tk_dialogRAM .gid.errorwin [_ "Error info"] $text error 0 [_ "OK"]
	    SetServerInfoState $channel ERROR
	}
	EXECUTING {
	
	    append text " " [_ "Automatic update has been disabled."]
	    append text " " [_ "To update later, use the button 'Remote' in the Calculate window."]
	    tk_dialogRAM .gid.errorwin [_ "Warning info"] $text warning 0 [_ "OK"]
	    SetServerInfoState $channel EXECUTING
	    set GidProcWin(remoteauto) 0
	}
	EXECUTINGFORCE {
	    append text " " [_ "Check your internet connection."]
	    append text " " [_ "To update later, use the button 'Remote' in the Calculate window."]
	    tk_dialogRAM .gid.errorwin [_ "Error info"] $text error 0 [_ "OK"]
	    SetServerInfoState $channel EXECUTING
	    set GidProcWin(remoteauto) 0
	}
	KILLINGFORCE {
	    SetServerInfoState $channel ERROR
	}
	KILLING {
	    append text " " [_ "Terminate process in server is not possible."]
	    append text " " [_ "Do you want to try later or consider locally as terminated?"]
	    set retval [tk_dialogRAM .gid.errorwin [_ "Error info"] $text \
		    warning 0 [_ "Try later"] [_ "Terminate locally"]]
	    if { $retval == 0 } {
		SetServerInfoState $channel EXECUTING
	    } else {
		set name [GiveRunProcInfoName $channel]
		WarnWin [_ "Process '%s' has been locally terminated" $name]
		SetServerInfoState $channel ERROR
		after idle ActualizeProcInfo autoupdate
	    }
	}
	ANY {
	    tk_dialogRAM .gid.errorwin [_ "Error info"] $text \
		    error 0 [_ "OK"]
	    SetServerInfoState $channel ERROR
	}
	default {
	    append text " " [_ "Check your internet connection and try later."]
	    tk_dialogRAM .gid.errorwin [_ "Error info"] $text \
		    error 0 [_ "OK"]
	    SetServerInfoState $channel ERROR
	}
    }
    #PWdebugprint "leaving ErrorInSocket"
    CloseChannel $channel
    set GidProcWin(remotemessages) ""
}

proc PWTimeout { channel type } {
    global GidProcWin
    after [expr $GidProcWin(remotetimeout)*1000] [list PWCheckSocketState $channel $type]
}

proc PWCancelTimeout { channel } {
    foreach i [after info] {
	set proc [lindex [after info $i] 0]
	if { [string match PWCheckSocketState* $proc] } {
	    after cancel $i
	}
    }
    #after cancel [list PWCheckSocketState $channel ""]
}

# type can be: OPENING ; EXECUTING ; EXECUTINGFORCE ; KILLING ; KILLINGFORCE
proc PWCheckSocketState { channel type } {

    set server [GiveRunProcInfoServer $channel]
    if { [catch {
	#set err [fconfigure $channel -error]
	set err ""
    } err2]} {
	ErrorInSocket $channel $type \
		[_ "Connection to server '%s' has failed (%s)." $server  $err2]
	return
    }
    if { $err != "" } {
	ErrorInSocket $channel $type \
		[_ "Connection to server '%s' has failed (%s)." $server $err]
	return
    }
    ErrorInSocket $channel $type [_ "Connection to server '%s' has failed (timeout)." $server]
}

proc PWWriteToSocket { channel type text } {
    global GidProcWin
    if { [catch {
	if { [info exists GidProcWin(userkey,$channel)] } {
	    set encrypt 1
	} else {
	    set encrypt 0
	}
	fileevent $channel writable [list PWWriteToSocketCb $channel $type $text $encrypt]
	
	PWTimeout $channel $type
    } err] } {
	ErrorInSocket $channel $type [_ "Connection to server has failed (%s)." $err]
    }
}

proc PWWriteToSocketCb { channel type text encrypt } {
    global GidProcWin
    if { [eof $channel] } {
	ErrorInSocket $channel $type [_ "Connection to server has failed."]
    } else {
	fileevent $channel writable ""
	PWdebugprint ">>$text"
	if { $encrypt } {
	    if { ![info exists GidProcWin(userkey,$channel)] } {
		ErrorInSocket $channel $type [_ "Secure connection has failed."]
	    } else {
		set text [encrypter $GidProcWin(securemode) encode "$GidProcWin(userkey,$channel)" "$text"]
		set text [encrypter BASE64 encode $text]
		puts $channel $text
	    }
	} else {
	    puts $channel $text
	}
	flush $channel
    }
}

proc PWGetNumNodes {} {
    return [GiD_Info Mesh NumNodes]
}

proc PWCompressFileCheckIfFinished { pid { FirstTime 1 } } {
    global GidProcWin

    if { $FirstTime } {
	set res [gidproc isalive $pid [clock seconds]]
    } else {
	set res [gidproc isalive $pid]
    }

    if { $res } {
	after 200 PWCompressFileCheckIfFinished $pid 0
    } else {
	set GidProcWin(CompressingFile) end
    }
}

proc PWCompressFile { file { uncompress 0 } } {
    global GidProcWin argv0

    if { $::tcl_platform(platform) == "windows" } {
	set null NUL:
    } else {
	set null /dev/null
    }

    if {[catch {
	if { $uncompress == 0 } {
	    set destfile $file.gz
	    #             set res [gidproc exec $argv0 -compress $file $destfile]
	    #             set pid [lindex $res 0]
	    set pid [exec $argv0 -compress $file $destfile >& $null &]
	} else {
	    set destfile [file root $file]
	    #             set res [gidproc exec $argv0 -compress $file $destfile]
	    #             set pid [lindex $res 0]
	    set pid [exec $argv0 -compress -d $file $destfile >& $null &]
	}
    } err] } {
	WarnWin $err
	return -1
    }
    after 200 PWCompressFileCheckIfFinished $pid
    vwait GidProcWin(CompressingFile)

    if { [file exists $destfile] && [file size $destfile] > 0 } {
	return 0
    } else { return -1 }
}

# type can be: OPENING ; EXECUTING ; EXECUTINGFORCE ; KILLING ; KILLINGFORCE
# OPENING has as second argument NumNodes
proc PWReadFromSocket { channel type basename directory ProblemType \
	group user password otherargs } {
    global GidProcWin
    PWdebugprint "enter PWReadFromSocket"

    PWCancelTimeout $channel

    set state [GiveServerInfoState $channel]

    if { [catch {
	set err [fconfigure $channel -error]
	#set err ""
    } err2] } {
	PWdebugprint "PWReadFromSocket err2=$err2"
	ErrorInSocket $channel $type \
		[_ "Connection to server has failed (%s)." $err2]
	return
    }
    if { $err != "" } {
	PWdebugprint "PWReadFromSocket err=$err"
	ErrorInSocket $channel $type \
		[_ "Connection to server has failed (%s)." $err]
	return
    }

    if { [eof $channel] } {
	PWdebugprint "PWReadFromSocket eof"
	ErrorInSocket $channel $type \
		[_ "Connection to server has failed for '%s'." $basename]
	return
    }

    gets $channel aa

    PWdebugprint "<<encrypted aa=$aa,length=[string length $aa]"

    if { [string length $aa] == 0 } return

    if { [info exists GidProcWin(userkey,$channel)] } {
	set aa [encrypter BASE64 decode $aa]
	set aa [encrypter $GidProcWin(securemode) decode "$GidProcWin(userkey,$channel)" "$aa"]
    }
    PWdebugprint "<<$aa, type=$type, state=$state"

    if { [catch {
	join  $aa " "
    }]} {
	after idle WarnWin [list [_ "Error: unknown command from server '%s'" $aa]]
	#puts [list [_ "Error: unknown command from server '%s'" $aa]]
	#.central.s OutPutPrintedMessages
	return
    }



    switch -glob $aa {
	ERRORSEVERE* {
	    if { $state != "KILLINGFORCE" } {
		set msg [_ "There has been an error in the server. "]
		append msg " " [_ "Process '%s' terminated (%s)." $basename [string trim [lrange $aa 2 end] \{\}]]
		WarnWin $msg
	    }
	    set GidProcWin(remotemessages) ""

	    SetServerInfoState $channel ERROR
	    CloseChannel $channel
	    after idle ActualizeProcInfo
	}
	ERROR* {
	    ErrorInSocket $channel ANY [_ "Error from server for %s' (%s)." '$basename [lrange $aa 1 end]]
	    return
	}
	INFORMATION* {
	    WarnWin [_ "Information from server: %s" [lrange $aa 1 end]]
	}
	USERINFO* {
	    CloseChannel $channel
	    set GidProcWin(remotemessages) ""
	    ShowServerUserInfo $aa
	}
	SERVERVERSION* {
	    set GidProcWin(serverversion) [lindex $aa 1]
	    if { $GidProcWin(serverversion) < $GidProcWin(requiredserverversion_encrypt) } {
		catch { unset GidProcWin(userkey,$channel) }
		set msg [_ "Security Warning: Server Version %s not support secure connections." $GidProcWin(serverversion)]
		WarnWin $msg
	    }
	    PWWriteToSocket $channel $type "SERVERVERSION OK"
	}
	IDENTIFY* {
	    set GidProcWin(remotemessages) [_ "Security"]...
	    #SetServerInfoState $channel "OPENING"
	    PWWriteToSocket $channel $type [list SECUREMODE $GidProcWin(securemode)]
	}
	SERVERREQUIREENCRYPT* {
	    set GidProcWin(remotemessages) [_ "Security"]...
	    #SetServerInfoState $channel "OPENING"
	    set msg [_ "The server requires a secure connection."]
	    append msg "" [_ "Do you want to send the data with encryption?"]
	    set retval [tk_dialogRAM .gid.errorwin [_ "Security warning"] \
		    $msg warning 1 [_ "Yes"] [_ "Cancel"]]
	    if { $retval == 0 } {
		SetServerInfoState $channel OPENING
		set GidProcWin(securemode) "BF"
		PWWriteToSocket $channel $type [list SECUREMODE $GidProcWin(securemode)]
	    } else {
		catch { unset GidProcWin(userkey,$channel) } ;#until encrypted transmission must be unset
		set GidProcWin(remotemessages) ""
		SetServerInfoState $channel ERROR
		CloseChannel $channel
		after idle ActualizeProcInfo
	    }
	}
	SERVERREJECTENCRYPT* {
	    set GidProcWin(remotemessages) [_ "Security"]...
	    #SetServerInfoState $channel "$state"
	    set msg [_ "The server reject a secure connection."]
	    append msg "" [_ "Do you want to send the data without encryption?"]
	    set retval [tk_dialogRAM .gid.errorwin [_ "Security warning"] \
		    $msg warning 1 "Yes" "Cancel"]
	    if { $retval == 0 } {
		SetServerInfoState $channel OPENING
		set GidProcWin(securemode) "NONE"
		catch { unset GidProcWin(userkey,$channel) } ;#until encrypted transmission must be unset
		PWWriteToSocket $channel $type [list SECUREMODE $GidProcWin(securemode)]
	    } else {
		catch { unset GidProcWin(userkey,$channel) } ;#until encrypted transmission must be unset
		set GidProcWin(remotemessages) ""
		SetServerInfoState $channel ERROR
		CloseChannel $channel
		after idle ActualizeProcInfo
	    }
	}
	PUBLICKEY* {
	    set GidProcWin(remotemessages) [_ "Security"]...
	    #SetServerInfoState $channel "OPENING"

	    if { $GidProcWin(securemode) == "NONE" } {
		catch { unset GidProcWin(userkey,$channel) }
		PWWriteToSocket $channel $type "SETUSERKEY NONE"
	    } else {
		set publickey [lindex $aa 1]
		#invento una clave automtica cada vez
		set key [string range [encrypter BASE64 encode [encrypter MD5 encode [clock seconds]]] 0 21]
		regsub -all {[=+/]} $key {z} key ;#only alphanumeric characters

		set encryptedpassword [encrypter RSA encode "$publickey" "$key"]
		set encryptedpassword [encrypter BASE64 encode $encryptedpassword]
		catch { unset GidProcWin(userkey,$channel) }
		PWWriteToSocket $channel $type "SETUSERKEY $encryptedpassword"
		set GidProcWin(userkey,$channel) $key
	    }
	}
	USERID* {
	    set GidProcWin(remotemessages) [_ "Identifying"]...
	    SetServerInfoState $channel "IDENTIFYING $state"
	    set NumNodes [lindex $type 1]
	    if { $NumNodes == "" } { set NumNodes 0 }
	    set fail 0
	    if { $password != "" } {
		if { [catch { set password [encrypter BASE64 decode $password] } err] } { 
		    set fail 1
		} else {
		    set password [encrypter BF decode kah45fd93ak74ngfu $password]
		}
	    }

	    if { $fail } {
		WarnWin [_ "Problems with process '%s' terminating it." $basename]
		set GidProcWin(remotemessages) ""
		SetServerInfoState $channel ERROR
		CloseChannel $channel
		set password ""
	    } else {		
		PWWriteToSocket $channel $type \
		    [list IDENTITY $user $password $ProblemType $NumNodes $basename $GidProcWin(clientversion) $group]
		set password ""
	    }
	}
	INFO* {
	    switch [lindex $aa 1] {
		FINISHED {
		    if { $GidProcWin(remoteresultsdownload) == "Automatic" } {
		        # send files and delete or not in the server
		        set files [lindex $aa 2]
		        set filename [lindex [lindex $files 0] 0]
		        set size [lindex [lindex $files 0] 1]
		        if { $GidProcWin(remoteresultsdelete) == "Automatic" } {
		            set GidProcWin(remotemessages) \
		                [_ "Calculation finished. Transferring files"]...
		            SetServerInfoState $channel [list FILETOCLIENT $files FINISHED]
		        } else {
		            set GidProcWin(remotemessages)\
		                [_ "Calculation finished. Files not transferred automatically"]
		            SetServerInfoState $channel [list FILETOCLIENT $files STORE]
		        }
		        #SetServerInfoState $channel [list FILETOCLIENT $files FINISHED]
		        PWWriteToSocket $channel $type [list FILETOCLIENT $filename]
		    } else {
		        # only notify, not send or delete files
		        set GidProcWin(remotemessages) [_ "Calculation finished. Files not transferred automatically"]
		        PWWriteToSocket $channel $type STORE
		    }
		}
		EXECUTING {
		    set message [lindex $aa 3]
		    if { $message != "" } { set message " ($message)" }
		    if { [lindex $state 1] == "CHECK" } {
		        tk_dialogRAM .gid.namewin [_ "Process info"] \
		                [_ "Process '%s' is still running%s." $basename $message] \
		                info 0 [_ "OK"]
		
		    }
		    set closing 1
		    if { [lindex $state 1] == "UPDATE" } {
		        set files [lindex $aa 2]
		        if { [llength $files] > 0 } {
		            #avoid require files if size not change form previous send
		            if { [info exists GidProcWin(lastinfofiles,$channel)] &&
		                $GidProcWin(lastinfofiles,$channel) == $files } {
		                set GidProcWin(remotemessages) [_ "Info files unchanged, avoid to send"]
		            } else {
		                set GidProcWin(lastinfofiles,$channel) $files
		                set GidProcWin(remotemessages) \
		                    [_ "Process '%s' is executing %s. Transfering info files..." $basename $message]
		                set filename [lindex [lindex $files 0] 0]
		                set size [lindex [lindex $files 0] 1]
		                SetServerInfoState $channel [list FILETOCLIENT $files UPDATE]
		                PWWriteToSocket $channel $type [list FILETOCLIENT $filename]
		                set closing 0
		            }
		        } else {
		            set GidProcWin(remotemessages) \
		                    [_ "Process '%s' is executing %s. No files to transfer..." $basename $message]
		        }
		    } else {
		        set GidProcWin(remotemessages) [_ "Process '%s' is executing %s..." $basename $message]
		    }
		    if { $closing } {
		        SetServerInfoState $channel EXECUTING
		        CloseChannel $channel
		        after 2000 [list set GidProcWin(remotemessages) {}]
		    }
		}
		KILLED {
		    WarnWin [_ "Process '%s' has been terminated in the server (%s)." $basename [string trim [lrange $aa 2 end] \{\}]]
		    set GidProcWin(remotemessages) ""
		    SetServerInfoState $channel ERROR
		    CloseChannel $channel
		}
		STORED {
		    if { $state == "DOWNLOADRESULTS" } {
		        #send result files
		        set GidProcWin(remotemessages) [_ "Transferring files"]...
		        set files [lindex $aa 2]
		        set filename [lindex [lindex $files 0] 0]
		        set size [lindex [lindex $files 0] 1]
		        SetServerInfoState $channel [list FILETOCLIENT $files ENDDOWNLOAD]
		        PWWriteToSocket $channel $type [list FILETOCLIENT $filename]
		    } else {
		        WarnWin [_ "Results '%s' stored in the server, files: %s" $basename [lindex $aa 2]]
		        set GidProcWin(remotemessages) ""
		        SetServerInfoState $channel RESULTSINSERVER
		        CloseChannel $channel
		    }
		}
		SETUP {
		    WarnWin [_ "Analisys '%s' not started. The connection is closed before the data send is concluded" $basename]
		    set GidProcWin(remotemessages) ""
		    SetServerInfoState $channel ERROR
		    CloseChannel $channel
		}
		default {
		    #WarnWinText "Unexpected INFO: '$aa'"
		    WarnWin [_ "Problems with process '%s' terminating it." $basename]
		    set GidProcWin(remotemessages) ""
		    SetServerInfoState $channel ERROR
		    CloseChannel $channel
		}
	    }
	}
	GIVEINFO* {
	    set comm [lrange $aa 1 end]
	    catch { eval $comm } retval
	    PWWriteToSocket $channel $type "GIVEINFO $retval"
	}
	OK* {
	    switch -glob $state {
		IDENTIFYING* {
		    switch [lindex $state 1] {
		        OPENING {
		            SetServerInfoState $channel SETUP
		            PWWriteToSocket $channel $type SETUP
		        }
		        EXECUTING {
		            SetServerInfoState $channel [lrange $state 1 end]
		            PWWriteToSocket $channel $type INFO
		        }
		        KILLING {
		            SetServerInfoState $channel KILLING
		            PWWriteToSocket $channel $type KILLDELETE
		        }
		        KILLINGFORCE {
		            SetServerInfoState $channel KILLINGFORCE
		            PWWriteToSocket $channel $type KILLDELETE
		        }
		        DOWNLOADRESULTS {
		            SetServerInfoState $channel DOWNLOADRESULTS
		            PWWriteToSocket $channel $type INFO
		        }
		        USERINFO {
		            SetServerInfoState $channel USERINFO
		            PWWriteToSocket $channel $type USERINFO
		        }
		        default {
		            WarnWin [_ "Internal error; unknown state: %s" $state]
		        }
		    }
		}
		SETUP {
		    set GidProcWin(lastinfofiles,$channel) "" ;#reset cached filename & size
		    set filesnc [glob [file join $directory $basename*.dat]]
		    set files ""
		    foreach i $filesnc {
		        if { $GidProcWin(serverversion) >= $GidProcWin(requiredserverversion_compress) } {
		            set GidProcWin(remotemessages) [_ "Compressing file '%s'..." $i]
		            set fail [PWCompressFile $i]
		            if { $fail } {
		                ErrorInSocket $channel ANY \
		                        [_ "Error for '%s'. Could not compress file. (Check disk space)." $basename]]
		                return
		            }
		            if { [info exists GidProcWin(userkey,$channel)] && \
		                    $GidProcWin(serverversion) >= $GidProcWin(requiredserverversion_encrypt)} {
		                EncryptFile $i.gz $i.gz $GidProcWin(securemode) encode "$GidProcWin(userkey,$channel)"
		            }
		            append GidProcWin(remotemessages) [_ "Done"]
		            lappend files $i.gz
		        } else {
		            lappend files $i
		        }
		    }
		    set filename [lindex $files 0]
		    SetServerInfoState $channel [list FILETOSERVER $files]
		    PWWriteToSocket $channel $type [list FILETOSERVER [file tail $filename] [file size $filename]]
		}
		FILETOSERVER* {
		    set files [lindex $state 1]
		    set filename [lindex $files 0]
		    set tmpfilename $filename
		    set size [file size $filename]
		    SetServerInfoState $channel [list ENDFILETOSERVER $files]
		    PWBeginCopying $channel $filename $tmpfilename $type $basename $directory $ProblemType \
		            $group $user $password $otherargs $size 1
		}
		ENDFILETOSERVER* {
		    set files [lindex $state 1]
		    set filename [lindex $files 0]
		    if { [file ext $filename] == ".gz" && [file exists [file root $filename]] } {
		        file delete $filename
		    }
		    set files [lrange $files 1 end]
		    if { [llength $files] > 0 } {
		        set filename [lindex $files 0]
		        SetServerInfoState $channel [list FILETOSERVER $files]
		        PWWriteToSocket $channel $type [list FILETOSERVER \
		                [file tail $filename] \
		                [file size $filename]]
		    } else {
		        SetServerInfoState $channel EXECUTING
		        PWWriteToSocket $channel $type "EXECUTE $otherargs"
		    }
		}
		EXECUTING* {
		    set GidProcWin(remotemessages) ""
		    CloseChannel $channel
		}
		FILETOCLIENT* {
		    set files [lindex $state 1]
		    set filenamesize [lindex [lindex $files 0] 0]
		    set filename [file join $directory $filenamesize]
		    set size [lindex [lindex $files 0] 1]
		    #encryption can change the file size, returned "OK filename size"
		    if { [lindex $aa 2] != "" } { set size [lindex $aa 2] }
		    set other [lindex $state 2]
		    SetServerInfoState $channel [list ENDFILETOCLIENT $files $other]
		    set tmpfilename [GidUtils::GetTmpFilename]
		    PWBeginCopying $channel $filename $tmpfilename $type $basename $directory $ProblemType \
		            $group $user $password $otherargs $size 0
		}
		ENDFILETOCLIENT* {
		    set files [lindex $state 1]
		    set filename [lindex [lindex $files 0] 0]
		    set filename [file join $directory $filename]

		    if { [file ext $filename] == ".gz" } {
		        set GidProcWin(remotemessages) [_ "Uncompressing file '%s'..." [file root $filename]]
		        set fail [PWCompressFile $filename 1]
		        if { $fail } {
		            ErrorInSocket $channel ANY \
		                    [_ "Error for '%s'. Could not uncompress file. Check disk space)." $basename]]
		            return
		        }
		        append GidProcWin(remotemessages) done
		        file delete $filename
		    }
		    set files [lrange $files 1 end]
		    set other [lindex $state 2]
		    if { [llength $files] > 0 } {
		        set filename [lindex [lindex $files 0] 0]
		        SetServerInfoState $channel [list FILETOCLIENT $files $other]
		        PWWriteToSocket $channel $type [list FILETOCLIENT \
		                $filename]
		    } else {
		        switch $other {
		            FINISHED {
		                if { $GidProcWin(remoteresultsdelete) == "Automatic" } {
		                    #delete files in the server
		                    SetServerInfoState $channel DELETING
		                    PWWriteToSocket $channel $type KILLDELETE
		                } else {
		                    SetServerInfoState $channel RESULTSINSERVER
		                    set GidProcWin(remotemessages) ""
		                    CloseChannel $channel
		                }
		            }
		            STORE {
		                SetServerInfoState $channel STORING
		                PWWriteToSocket $channel $type STORE
		            }
		            ENDDOWNLOAD {
		                WarnWin [_ "Results of '%s' are downloaded" $basename]
		                if { $GidProcWin(remoteresultsdelete) == "Automatic" } {
		                    #delete files in the server
		                    SetServerInfoState $channel DELETING
		                    PWWriteToSocket $channel $type KILLDELETE
		                } else {
		                    SetServerInfoState $channel RESULTSINSERVER
		                    set GidProcWin(remotemessages) ""
		                    CloseChannel $channel
		                }
		            }
		            UPDATE {
		                SetServerInfoState $channel EXECUTING
		                set GidProcWin(remotemessages) ""
		                CloseChannel $channel
		            }
		            default {
		                set GidProcWin(remotemessages) ""
		                CloseChannel $channel
		            }
		        }
		    }
		}
		DELETING {
		    set GidProcWin(remotemessages) [_ "Analysis has finished"]
		    after 5000  [list set GidProcWin(remotemessages) {}]
		    SetServerInfoState $channel FINISHED
		    CloseChannel $channel
		    after idle ActualizeProcInfo autoupdate
		}
		STORING {
		    set GidProcWin(remotemessages) [_ "Analysis has finished: results stored in the server."]
		    after 5000  [list set GidProcWin(remotemessages) {}]
		    SetServerInfoState $channel RESULTSINSERVER
		    CloseChannel $channel
		    after idle ActualizeProcInfo autoupdate
		}
		KILLING {
		    if { $state != "KILLINGFORCE" } {
		        WarnWin [_ "Process '%s' has been terminated on the server" $basename]
		    }
		    set GidProcWin(remotemessages) ""
		    SetServerInfoState $channel ERROR
		    CloseChannel $channel
		    after idle ActualizeProcInfo
		    #set GidProcWin(killed) 1
		}
	    }
	}
	"" {
	    #nothing
	}
	default {
	    after idle WarnWin [list [_ "Error: unknown subcommand from server '%s'" $aa]]
	    #.central.s OutPutPrintedMessages
	}

    }
}

proc PWBeginCopying { channel filename tmpfilename type basename directory ProblemType \
	group user password otherargs size { toserver 0 } } {
    global GidProcWin

    #PWdebugprint "enter PWBeginCopying file=$filename size=$size"

    fileevent $channel readable ""
    if { [catch {
	if { !$toserver } {
	    set otherchannel [open $tmpfilename w]
	    set GidProcWin(remotemessages) \
		    [_ "Transferring to client '%s' ... 0%% of %s KB" $filename [expr $size/1024]]
	} else  {
	    set otherchannel [open $tmpfilename r]
	    set GidProcWin(remotemessages) \
		    [_ "Transferring to server '%s' ... 0%% of %s KB" $filename [expr $size/1024]]
	}
    } err] } {
	ErrorInSocket $channel $type [_ "Problems opening files (%s). Correct the problem and try again." $err]
	return
    }

    fconfigure $channel -translation binary
    fconfigure $otherchannel -translation binary
    set inc 10000
    if { $inc > $size } {
	set inc $size
    }
    if { $size == 0 } {
	PWFinishedCopying $channel $otherchannel $filename $tmpfilename $type $basename \
		$directory $ProblemType $group $user $password $otherargs 0 $size $toserver 0
    } elseif { !$toserver } {
	fcopy $channel $otherchannel -size $inc \
		-command [list PWFinishedCopying $channel $otherchannel $filename $tmpfilename $type $basename \
		$directory $ProblemType $group $user $password $otherargs 0 $size $toserver]
    } else {
	fcopy $otherchannel $channel -size $inc \
		-command [list PWFinishedCopying $channel $otherchannel $filename $tmpfilename $type $basename \
		$directory $ProblemType $group $user $password $otherargs 0 $size $toserver]
    }

}

proc PWFinishedCopying { channel otherchannel filename tmpfilename type basename directory ProblemType \
	group user password otherargs acumm size toserver bytes {error {}} } {
    global GidProcWin

    PWCancelTimeout $channel

    incr acumm $bytes
    #PWdebugprint "Enter PWFinishedCopying acumm=$acumm size=$size"
    if { $error == "" } {
	if { $acumm == $size } {
	    set percent 100
	} else { set percent [expr int(double($acumm)/$size*100)] }
	
	if { !$toserver } {
	    set GidProcWin(remotemessages) \
		    [_ "Transferring to client '%s' ... %s%% of %s KB" $filename $percent [expr $size/1024]]
	} else  {
	    set GidProcWin(remotemessages) \
		    [_ "Transferring to server '%s' ... %s%% of %s KB" $filename $percent [expr $size/1024]]
	}
    }
    update

    #PWdebugprint "middle PWFinishedCopying acumm=$acumm size=$size"
    if { $acumm < $size && $error == "" } {
	set inc 10000
	if { [expr $acumm+$inc] > $size } {
	    set inc [expr $size-$acumm]
	}
	if { !$toserver } {
	    after idle [list fcopy $channel $otherchannel -size $inc \
		    -command [list PWFinishedCopying $channel $otherchannel $filename $tmpfilename $type $basename \
		    $directory $ProblemType $group $user $password $otherargs $acumm \
		    $size $toserver]]
	    return
	} else {
	    after idle [list fcopy $otherchannel $channel -size $inc \
		    -command [list PWFinishedCopying $channel $otherchannel $filename $tmpfilename $type $basename \
		    $directory $ProblemType $group $user $password $otherargs $acumm \
		    $size $toserver]]
	    return
	}
    }
    if { !$toserver } {
	set GidProcWin(remotemessages) [_ "Transferred to client '%s' ... " $filename]
    } else {
	set GidProcWin(remotemessages) [_ "Transferred to server '%s' ... " $filename]
    }
    update

    #PWdebugprint "middle PWFinishedCopying"
    close $otherchannel
    fconfigure $channel -translation auto
    if { $toserver } { flush $channel }
    if { $error != "" } {
	ErrorInSocket $channel $type \
		[_ "Connection to server '%s' has failed (%s)." $server $error]
	return
    }


    fileevent $channel readable [list PWReadFromSocket $channel $type $basename \
	    $directory $ProblemType \
	    $group $user $password $otherargs]

    if { !$toserver } {
	if { [info exists GidProcWin(userkey,$channel)] && \
		$GidProcWin(serverversion) >= $GidProcWin(requiredserverversion_encrypt)} {
	    #it is a copy in tmpfilename of the requested filename, encripted before send to the client
	    EncryptFile $tmpfilename $filename $GidProcWin(securemode) decode "$GidProcWin(userkey,$channel)"
	} else {
	    if { $tmpfilename != $filename } { file copy -force $tmpfilename $filename }
	}
    }
    if { $tmpfilename != $filename } { file delete $tmpfilename }

    PWWriteToSocket $channel $type OK
    #PWdebugprint "leaving PWFinishedCopying"
}

proc EncryptFile { filein fileout securemode operation key } {
    if { ![file exists $filein] } return
    set aa ""
    if { [file size $filein] } {
	set fin [open $filein r]
	fconfigure $fin -translation binary
	set aa [encrypter $securemode $operation "$key" "[read $fin]"]
	close $fin
    }
    set fileoutdir [file dirname $fileout]
    if { ![file isdirectory $fileoutdir] } {
	file mkdir $fileoutdir
    }
    set fout [open $fileout w]
    fconfigure $fout -translation binary
    puts -nonewline $fout $aa
    close $fout
}


#Command type can be DOWNLOADRESULTS, KILLING, KILLINGFORCE
proc PWBeginCommand { type basename } {
    global RunProcInfo GidProcWin env

    if { ![info exists GidProcWin(w)] } {
	set w .gid.tempwin
    } else {
	set w $GidProcWin(w).tempwin
    }

    if { ![info exists GidProcWin(remoteport)] } {
	set GidProcWin(remoteport) 2048
    }
    set port $GidProcWin(remoteport)

    if { [info exists env(PROCSERVER_PORT)] } {
	set port $env(PROCSERVER_PORT)
    }

    set ipos 0
    set i ""
    foreach i $RunProcInfo {
	set name [lindex $i 0]
	if { $name == $basename } {
	    break
	}
	incr ipos
    }
    if { $i == "" || $ipos >= [llength $RunProcInfo] } { return }
	
    set channel [lindex $i 8]
    if { $channel != "" } {
	set GidProcWin(remotemessages) ""
	CloseChannel $channel
    }

    set GidProcWin(remoteserver) [lindex $i 6]
    set GidProcWin(remotegroup) [lindex [lindex $i 7] 0]
    set GidProcWin(remoteuser) [lindex [lindex $i 7] 1]
    if { ![info exists GidProcWin(Password,$GidProcWin(remoteserver),$GidProcWin(remotegroup),$GidProcWin(remoteuser))] } {
	PWAskForServer $w [_ "Password for remote server"] \
	    [_ "Enter the remote server for problem '%s'" $basename]: [_ "OK"] 1

	if { $GidProcWin(exec) == 0 } {
	    if { $type=="KILLING" || $type=="KILLINGFORCE" } {
		set text [_ "Do you want to consider locally the process as terminated?"]
		set retval [tk_dialogRAM .gid.errorwin [_ "Dialog window"] $text \
		        warning 0 [_ "Yes"] [_ "Cancel"]]
		if { $retval == 0 } {
		    WarnWin [_ "Process '%s' has been locally terminated" $basename]
		    set newi [lreplace $i 9 9 ERROR]
		    set RunProcInfo [lreplace $RunProcInfo $ipos $ipos $newi]
		    after idle ActualizeProcInfo
		    set GidProcWin(remotemessages) ""
		}
	    }
	    return
	}
    }
	


    if { [catch {
	set channel [socket -async $GidProcWin(remoteserver) $port]
	catch { unset GidProcWin(userkey,$channel) } ;#until encrypted transmission must be unset
    } err] } {
	ErrorInSocket $channel OPENING \
		[_ "Connection to server '%s' for project '%s' has failed (%s)." $GidProcWin(remoteserver) $basename $err]
	return
    }

    set newi [lreplace $i 8 8 $channel]
    set RunProcInfo [lreplace $RunProcInfo $ipos $ipos $newi]

    set directory [lindex $i 10]
    set ProblemType [lindex $i 11]
    set otherargs [lindex $i 12]

    fconfigure $channel -blocking 0
    SetServerInfoState $channel $type
    fileevent $channel readable [list PWReadFromSocket $channel $type $basename \
	    $directory $ProblemType $GidProcWin(remotegroup) $GidProcWin(remoteuser) \
	    $GidProcWin(Password,$GidProcWin(remoteserver),$GidProcWin(remotegroup),$GidProcWin(remoteuser)) \
	    $otherargs]
    if { ![info exists GidProcWin(remotetimeout)] } {
	set GidProcWin(remotetimeout) 30
    }
    PWTimeout $channel $type
}


proc PWdebugprint { text } {
    #disconnected
    return
    global env PWdebugf tcl_platform

    if { ![info exists PWdebugf] } {
	if { $tcl_platform(platform) == "windows" } {
	    set file [file join $env(TEMP) kk.dat]
	} else {
	    set file /tmp/kk.dat
	}
	set PWdebugf [open $file w]
    }
    puts $PWdebugf "[clock format [clock seconds] -format "%d %b %Y %H:%M:%S"] $text"
    flush $PWdebugf
}




# Allow interface to be run "stand-alone" for testing

# catch {
#     if [info exists embed_args] {
#         # we are running in the plugin
#         ProcWin_ui .
#     } else {
#         # we are running in stand-alone mode
#         if {$argv0 == [info script]} {
#             wm title . "Testing ProcWin_ui"
#             ProcWin_ui .
#         }
#     }
# }


proc GidConnectGetChannel { remoteserver } {
    global GidConnections
    set channel ""
    foreach i [array names GidConnections *,remoteserver]] {
	if { [lindex [split $i ,] 1] == $remoteserver } {
	    set channel [lindex [split $i ,] 0]
	    break
	}
    }
    return $channel
}

proc GidConnectCloseChannel { channel } {
    global GidConnections
    array unset GidConnections $channel,*
    return
}

proc GidConnectSetRemoteServer { channel remoteserver } {
    global GidConnections
    set GidConnections($channel,remoteserver) $remoteserver
}

proc GidConnectGetRemoteServer { channel } {
    global GidConnections
    set remoteserver ""
    if { [info exists GidConnections($channel,remoteserver)] } {
	set remoteserver $GidConnections($channel,remoteserver)
    }
    return $remoteserver
}

proc GidConnectSetState { channel state } {
    global GidConnections
    set GidConnections($channel,state) $state
}

proc GidConnectGetState { channel } {
    global GidConnections
    set state ""
    if { [info exists GidConnections($channel,state)] } {
	set state $GidConnections($channel,state)
    }
    return $state
}


#funcions finding in RunProcInfo and also in GidConnections

proc SomeChannelIsOpen { remoteserver } {
    global RunProcInfo GidProcWin
    set channel ""
    foreach i $RunProcInfo {
	set channel [lindex $i 8]
	if { $channel != "" } {
	    break
	}
    }
    if { $channel == "" } {
	set channel [GidConnectGetChannel $GidProcWin(remoteserver)]
    }
    return $channel
}

proc GiveServerInfoState { channel } {
    #find channel in RunProcInfo (asociated to a calculation)
    set state [ GiveRunProcInfoState $channel ]
    #find channel in GidConnect (asociated to a server, but not to a calculation)
    #for example to ask some server info without calculate
    if { $state == "" } {
	set state [GidConnectGetState $channel]
    }
    return $state
}

#return 1 it fail
proc SetServerInfoState { channel state } {
    #find channel in RunProcInfo (asociated to a calculation)
    set fail [ SetRunProcInfoState $channel $state]
    #find channel in GidConnect (asociated to a server, but not to a calculation)
    #for example to ask some server info without calculate
    if { $fail } {
	set fail [GidConnectSetState $channel $state]
    }
    return $fail
}

proc SetServerCloseChannel { channel } {
    set fail [SetRunProcInfoCloseChannel $channel]
    if { $fail } {
	set fail [GidConnectCloseChannel $channel]
    }
    return fail
}


#open a generic channel not related to a specific basename
#Command type can be USERINFO, or in future DOWNLOADPROBLEMTYPE for example
proc PWMainRemoteCommand { type } {
    global GidProcWin env GidConnections

    if { ![info exists GidProcWin(remoteport)] } {
	set GidProcWin(remoteport) 2048
    }

    PWAskForServer $GidProcWin(w).calcremote [_ "Remote server"] \
	[_ "Enter the server information"]: [_ "Ok"]
    if { $GidProcWin(exec) == 0 } {
	return
    }

#     if { ![info exists GidProcWin(remoteserver)] ||
#         ![info exists GidProcWin(remotegroup)] ||
#         ![info exists GidProcWin(remoteuser)] ||
#         ![info exists GidProcWin(Password,$GidProcWin(remoteserver),$GidProcWin(remotegroup),$GidProcWin(remoteuser))]
#     } {
#         PWAskForServer .gid [_ "Remote calculate"] \
#             [_ "Enter the server to perform the remote calculation"]: [_ "Calculate"]
#         if { $GidProcWin(exec) == 0 } {
#             return
#         }
#     }

    if { [SomeChannelIsOpen $GidProcWin(remoteserver)] != "" } {
	return
    }

    #set channel [GidConnectGetChannel $GidProcWin(remoteserver)]
    #if { $channel != "" } {
    #    CloseChannel $channel
    #    set channel ""
    #}

    if { [catch {
	set channel [socket -async $GidProcWin(remoteserver) $GidProcWin(remoteport)]
	catch { unset GidProcWin(userkey,$channel) } ;#until encrypted transmission must be unset
    } err] } {
	WarnWin [_ "Connection to server has failed (%s). Try again" $err]
	return
    }

    set ProblemType [GiD_Info Project ProblemType]
    set ProjectName [GiD_Info Project ModelName]
    if { [file extension $ProjectName] == ".gid" } {
	set ProjectName [file root $ProjectName]
    }
    set basename [file tail $ProjectName]
    set directory $ProjectName.gid
    if { [file pathtype $directory] == "relative" } {
	set directory [file join [pwd] $directory]
    }
    set otherargs ""

    fconfigure $channel -blocking 0
    fileevent $channel readable [list PWReadFromSocket $channel $type \
	    $basename $directory $ProblemType $GidProcWin(remotegroup) $GidProcWin(remoteuser) \
	    $GidProcWin(Password,$GidProcWin(remoteserver),$GidProcWin(remotegroup),$GidProcWin(remoteuser)) \
	    $otherargs]

    GidConnectSetRemoteServer $channel $GidProcWin(remoteserver)
    GidConnectSetState $channel $type

    PWTimeout $channel $type

    return
}

proc FormattedTime { time } {
    set format  "%d %b %Y %H:%M:%S"
    return [clock format $time -format $format]
}

proc ShowServerUserInfo { aa } {
    #format the user information
    set text ""
    append text [_ "General process"]: "\n"
    append text "****************\n"
    append text [_ "Running: %s" [lindex [lindex $aa 2] 0]] "\n"
    append text [_ "Waiting: %s" [lindex [lindex $aa 2] 1]] "\n"
    append text "\n"
    append text [_ "User process"]: "\n"
    append text "*************\n"
    if { [lindex $aa 3] == "" } {
	append text [_ "None"] "\n"
    } else {
	append text [format "%-16s %-8s %-24s %-8s\n" [_ "Name"] [_ "Status"] \
		[_ "StartTime"] [_ "Disk KB"]]
	foreach i [lindex $aa 3] {
	    append text [format "%-16s %-8s %-24s %-8.1f\n" [lindex $i 0] \
		    [string tolower [lindex $i 1]] [FormattedTime [lindex $i 2]] \
		    [expr [lindex $i 3]/1024.0]]
	}
    }
    append text "\n"
    append text [_ "Available user groups"]: "\n"
    append text "**********************\n"
    foreach i [lindex $aa 4] {
	append text $i "\n"
    }
    #to delete previous text widget contents
    if { [winfo exists .gid.warning] } {
	destroy .gid.warning
    }
    WarnWinText $text [_ "Information from server %s" [lindex $aa 1] ]
    #set fixed font to align columns
    .gid.warning.fr.t configure -font FixedFont
}

proc CloseChannel { channel } {
    #for debug
    for { set i [info level] } { $i>0} {incr i -1 } {
	PWdebugprint "proc [info level $i]"
    }

    SetServerCloseChannel $channel
    catch { close $channel }
}
