# Tcl package index file

proc LoadLibraryGdal { dir basename } {
    package require objarray
    if { $::tcl_platform(pointerSize) == 8} {
	set bits 64
    } else {
	set bits 32
    }
    set library ${basename}_${bits}[info sharedlibextension]    
    load [file join $dir $library] $basename
    #load {C:\gid project\gidvs\Debug\gdal_32.dll} gdal ;#debug
}

package ifneeded gdal 1.0 [list LoadLibraryGdal $dir gdal]