
set Version 1.0
proc LoadLognoter { dir version } {
    set argv ""
    if { [interp exists lognoter] } {
	if { [lognoter eval info exists argv] } {
	    set argv [lognoter eval set argv]
	}
	interp delete lognoter
    }
#     interp create lognoter_intp
    if { ![interp exists lognoter_intp] } {
	interp create lognoter_intp
    }
    lognoter_intp eval [list load {} Tk]
    lognoter_intp eval package require Tk
    lognoter_intp eval wm withdraw .
    if { ![lognoter_intp eval info exists argv] } {
	lognoter_intp eval [list set argc 0]
	lognoter_intp eval [list set argv $argv]
    }
    lognoter_intp eval lappend auto_path $::auto_path
    #lognoter_intp eval [list set auto_path $::auto_path]
    lognoter_intp eval [list set argv0 [file join $dir lognoter.tcl]]
    catch { lognoter_intp hide exit }
    lognoter_intp alias exit EndLoadLognoter
    lognoter_intp eval package provide Lognoter $version
    lognoter_intp eval [list source [file join $dir lognoter.tcl]]
    package provide Lognoter $version
}
proc EndLoadLognoter {} {
    interp delete lognoter_intp
    package forget Lognoter
}
if {![package vsatisfies [package provide Tcl] 8.5]} {return}
package ifneeded Lognoter $Version [list LoadLognoter $dir $Version]
package ifneeded lognoter_db 1.0 [list source [file join $dir tcl lognoter_db.tcl]]
