

window.onload = function() {
    cu_tableHeader();
    cu_slideHeader(); 
}

function noUpdate() { return true }




// USERS LOGIN / REGISTER




function handle_user(base_path, page, SSL_option, is_logged, is_admin, is_demo, is_demo_active, demo_form, demo_step, demo_loop, lan) {

    _base_path = base_path;
    _page = page;

    _UMS_enabled = '1';

    _SSL_option = SSL_option;  
    
    _is_logged = is_logged;
    _is_admin = is_admin;
    
    _is_demo = is_demo;
    _is_demo_active = is_demo_active;
    _demo_form = demo_form;
    _demo_step = demo_step;
    _demo_loop = demo_loop;

    _lan = lan;
            
    handleDoUser();
}

function handleDoUser() {

    require(['dojo/ready','dojo/dom','dojo/on','dijit/Tooltip','dijit/form/Button','dijit/Dialog'], function(ready, dom, on, Tooltip) {

	    ready(function() { 

            var EditM_UImageSrc = _base_path + '/int/js/custom/images/user.png';
	    	var EditM_NImageSrc = _base_path + '/int/js/custom/images/notifications.png';
	    	var EditM_NewUImageSrc = _base_path + '/int/js/custom/images/user_plus.png';
            var EditM_LogoImageSrc = _base_path + '/int/js/custom/images/Lognoter_logo.png';
            
            cu_preloadEditMenuImages([EditM_UImageSrc, EditM_NImageSrc, EditM_NewUImageSrc, EditM_LogoImageSrc]).done(function(images) {
	    	    cu_fadeIn('editmenu'); 
        	});
        	
	        if (_is_logged == '0') {

	            if (_is_demo == '1' && dom.byId('democontents') != null) {
			        cu_showWizard();

                } else {
 
			        if (_is_admin == '0') {
	                    on(dom.byId('loginUserLink'), 'click', function() {
                            uL_dialog();
		                });

			        } else {
		                on(dom.byId('loginUserLink'), 'click', function() {
                        	uR_admin_dialog();
		                });
		            }
                }

            } else {

	            on(dom.byId('loginUserLink'), 'click', function() {
	                uL_logout();
	            });

                updateEditMenu();
            }
        });
    });
}

function updateEditMenu() {

    require(['dojo/dom','dojo/dom-class','dojo/on','dojo/_base/xhr','dijit/Tooltip'], function(dom, domClass, on, xhr, Tooltip) {
        
        xhr.post({
            url: _base_path + '/' + _page + '/user_data/check/?',
            handleAs: 'json',
            preventCache: true,
            load: function(jsonData) {
            
                var view_n_contents = jsonData.view_n_contents.toString();
                var view_admin_n_contents = jsonData.view_admin_n_contents.toString();
                var view_n_class = jsonData.view_n_class.toString();
                var num_n = jsonData.num_n.toString();
                var num_admin_n = jsonData.num_admin_n.toString();

			    if (dom.byId('wizardNotifStep3a')) {
		            dom.byId('wizardNotifStep3a').innerHTML = view_n_contents + ' !';
                }

		        if ( view_n_class == 'show' ) {
		            domClass.remove('notifications_menu_num', 'hide');
		        } else {
		            domClass.add('notifications_menu_num', 'hide');
		        }
		        dom.byId('notifications_menu_num').innerHTML = num_n;
		        dom.byId('notifications_menu_text').innerHTML = view_n_contents;
            }
        });
   });
}

function uL_dialog() {

    var PLImageSrc = _base_path + '/int/js/custom/images/preloader_2.gif';
    var PLImageButtonSrc = _base_path + '/int/js/custom/images/preloader.gif';
    
    cu_preloadImages([PLImageSrc, PLImageButtonSrc]).done(function(images) { 
        uL_showDialog(); 
    });
}

function uL_showDialog() {

    require(['dojo/ready','dojo/dom','dojo/dom-construct','dojo/on','dojo/parser','dojo/_base/xhr','dojo/keys','dijit/Dialog',
             'dijit/form/Form','dijit/form/ValidationTextBox','dijit/form/CheckBox','dijit/form/Button','dijit/layout/ContentPane'], 

    function(ready, dom, domConstruct, on, parser, xhr, keys, dialog) {

        var PLIconSrc = _base_path + '/int/js/custom/images/preloader_2.gif';
        var PLIconNode = "<img id='usersDialogLoginPLIcon' class='hidden' width='35' src='" + PLIconSrc + "'></img>";

        if (_is_demo == '1') {
            var titleNode = "<h3 class='header contents'>Login<span class='demoRTitle'>Live Demo</span></h3>";
        } else {
	        var titleNode = "<h3 class='header contents'>Login</h3>";
	    }
        var refNode = "<div id='d_contents' style='display: none;opacity: 0'></div>";

        var PLNode_ = titleNode + refNode + "<table id='usersDialogLoginPL' class='usersDialogLoginPL'>";
        var PLNode = PLNode_ + "<tr><td>" + PLIconNode + "</td></tr></table>";

        var usersDialog = dijit.byId('usersDialog');
        if (usersDialog) { usersDialog.destroyRecursive(); }

        if (_SSL_option == '1') {
            var loginDialogClass = 'loginDialogSSL';
        } else {
            var loginDialogClass = 'loginDialogNoSSL';
        }

        var dlg = new dialog ({ 
	        id: 'usersDialog',
	        'class': 'usersDialog loginDialog ' + loginDialogClass,
	        executeScripts: true,
	        scriptHasHooks: true,
	        content: PLNode
	    });

        cu_dlgShow(dlg);

        setTimeout(function() { uLR_GL(); }, 500);

        xhr.post({
            url: _base_path + '/login/login',
            postData: { 'what': 'login' },
            handleAs: 'text', 
            load: function(data) {	            

                var mainNode = dom.byId('d_contents');
                domConstruct.place(data, mainNode, 'first');

                parser.parse('d_contents'); 
                
                ready(function() { 

		            on(dom.byId('login'), 'keydown', function(e) {
                        if (e.keyCode == keys.ENTER) {
                            dom.byId('loginButton').click();
                        }
                    });

                    var handler = on.pausable(dom.byId('loginButton'), 'click', function() {
                        dijit.byId('loginButton').set('disabled', 'disabled');
                        handler.pause();
	                    uL_login(dlg, handler);
		            });

                    if (_SSL_option == '1') {

		                var _base_path_array = _base_path.split('/');
		                var lan_path = _base_path_array[_base_path_array.length-1];

		                var base_path = _base_path;
		                if (lan_path == _lan) { 
		                    _base_path_array.splice(-1);
		                    base_path = _base_path_array.join('/'); 
		                }

                        on(dom.byId('loginRegCertButton'), 'click', function() {
                            uLR_clearStatus(); 
		                    uLR_showPL();

                            xhr.post({
                                url: base_path + '/users/certificates/select/login',
			                    postData: { 'dummy': 'dummy' },
                                handleAs: 'text',
                                load: function(data) {
                                    uL_manageCertificates(data);  
				                    if (data.match(/ACTIVE--*/) || data.match(/NEW--*/)) {
				                        dijit.byId('loginButton').set('disabled', false);
				                        handler.resume();
                                    }          
                                }
                            }); 
                        });

		                on(dijit.byId('loginRegCertCheckBox'), 'click', function() {
		                    var value = dijit.byId('loginRegCertCheckBox').get('checked');
                            if (value == true) { 
                                handler.pause();                   
                            } else {
                                handler.resume();
                            }   
		                });
                    }

                    if (dom.byId('registerButton')) {
                        on(dom.byId('registerButton'), 'click', function() {
			                uLR_clearStatus(); 
		                    uLR_showPL();
	                        uR_dialog(dlg);
		                });
		            }

                    on(dom.byId('loginButtonCancel'), 'click', function() {
		                dom.byId('login').reset();
		                uLR_clearStatus();
	                    dlg.hide();
	                });

                    uLR_show();
                    dijit.byId('username').focus();
                });
	        }
        });
    });
}

function uL_manageCertificates(data) {

    var ldata = data.split('--');
  
    var status = ldata[0];
    var id = ldata[1];
    var data = ldata[2];

    if (status == 'ACTIVE') {
		uLR_showStatus('true', data);
		
		require(['dojo/dom'], function(dom) {
            dom.byId('id_cert').setAttribute('value', id);
        });

	} else {
		uLR_showStatus('false', data);                               
    }
    
    require(['dojo/dom','dojo/on'], function(dom, on) {
        var handler = on(dom.byId('usersDialogStatus_info'), 'click', function() {
            uLR_viewCertificate(handler, status, id, data);
	    });
    });       

    uLR_showInfo(); 
}

function uR_manageCertificates(data) {

    var ldata = data.split('--');
  
    var status = ldata[0];
    var id = ldata[1];
    var data = ldata[2];

    if (status == 'ACTIVE' || status == 'NEW' || status == 'REVOKED') {
        var cert_tick = 'false';
        var cert_text = data;
        
	    uLR_showStatus(cert_tick, cert_text);

    } else if (status == 'EXPIRED') {
        var cert_tick = 'false';
        var cert_text = data;
        
	    uLR_showStatus(cert_tick, cert_text);
			                                    
    } else if (status == 'NONE') {
	    var lcontents = data.split('-*/*-');

        if (dijit.byId('firstname')) { dijit.byId('firstname').set('disabled',false); }
	    if (dijit.byId('surname')) { dijit.byId('surname').set('disabled',false); }
        if (dijit.byId('companyname')) { dijit.byId('companyname').set('disabled',false); }
        if (dijit.byId('companyVAT')) { dijit.byId('companyVAT').set('disabled',false); }
	    dijit.byId('username').set('disabled',false);

        if (lcontents[0] != '' && dijit.byId('firstname')) { dijit.byId('firstname').set('value',lcontents[0]); }
	    if (lcontents[1] != '' && dijit.byId('surname')) { dijit.byId('surname').set('value',lcontents[1]); }
        
        require(['dojo/dom'], function(dom) {
            dom.byId('id_cert').setAttribute('value', id);
        });
        
        dijit.byId('loginButton').set('disabled', false);

        var cert_tick = 'true';
        var cert_text = lcontents[2];
	    uLR_showStatus(cert_tick, cert_text);
		
    } else {
	    var cert_tick = 'false';
	    var cert_text = data;
	    
	    uLR_showStatus(cert_tick, cert_text);                                
    }

    _cert_check = cert_tick + '*/*' + cert_text;
    
    require(['dojo/dom','dojo/on'], function(dom, on) {
        var handler = on(dom.byId('usersDialogStatus_info'), 'click', function() {
            uLR_viewCertificate(handler, status, id, data);
	    });
    });
    
    uLR_showInfo();
}

function uLR_viewCertificate(handler, status, id, data) {

    require(['dojo/dom','dojo/dom-construct','dojo/dom-class','dojo/dom-style','dojo/on','dojo/parser','dojo/io/iframe','dojo/query',
             'dijit/Dialog','dojo/_base/fx'], 
    
    function(dom, domConstruct, domClass, domStyle, on, parser, ioIframe, query, dialog, fx) {

        ioIframe.send({
	        url: _base_path + '/users/certificates/view',
	        handleAs: 'html',
	        preventCache: true,
	        content: { register: '1', status: status, id: id, data: data },
	        load: function(data) {

                data = data.body.innerHTML;   
                var ldata = data.split('-*/*-');

                if ( ldata[0] == 'OK' ) {

	                var contents = ldata[1]; 
	                var lstatus = ldata[2];
      
	                if (lstatus == 'active') {
                        var print = 'Certificate active';
                        var StSrc = './../int/js/custom/images/users/validations/valid.jpg';
		            } else if (lstatus == 'new') {
                        var print = 'Certificate pending to be validated';
                        var StSrc = './../int/js/custom/images/users/validations/new.jpg';
                    } else if (lstatus == 'expired') {
                        var print = 'Certificate expired';
                        var StSrc = './../int/js/custom/images/users/validations/expired.jpg';
                    } else if (lstatus == 'revoked') {
                        var print = 'Certificate revoked';
                        var StSrc = './../int/js/custom/images/users/validations/revoked.jpg';
                    } else {
                        var print = 'Certificate not registered yet';
			            var StSrc = './../int/js/custom/images/users/validations/none.jpg';
                    }
            
                    domStyle.set('login', 'display', 'none');

                    var mainNode = dom.byId('u_contents');
                    
                    domConstruct.place(contents, mainNode, 'last');

                    domClass.add('certD_val', 'hidden');

    		        var StImage = new Image();
    		        StImage.src = StSrc;
  
    		        StImage.onload = function() {
			            var StIconNode = "<img width='40' height='35' src='" + StSrc + "'></img>";
                        dom.byId('certD_val').innerHTML = "<table><td>" + StIconNode + "</td><td class='certInfoStatus'>" + print + "</td></table>";

                        domStyle.set('certD_val', 'display', 'block');
                        cu_fadeIn('certD_val');
    		        }

                } else {

                    var msgError = ldata[1];
                    
                    domStyle.set('login', 'display', 'none');
 
                    var mainNode = dom.byId('u_contents');
                    domConstruct.place(msgError, mainNode, 'last');
                }

                if (_SSL_option == '1') {
		            domClass.remove('usersDialog', 'loginDialogSSL');
			    domClass.remove('usersDialog', 'loginRDialogSSL');
        	    } else {
            	    domClass.remove('usersDialog', 'loginDialogNoSSL');
			domClass.remove('usersDialog', 'loginRDialogNoSSL');
        	    }
                
                query('#usersDialog .dijitDialogPaneContent').forEach(function(node, index, arr) {  
	    	        domStyle.set(node, 'paddingBottom', '0');
		        });

                dijit.byId('usersDialog').resize();
                    
                parser.parse('certificateDialog');
                    
                on(dom.byId('certButtonPrevious'), 'click', function() {
		            uLR_viewCertificateBackwards(handler);
                });
                    
                on(dom.byId('certButtonClose'), 'click', function() {
	                dijit.byId('usersDialog').hide();
		        }); 
	        }
        });
    });
}

function uLR_viewCertificateBackwards(handler) {

    require(['dojo/dom','dojo/on','dojo/dom-construct','dojo/dom-style'], function(dom, on, domConstruct, domStyle) {
        
        domStyle.set('login', 'display', '');
        domStyle.set('certificateDialog', 'display', 'none');
        
        domConstruct.empty('certificateDialog');
        domConstruct.destroy('certificateDialog');

        dijit.byId('certButtonPrevious').destroyRecursive();
        dijit.byId('certButtonClose').destroyRecursive();
        
        on(dom.byId('loginRegCertButton'), 'click', function() {
            handler.remove();                   
		});
		
		if (dom.byId('registerButton')) {
            on(dom.byId('registerButton'), 'click', function() {

			    handler.remove();    
		    });
		}
        
        dijit.byId('usersDialog').resize();
    });
}


function uR_admin_dialog() {

    var PLImageButtonSrc = _base_path + '/int/js/custom/images/preloader.gif';
    
    cu_preloadImages([PLImageButtonSrc]).done(function(images) { 
        uR_showAdmin_dialog();
    });
}


function uR_showAdmin_dialog() {

    require(['dojo/ready','dojo/dom','dojo/dom-construct','dojo/on','dojo/_base/xhr','dojo/keys','dijit/Dialog','dojo/query',
             'dijit/form/Form','dijit/form/ValidationTextBox','dijit/form/CheckBox','dijit/form/Button','dijit/layout/ContentPane'], 

    function(ready, dom, domConstruct, on, xhr, keys, dialog, query) {

        xhr.post({
            url: _base_path + '/login/create_admin',
            postData: { 'what': 'create_check' },
            handleAs: 'text', 
            load: function(data) {
                	            
                var usersDialog = dijit.byId('usersDialog');
                if (usersDialog) { usersDialog.destroyRecursive(); }
                
                if (_SSL_option == '1') {
                    var loginRDialogClass = 'loginRDialogSSL';
                } else {
                    var loginRDialogClass = 'loginRDialogNoSSL';
                }

                var dlg = new dialog ({ 
		            id: 'usersDialog',
		            'class': 'usersDialog loginDialog ',
		            executeScripts: true,
		            scriptHasHooks: true,
		            content: data
		        });

		        dlg.startup();

		        on(dom.byId('login'), 'keydown', function(e) {
                    if (e.keyCode == keys.ENTER) {
                        dom.byId('loginButton').click();
                    }
                });

                if (_is_demo == '1') {
                    var handler = on.pausable(dom.byId('loginButton'), 'click', function() {
			            dijit.byId('loginButton').set('disabled', 'disabled');
                        handler.pause();
                        uR_createAccount(dlg, handler);
	                });
	                
	                var titleNode = "<h3 class='header contents'>Sign up<span class='demoRTitle'>Live Demo</span></h3>";     
                    query('.usersDialog h3').forEach(function(h3, index, arr) {
	                    domConstruct.place(titleNode, h3, 'replace');
                    });

		        } else {
		            var handler = on.pausable(dom.byId('loginButton'), 'click', function() {
				        dijit.byId('loginButton').set('disabled', 'disabled');
		                handler.pause();
			            uR_checkAccount(dlg, handler);
	                });
                }

		        if (_SSL_option == '1') {

		            var _base_path_array = _base_path.split('/');
		            var lan_path = _base_path_array[_base_path_array.length-1];

		            var base_path = _base_path;
		            if (lan_path == _lan) { 
		                _base_path_array.splice(-1);
		                base_path = _base_path_array.join('/'); 
		            }

                    on(dom.byId('loginRegCertButton'), 'click', function() {
                        uLR_clearStatus(); 
		                uLR_showPL();

                        xhr.post({
                            url: base_path + '/users/certificates/select/register',
			                postData: { 'dummy': 'dummy' },
                            handleAs: 'text',
                            load: function(data) {
                                uR_manageCertificates(data); 
			                    if (data.match(/NONE--*/)) {
				                    handler.resume();
                                }             
                            }
                        }); 
                    });

		            on(dijit.byId('loginRegCertCheckBox'), 'click', function() {
		                var value = dijit.byId('loginRegCertCheckBox').get('checked');
                        if (value == true) { 
                            handler.pause();                   
                        } else {
                            handler.resume();
                        }   
		            });
                }

                on(dom.byId('loginButtonCancel'), 'click', function() {    
	                dlg.hide();
	            }); 

                if (dijit.byId('firstname')) { 
                    dijit.byId('firstname').focus(); 
                } else if (dijit.byId('surname')) { 
                    dijit.byId('surname').focus(); 
                } else if (dijit.byId('companyname')) { 
                    dijit.byId('companyname').focus(); 
                } else if (dijit.byId('companyVAT')) { 
                    dijit.byId('companyVAT').focus(); 
                } else {
                    dijit.byId('username').focus(); 
                }

                cu_dlgShow(dlg);
	        }
	    });
    });
}

function uR_wizard_dialog() {

    var PLImageSrc = _base_path + '/int/js/custom/images/preloader_2.gif';
    var PLImageButtonSrc = _base_path + '/int/js/custom/images/preloader.gif';
    
    cu_preloadImages([PLImageSrc, PLImageButtonSrc]).done(function(images) { 
        uR_showWizard_dialog();
    });
}


function uR_showWizard_dialog() {

    require(['dojo/ready','dojo/dom','dojo/dom-construct','dojo/on','dojo/parser','dojo/_base/xhr','dojo/keys','dijit/Dialog','dijit/form/Form',
             'dijit/form/ValidationTextBox','dijit/form/CheckBox','dijit/form/Button','dijit/layout/ContentPane','dojox/fx/scroll'], 

    function(ready, dom, domConstruct, on, parser, xhr, keys, dialog) {
    
        var init_position = 'body';
	
	    dojox.fx.smoothScroll({
            node: init_position,
            win: window,
            duration: 500
        }).play();

        var PLIconSrc = _base_path + '/int/js/custom/images/preloader_2.gif';
        var PLIconNode = "<img id='usersDialogLoginPLIcon' class='hidden' width='35' src='" + PLIconSrc + "'></img>";

	    var titleNode = "<h3 class='header contents'>Sign up<span class='demoRTitle'>Live Demo</span></h3>";
        var refNode = "<div id='d_contents' style='display: none;opacity: 0'></div>";

        var PLNode_ = titleNode + refNode + "<table id='usersDialogLoginPL' class='usersDialogLoginPL'>";
        var PLNode = PLNode_ + "<tr><td>" + PLIconNode + "</td></tr></table>";

        var usersDialog = dijit.byId('usersDialog');
        if (usersDialog) { usersDialog.destroyRecursive(); }

        if (_SSL_option == '1') {
            var loginRDialogClass = 'loginRDialogSSL';
        } else {
            var loginRDialogClass = 'loginRDialogNoSSL';
        }

        var dlg = new dialog ({ 
	        id: 'usersDialog',
	        'class': 'usersDialog loginDialog ' + loginRDialogClass,
	        executeScripts: true,
	        scriptHasHooks: true,
	        content: PLNode
	    });

        setTimeout(function() { cu_dlgShow(dlg); }, 800);
        setTimeout(function() { uLR_GL(); }, 1200);

        xhr.post({
            url: _base_path + '/login/create',
            postData: { 'what': 'create', 'demo_version': '1' },
            handleAs: 'text', 
            load: function(data) {	            

                var mainNode = dom.byId('d_contents');
                domConstruct.place(data, mainNode, 'first');

                parser.parse('d_contents'); 
                
                ready(function() { 

		            dlg.startup();

		            on(dom.byId('login'), 'keydown', function(e) {
                        if (e.keyCode == keys.ENTER) {
                            dom.byId('loginButton').click();
                        }
                    });

                    var handler = on.pausable(dom.byId('loginButton'), 'click', function() {
			            dijit.byId('loginButton').set('disabled', 'disabled');
                        handler.pause();
                        uR_createAccount(dlg, handler);
	                });

		            if (_SSL_option == '1') {

		                var _base_path_array = _base_path.split('/');
		                var lan_path = _base_path_array[_base_path_array.length-1];

		                var base_path = _base_path;
		                if (lan_path == _lan) { 
		                    _base_path_array.splice(-1);
		                    base_path = _base_path_array.join('/'); 
		                }

                        on(dom.byId('loginRegCertButton'), 'click', function() {
                            uLR_clearStatus(); 
		                    uLR_showPL();

                            xhr.post({
                                url: base_path + '/users/certificates/select/register',
			                    postData: { 'dummy': 'dummy' },
                                handleAs: 'text',
                                load: function(data) {
                                    uR_manageCertificates(data); 
			                        if (data.match(/NONE--*/)) {
				                        handler.resume();
                                    }             
                                }
                            }); 
                        });

		                on(dijit.byId('loginRegCertCheckBox'), 'click', function() {
		                    var value = dijit.byId('loginRegCertCheckBox').get('checked');
                            if (value == true) { 
                                handler.pause();                   
                            } else {
                                handler.resume();
                            }   
		                });
                    }

                    on(dom.byId('loginButtonCancel'), 'click', function() {  
                        dlg.hide(); 
	                });

                    uLR_show();
                    
                    if (dijit.byId('firstname')) { 
                        dijit.byId('firstname').focus(); 
                    } else if (dijit.byId('surname')) { 
                        dijit.byId('surname').focus(); 
                    } else if (dijit.byId('companyname')) { 
                        dijit.byId('companyname').focus(); 
                    } else if (dijit.byId('companyVAT')) { 
                        dijit.byId('companyVAT').focus(); 
                    } else {
                        dijit.byId('username').focus(); 
                    }
                });
	        }
        });
    });
}


function uR_dialog(dlg) {

    require(['dojo/ready','dojo/dom','dojo/dom-construct','dojo/dom-class','dojo/parser','dojo/on','dojo/query','dojo/_base/xhr',
             'dojo/_base/fx','dijit/registry','dojo/_base/array','dojo/keys','dijit/form/CheckBox'], 

    function(ready, dom, domConstruct, domClass, parser, on, query, xhr, fx, registry, array, keys) {
    
       xhr.post({
            url: _base_path + '/login/create',
            postData: { 'what': 'create' },
            handleAs: 'text',    
            load: function(data) {
            
                var node = dom.byId('u_contents'); 
                array.forEach(registry.findWidgets(node),'item.destroyRecursive()');
                domConstruct.empty(node);
            
                query('.usersDialog h3').forEach(function(h3, index, arr) {
	                domConstruct.destroy(h3);
                });

                domConstruct.place(data, node, 'replace');
                
                if (_is_demo == '1') {
                    var titleNode = "<h3 class='header contents'>Sign up<span class='demoRTitle'>Live Demo</span></h3>";
                    query('.usersDialog h3').forEach(function(h3, index, arr) {
	                    domConstruct.place(titleNode, h3, 'replace');
                    });
                }

		        if (_SSL_option == '1') {
		            domClass.remove('usersDialog', 'loginDialogSSL');
        	    } else {
            	    domClass.remove('usersDialog', 'loginDialogNoSSL');
        	    }
        	    
        	    parser.parse('login'); 

                ready(function() { 

                    on(dom.byId('login'), 'keydown', function(e) {
                        if (e.keyCode == keys.ENTER) {
                            dom.byId('loginButton').click();
                        }
                    });

                    if (_is_demo == '1') {
                        var handler = on.pausable(dom.byId('loginButton'), 'click', function() {
			                dijit.byId('loginButton').set('disabled', 'disabled');
                            handler.pause();
                            uR_createAccount(dlg, handler);
	                    });

		            } else {
			            var handler = on.pausable(dom.byId('loginButton'), 'click', function() {
					        dijit.byId('loginButton').set('disabled', 'disabled');
			                handler.pause();
			                uR_checkAccount(dlg, handler);
	                    });
                    }

                    if (_SSL_option == '1') {

			            var _base_path_array = _base_path.split('/');
		                var lan_path = _base_path_array[_base_path_array.length-1];

		                var base_path = _base_path;
		                if (lan_path == _lan) { 
		                    _base_path_array.splice(-1);
		                    base_path = _base_path_array.join('/'); 
		                }

                        on(dom.byId('loginRegCertButton'), 'click', function() {
                            uLR_clearStatus(); 
		                    uLR_showPL();

                            xhr.post({
                                url: base_path + '/users/certificates/select/register',
			                    postData: { 'dummy': 'dummy' },
                                handleAs: 'text',
                                load: function(data) {
                                    uR_manageCertificates(data);     
				                    if (data.match(/NONE--*/)) {
					                    handler.resume();
                                    }       
                                }
                            }); 
                        });

		                on(dijit.byId('loginRegCertCheckBox'), 'click', function() {
		                    var value = dijit.byId('loginRegCertCheckBox').get('checked');
                            if (value == true) { 
                                handler.pause();                   
                            } else {
                                handler.resume();
                            }   
			            });
                    }

                    on(dom.byId('loginButtonCancel'), 'click', function() {    
	                    dijit.byId('usersDialog').hide();
	                });

		            if (dijit.byId('firstname')) { 
                        dijit.byId('firstname').focus(); 
                    } else if (dijit.byId('surname')) { 
                        dijit.byId('surname').focus(); 
                    } else if (dijit.byId('companyname')) { 
                        dijit.byId('companyname').focus(); 
                    } else if (dijit.byId('companyVAT')) { 
                        dijit.byId('companyVAT').focus(); 
                    } else {
                        dijit.byId('username').focus(); 
                    }   
	            });
            }
        });
    });
}


function uR_createAccount(dlg, handler) {

    require(['dojo/dom','dojo/dom-style','dojo/on','dojo/_base/xhr','dojo/_base/fx'], function(dom, domStyle, on, xhr, fx) {
     
	    uLR_showPL();
      
	    xhr.post({
            url: _base_path + '/login/create',
            handleAs: 'json',
            form: dom.byId('login'),
            load: function(jsonData) {

	            uLR_hidePL();
                                    
                var opResult = jsonData.opResult.toString();
                                
                if (opResult.match(/^ERROR/)) {
                    var msgError = jsonData.error.toString();
                    uLR_showStatus('false', msgError);
		            dijit.byId('loginButton').set('disabled', false);
                    handler.resume();

	            } else { 
	                dlg.hide();     
		            window.location.href = _base_path + '/users/personal_area'; 
                }
            }  
        });
    });
}

function uR_checkAccount(dlg, handler) {

    require(['dojo/dom','dojo/dom-style','dojo/on','dojo/_base/xhr','dojo/_base/fx'], function(dom, domStyle, on, xhr, fx) {

	    uLR_showPL();
      
	    xhr.post({
            url: _base_path + '/login/create/check',
            handleAs: 'json',
            form: dom.byId('login'),
            load: function(jsonData) {

	            uLR_hidePL();
                                    
                var opResult = jsonData.opResult.toString();
                                
                if (opResult.match(/^ERROR/)) {
                    var msgError = jsonData.error.toString();
                    uLR_showStatus('false', msgError);
		            dijit.byId('loginButton').set('disabled', false);
                    handler.resume();

	            } else {      
		            uR_profile(handler);
                }
            }  
        });
    });
}

function uR_profile(handler) {

    require(['dojo/ready','dojo/dom','dojo/dom-construct','dojo/dom-class','dojo/dom-style','dojo/parser','dojo/on','dojo/query','dojo/_base/xhr',
             'dojo/_base/fx','dijit/registry','dojo/_base/array','dojo/keys','dijit/form/Form','dijit/Dialog','dijit/form/ValidationTextBox',
             'dijit/form/CheckBox','dijit/form/FilteringSelect','dijit/form/Select','dijit/form/Button','dijit/layout/ContentPane','dojox/fx/scroll'], 

    function(ready, dom, domConstruct, domClass, domStyle, parser, on, query, xhr, fx, registry, array, keys) {

	    uLR_showPL();

	    xhr.post({
            url: _base_path + '/users/profile/profileForm',
	        handleAs: 'text',
	        postData: { 'register': '1', 'dialog': '1' },
	        load: function(data) {

                var ldata = data.split('-*/*-');

                var contents = ldata[0];
                
                domStyle.set('login', 'display', 'none');

                var mainNode = dom.byId('u_contents');

                domConstruct.place(contents, mainNode, 'last');
                dijit.byId('usersDialog').resize();

                parser.parse('FormTable');

                ready(function() { 

			        dijit.byId('usersDialog').resize(); 

                    if (dom.byId('step_1')) { domClass.remove('step_1', 'selected'); }
                    if (dom.byId('step_2')) { domClass.add('step_2', 'selected'); }

                    uR_activateProfile();

                    if (dijit.byId('d_backButton')) {
                        on(dom.byId('d_backButton'), 'click', function() {
			                uR_profileBackwards(handler);
                        });
                    }
                    
                    on(dom.byId('d_submitButton'), 'click', function() {
			            dijit.byId('d_submitButton').set('disabled', 'disabled');
			            uR_createProfile();
                    });

                    on(dom.byId('d_resetButton'), 'click', function() {    
	                    dijit.byId('usersDialog').hide();
                        handleDoUser();
	                }); 
                });
            }
        });
    });
}

function uR_createProfile() {

    require(['dojo/dom','dojo/dom-form','dojo/_base/xhr','dojo/query','dojo/_base/lang'], function(dom, domForm, xhr, query, lang) {
    
        if (dijit.byId('Form_d_Profile').validate()) { 
        
            uLR_showPL();
            
            var mergedForms = {};
            query('form', 'u_contents').forEach( function(form) {
                lang.mixin(mergedForms, domForm.toObject(form));
            });

            xhr.post({
                url: _base_path + '/login/create',
                content: mergedForms,
                handleAs: 'json',
                load: function(jsonData) {
            
                    var opResult = jsonData.opResult.toString();
	                if (opResult.match(/^ERROR/)) {
                        var msgError = jsonData.error.toString();
                        uR_failed(msgError);
  
	                } else {
	                    window.location.href = _base_path + '/users/personal_area'; 
                    }
                }
            });
        } 
    });
}

function uR_profileBackwards(handler) {

    require(['dojo/dom','dojo/on','dojo/dom-class','dojo/dom-construct','dojo/dom-style','dojo/query','dijit/registry','dojo/_base/array'], 

    function(dom, on, domClass, domConstruct, domStyle, query, registry, array) {
        
        uLR_hidePL();

        if (_SSL_option == '1' && (typeof _cert_check != 'undefined')) {
	        var lcert_check = _cert_check.split('*/*');
	        uLR_showStatus(lcert_check[0], lcert_check[1]);
	        uLR_showInfo();   
	    } 

        domStyle.set('login', 'display', '');
        domStyle.set('FormTable', 'display', 'none');

	    var formNode = dom.byId('login');

	    var form_P_node = query(formNode).next()[0]; 
        if (form_P_node) {
             array.forEach(registry.findWidgets(form_P_node),'item.destroyRecursive()');
             domConstruct.empty(form_P_node);
             domConstruct.destroy(form_P_node);
        } 

        if (dom.byId('step_1')) { domClass.add('step_1', 'selected'); }
        if (dom.byId('step_2')) { domClass.remove('step_2', 'selected'); }

        dijit.byId('loginButton').set('disabled', false);
        handler.resume();
        
	    dijit.byId('usersDialog').resize();
    });
}

function uR_failed(msgError) {

    require(['dojo/dom','dojo/dom-construct','dojo/dom-style','dojo/on','dojo/query'], function(dom, domConstruct, domStyle, on, query) {

        var wrongIcon = _base_path + '/int/js/custom/images/alert.png';
        var wrongImage = "<img width='40' src='" + wrongIcon + "'></img>";
    
        var data_ = "<table class='registerError'><tr><td class='registerErrorIcon'>" + wrongImage + "</td>";
        var dataNode = data_ + "<td class='registerErrorText'>" + msgError + "</td></tr></table>";

        query('#FormTable fieldset').forEach(function(node, index, arr) {
	        domStyle.set(node, 'display', 'none');
        });
 
        var mainNode = dom.byId('initProfileFormPosition');
        domConstruct.place(dataNode, mainNode, 'after');

        domStyle.set('d_managerConfirmPane', 'display', 'none');
        domStyle.set('d_managerClosePane', 'display', '');

        on(dom.byId('d_closeButton'), 'click', function() {
	        dijit.byId('usersDialog').hide();
	    }); 

        dijit.byId('usersDialog').resize();
    });
}

function uLR_update() {

    require(['dojo/on','dojo/dom','dojo/dom-style'], function(on, dom, domStyle) {

	    dom.byId('login').reset();
    
        var value = dijit.byId('loginRegCertCheckBox').get('checked');

        if (value == true) {
            if (dijit.byId('firstname')) { dijit.byId('firstname').set('disabled','disabled'); }
            if (dijit.byId('surname')) { dijit.byId('surname').set('disabled','disabled'); }
            if (dijit.byId('companyname')) { dijit.byId('companyname').set('disabled','disabled'); }
            if (dijit.byId('companyVAT')) { dijit.byId('companyVAT').set('disabled','disabled'); }
            dijit.byId('username').reset();
            dijit.byId('username').set('disabled','disabled'); 
            dijit.byId('password_').reset();
            dijit.byId('password_').set('disabled','disabled');
            if (dijit.byId('password2_')) { dijit.byId('password2_').set('disabled','disabled'); }
            
            dijit.byId('loginRegCertButton').set('disabled',false); 
            dijit.byId('loginButton').set('disabled', 'disabled');

            dom.byId('login_password').setAttribute('value', '0');

        } else {
            if (dijit.byId('firstname')) { dijit.byId('firstname').set('disabled',false); }
            if (dijit.byId('surname')) { dijit.byId('surname').set('disabled',false); }
            if (dijit.byId('companyname')) { dijit.byId('companyname').set('disabled',false); }
            if (dijit.byId('companyVAT')) { dijit.byId('companyVAT').set('disabled',false); }
            dijit.byId('username').set('disabled',false);
            dijit.byId('password_').set('disabled',false);
            if (dijit.byId('password2_')) { dijit.byId('password2_').set('disabled',false); }
            
            dijit.byId('loginRegCertButton').set('disabled','disabled');
            dijit.byId('loginButton').set('disabled', false);

	        dom.byId('login_password').setAttribute('value', '1');
        }
        
        uLR_hidePL();
        uLR_clearStatus();
    }); 
}

function uR_activateProfile() {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojo/dom-construct','dojo/query'], function(dom, domStyle, domClass, domConstruct, query) {
    
        query('#Form_d_Profile input.hidden' ).forEach(function(node, index, arr) {  
            domConstruct.destroy(node);
	    });
        
	    domStyle.set('d_managerEditionPane', 'display', 'none');
	    domStyle.set('d_managerClosePane', 'display', 'none');
        domStyle.set('d_managerConfirmPane', 'display', '');
    });
}

function uL_login(dlg, handler) {

    require(['dojo/dom','dojo/dom-style','dojo/on','dojo/_base/xhr','dojo/_base/fx'], function(dom, domStyle, on, xhr, fx) {

        uLR_showPL();

        xhr.post({
            url: _base_path + '/login/login',
            handleAs: 'json',
            form: dom.byId('login'),
            load: function(jsonData) {
                var opResult = jsonData.opResult.toString();
	            if (opResult.match(/^ERROR/)) {
                    var msgError = jsonData.error.toString();
                    uLR_showStatus('false', msgError);
		            setTimeout(function() { 
                        dijit.byId('loginButton').set('disabled', false);
		                dijit.byId('username').focus(); 
		                handler.resume();
                    }, 1000);

	            } else {
	                dlg.hide();   		 
		            window.location.href = _base_path + '/users/personal_area'; 
                }  
            }
        });
    });
}

function uL_logout() {

    require(['dojo/dom','dojo/_base/xhr'], function(dom, xhr) {

        xhr.post({
            url: _base_path + '/login/logout',
            postData: { 'what': 'logout' },
            handleAs: 'text',
            load: function(data) {
	            window.location.href = _base_path + '/';
            }
        });
    });
}

function uLR_showPL() {
    uLR_clearStatus();
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
	    domStyle.set('usersDialogPL', 'display', ''); 
    });
}

function uLR_hidePL() {
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        domStyle.set('usersDialogPL', 'display', 'none');
    });
}

function uLR_showStatus(tick, text) {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
    
        if (tick == 'false') {
            domStyle.set('usersDialogStatus_icon_false', 'display', 'block');
	        domStyle.set('usersDialogStatus_icon_true', 'display', 'none');
        } else {
            domStyle.set('usersDialogStatus_icon_true', 'display', 'block');
	        domStyle.set('usersDialogStatus_icon_false', 'display', 'none');
        }

        dom.byId('usersDialogStatus_text').innerHTML = text;
        uLR_hidePL();  
        cu_fadeIn('usersDialogStatus_icon');
        cu_fadeIn('usersDialogStatus_text');      
    });
}

function uLR_clearStatus() {
    cu_fadeQuickOut('usersDialogStatus_icon');
    cu_fadeQuickOut('usersDialogStatus_text');
    cu_fadeQuickOut('usersDialogStatus_info');
    
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        domStyle.set('usersDialogStatus_info', 'display', 'none');
    });
}

function uLR_show() {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {

        domStyle.set('usersDialogLoginPL', 'display', 'none');
        domStyle.set('d_contents', 'display', '');

        cu_fadeIn('d_contents');
    });
}

function uLR_GL() {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {

        domStyle.set('usersDialogLoginPLIcon', 'display', 'block');
        cu_fadeIn('usersDialogLoginPLIcon');
    });
}

function uLR_showInfo() {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
    
        domStyle.set('usersDialogStatus_info', 'display', 'block');
        cu_fadeIn('usersDialogStatus_info');            
    });
}




// USERS PERSONAL AREA 




function handle_pA() {
    require(['dojo/ready','dojo/dom','dojo/parser','dojo/dom-style','dojo/dom-construct','dojo/query','dojo/on','dojo/_base/xhr',
             'dijit/registry','dojo/_base/array','dijit/form/Form','dijit/form/CheckBox','dijit/form/Select','dijit/form/FilteringSelect',
             'dijit/form/ComboBox','dijit/form/Button'], function(ready, dom, parser, domStyle, domConstruct, query) {
             
        ready(function() { 
        
            var RTImageSrc = _base_path + '/int/js/custom/images/right_tick.png';
            var PLImageSrc = _base_path + '/int/js/custom/images/preloader_.gif';

	        cu_preloadImages([RTImageSrc, PLImageSrc]).done(function(images) { 

                fM_hidePL(); 
                query('#pAContents span.nCount').forEach(function(node, index, arr) {  
		            cu_fadeIn(node); 
                });
                
                if (_is_demo_active == '1' && (_demo_step == 'step3' || _demo_step == 'step5')) { 
                    setTimeout(function() { uPa_showWizard(); }, 3000); 
                }
            });
        });
    });
}

function uPa_showWizard() {

    require(['dojo/ready','dojo/dom','dojo/dom-class','dojo/dom-style','dojo/on','dojo/_base/xhr','dijit/Tooltip','dojox/fx/scroll',
             'dojo/fx','dojo/fx/easing'], function(ready, dom, domClass, domStyle, on, xhr, Tooltip) {

        if (dom.byId('democontents') == null) { return }
        
        function combineShowIt() {

      	    var moveAnim = dojo.fx.chain([
                dojo.animateProperty({node: 'democontents',
          	        properties: {
            		    height: {start: 0, end: 170, unit: 'px'}
          	        },
          	        duration: 800
                })           
      	    ]);

      	    var combinedAnim = dojo.fx.combine([moveAnim]);

            dojo.connect(combinedAnim, 'onEnd', function() {
		domStyle.set('democontents', 'height', '100%');
                cu_fadeIn('democontents');
                if (dom.byId('wizardClose')) {
                    on(dom.byId('wizardClose'), 'click', function() {
                        uPa_hideWizard();
	                });
                }

                if (_demo_step == 'step3') {
		            setTimeout(function() { 
           		        dojox.fx.smoothScroll({
               		        node: 'pAId',
               		        win: window,
               		        duration: 1500,
               		        onEnd: function() { 
                   	            var label = 'Click the new notification !';
            	   		        setTimeout(function() { 
            	   		            if (_demo_loop == '0') {
            	   		                Tooltip.show(label, 'notifications_start_list_1', ['before']); 
            	   		            } else {
            	   		                Tooltip.show(label, 'notifications_start_list_2', ['before']);
            	   		            }
            	   		        }, 1000);              
               		        }
            		    }).play();
                    }, 5000);
                    
        	    } else if (_demo_step == 'step5' && _demo_loop == '0') {
		            setTimeout(function() { 
           		        dojox.fx.smoothScroll({
               		        node: 'pAId',
               		        win: window,
               		        duration: 1500,
               		        onEnd: function() { 
                   	            var label = 'Click the new notification !';
            	   		        setTimeout(function() { 
            	   		            Tooltip.show(label, 'notifications_start_list_2', ['before']); 
            	   		        }, 1000);              
               		        }
            		    }).play();
                    }, 5000);
        	    }

		        if (_demo_loop == '1') {
		            on(dom.byId('wizardEndStep5'), 'click', function() {
                        uPa_hideWizard();
	                });
		        }
            });

      	    combinedAnim.play();
        }
        
        domClass.add('demoWizardTStep1', 'disabled');
        domClass.add('demoWizardTStep2', 'disabled');

	    combineShowIt();
        domClass.add('wizardDisplay', 'hidden');
        
        _is_demo_active = '1';

        xhr.post({
		    url: _base_path + '/' + _page + '/demo/enable/?',
		    handleAs: 'text',
		    postData: { 'dummy': 'dummy' },
		    load: function(data) { }         
	    });
    });
}

function uPa_hideWizard() {

    require(['dojo/ready','dojo/dom','dojo/dom-class','dojo/on','dojo/_base/xhr','dojo/fx','dojo/fx/easing'], 
    
    function(ready, dom, domClass, on, xhr) {

        function combineHideIt() {

             var moveHideAnim = dojo.fx.chain([
                 dojo.animateProperty({node: 'democontents',
          	        properties: {
            		    height: {start: 170, end: 0, unit: 'px'}
          	        },
          	        duration: 1500
                 })           
      	     ]);

	        var combinedHideAnim = dojo.fx.combine([moveHideAnim]);

	        dojo.connect(combinedHideAnim, 'onBegin', function() {
                cu_fadeQuickOut('democontents');
            });
            
            if (_demo_step == 'step3') {
	            dojo.connect(combinedHideAnim, 'onEnd', function() {
                    domClass.remove('wizardDisplay', 'hidden');
                    on(dom.byId('wizardDisplay'), 'click', function() {
                        uPa_showWizard();
                    });
                });
            }

            combinedHideAnim.play();
        }

        combineHideIt();
        
        _is_demo_active = '0';
        
        xhr.post({
		    url: _base_path + '/' + _page + '/demo/disable/?',
		    handleAs: 'text',
		    postData: { 'dummy': 'dummy' },
		    load: function(data) { }         
	    });
    });
}

function uP_AutoInit() {

    require(['dojo/ready','dojo/dom','dojo/dom-class'], function(ready, dom, domClass) {

	    ready(function() {
           uP_Init();
        });
    });
}

function uP_Init() {

    if (typeof _profile_already_loaded != 'undefined') { return }

    require(['dojo/ready','dojo/dom','dojo/parser','dojo/dom-class','dojo/dom-style','dojo/dom-construct','dojo/on',
             'dojo/_base/xhr','dojo/query','dijit/registry','dojo/_base/array'], 
    
    function(ready, dom, parser, domClass, domStyle, domConstruct, on, xhr, query, registry, array) {
    
        var pImageSrc = _base_path + '/int/js/custom/images/form_pencil.jpg'; 
        cu_preloadImages([pImageSrc]).done(function(images) {} );

        xhr.post({
	        url: _base_path + '/users/profile/profileForm',
	        handleAs: 'text',
	        postData: { 'id': 'current', 'dialog': '0' },
	        load: function(data) {

	            var ldata = data.split('-*/*-');

                var edit_choose_name = ldata[0];
                var gfield = ldata[1];
                var name = ldata[2];
                var isadmin = ldata[3];
                var status = ldata[4];
                var contents = ldata[5];
                
                var contents = contents.replace(/&apos;/g, "'");
                
                var node = dom.byId('profileContents'); 
                
                domStyle.set('profileContents', 'visibility', 'hidden');

                array.forEach(registry.findWidgets(node),'item.destroyRecursive()');
                domConstruct.empty(node);

                domStyle.set('profileGPL', 'display', 'none');

                domConstruct.place(contents, node, 'first');
                parser.parse('FormTable'); 

                ready(function() {
                
                    uP_status(status, isadmin);     

                    on(dom.byId('editButton'), 'click', function() {
                        uP_edit(edit_choose_name, gfield, isadmin, status);         
                    });

                    on(dom.byId('submitButton'), 'click', function() {
                        uP_submit();         
                    });
         
                    on(dom.byId('resetButton'), 'click', function() {
			            uP_reset();
                    });
                    
                    query('.readonly.hidden' ).forEach(function(node, index, arr) {  
                        var name = node.getAttribute('name');
                        if (name != 'p_profile_' + edit_choose_name) {
                            domConstruct.destroy(node);
                        }
                    });

                    query('#' + edit_choose_name ).forEach(function(node, index, arr) {
		                domStyle.set(node, 'fontWeight', 'bold');
	                });

                    uP_close();
                    domStyle.set('profileContents', 'visibility', 'visible');

                    _profile_already_loaded = '1';
		        });
            }
	    });
    });
}

function uP_status(status, isadmin) {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojo/query'], function(dom, domStyle, domClass, query) {

        if (status == 'active') {
            var StTxt = 'Validated profile';
            var StSrc = _base_path + '/int/js/custom/images/users/validations/valid.jpg';
            
        } else {
            var StTxt = 'Your profile is pending to be validated';
            var StSrc = _base_path + '/int/js/custom/images/users/validations/new.jpg';
        }
        
        if (isadmin == '1') { var StTxt = StTxt + "<span class='s'>-</span>Administrator user"; }

        var StImage = new Image();
    	StImage.src = StSrc;
  
    	StImage.onload = function() {
	        var StIconNode = "<img width='40' src='" + StSrc + "'></img>";

            dom.byId('managerStatusImgPane').innerHTML = StIconNode;
            dom.byId('managerStatusPaneText').innerHTML = StTxt;  
            cu_fadeIn('managerStatusPane');
    	}
    });
}

function uP_edit(edit_choose_name, gfield, isadmin, status) {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojo/query'], function(dom, domStyle, domClass, query) {
    
        uP_clearStatus();

        query('#Form_Profile .dijitDisabled').forEach(function(node, index, arr) {  
            var id = node.getAttribute('id');
            if (dijit.byId(id)) {
                if (id == 'profile_' + edit_choose_name) {
                    dijit.byId(id).set('disabled','disabled');
                } else if (id == 'profile_' + gfield) {
                    if (isadmin == '1' || status == 'new') { 
                        domClass.add(node, 'usersProfileInputWidget'); 
                        dijit.byId(id).set('disabled',false);
                    }
                } else {
                    domClass.add(node, 'usersProfileInputWidget'); 
                    dijit.byId(id).set('disabled',false);
                }
            }
	    });

	    query('#Form_Profile .dijitDisabled input').forEach(function(node, index, arr) {  
            var id = node.getAttribute('id');
            if (dijit.byId(id)) {
                if (id == 'profile_' + edit_choose_name) {
                    dijit.byId(id).set('disabled','disabled');
                } else if (id == 'profile_' + gfield) {
                    if (isadmin == '1' || status == 'new') { 
                        domClass.add(node, 'usersProfileInputWidget'); 
                        dijit.byId(id).set('disabled',false);
                    }
                } else {
                    domClass.add(node, 'usersProfileInputWidget'); 
                    dijit.byId(id).set('disabled',false);
                }
            }
	    });

        domStyle.set('managerEditionPane', 'visibility', 'hidden');
        domStyle.set('managerConfirmPane', 'visibility', 'visible');
    });
}

function uP_reset() {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojo/query'], function(dom, domStyle, domClass, query) {
    
        dijit.byId('Form_Profile').reset(); 
        query('.usersProfileInputWidget' ).forEach(function(node, index, arr) {  
            var id = node.getAttribute('id');
            dijit.byId(id).set('disabled','disabled');
        });
	    domStyle.set('managerEditionPane', 'visibility', 'visible');
        domStyle.set('managerConfirmPane', 'visibility', 'hidden');
    });
}

function uP_close() {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojo/query'], function(dom, domStyle, domClass, query) {
    
        query('.usersProfileInputWidget' ).forEach(function(node, index, arr) {  
            var id = node.getAttribute('id');
            dijit.byId(id).set('disabled','disabled');
	    });
	    
	    domStyle.set('managerEditionPane', 'visibility', 'visible');
        domStyle.set('managerConfirmPane', 'visibility', 'hidden');
    });
}

function uP_submit() {

    require(['dojo/dom','dojo/dom-style','dojo/_base/xhr','dojo/query','dojo/on'], function(dom, domStyle, xhr, query, on) {

        clearTimeout(this._timeout); 
        
        uP_showPL();

        if (!dijit.byId('Form_Profile').validate()) { 
            uP_hidePL();
            return false; 
        }

        xhr.post({
            url: './profile/profileForm/submit',
            form: dom.byId('Form_Profile'),
            handleAs: 'json',
            load: function(jsonData) {

                var opResult = jsonData.opResult.toString();

	            if (opResult.match(/^ERROR/)) {
                    var msgError = jsonData.msgError.toString();
                    uP_showStatus('false', msgError);
                                
	            } else {
	                var msg = jsonData.msg.toString();
	                var userName = jsonData.userName.toString();
	                var isAdmin = jsonData.isAdmin.toString();
                    var needRestart = jsonData.needRestart.toString();

		            uP_showStatus('true', msg);

                    if (needRestart == '0') {
			            dom.byId('pAId').innerHTML = userName;
                        uP_close();
                        
                        if (isAdmin == '1' && dom.byId('usersProfileSelectionControl')) {
                            if (dom.byId('usersProfileSelectionControl').innerHTML == 'loaded') {
                                dom.byId('usersProfileSelectionControl').innerHTML = 'reload';
                            }
                        }

                    } else {
			            setTimeout(function() { window.location.href = _base_path + '/users/personal_area'; }, 1000);
                    }           
                }
            }
        });
    });
}

function uPa_select(selection) {

    require(['dojo/dom','dojo/dom-class', 'dojo/dom-style'], function(dom, domClass, domStyle) {
    
        if (selection == 'profile') {
            uP_Init();
            domClass.remove('profileSelection', 'pf_sh_c');
            domClass.add('notificationSelection', 'pf_sh_c');
            domStyle.set('profile', 'display', '');
            domStyle.set('notifications', 'display', 'none');
            if (dom.byId('usersManagement')) { 
                domStyle.set('usersManagement', 'display', 'none'); 
                domClass.add('usersManagementSelection', 'pf_sh_c');
            }
            if (dom.byId('liveDemo')) { 
                domStyle.set('liveDemo', 'display', 'none'); 
                domClass.add('liveDemoSelection', 'pf_sh_c');
            }

        } else if (selection == 'notifications') {
            domClass.remove('notificationSelection', 'pf_sh_c');
            domClass.add('profileSelection', 'pf_sh_c');
            domStyle.set('profile', 'display', 'none');
            domStyle.set('notifications', 'display', '');
            if (dom.byId('usersManagement')) { 
                domStyle.set('usersManagement', 'display', 'none'); 
                domClass.add('usersManagementSelection', 'pf_sh_c');
            }
            if (dom.byId('liveDemo')) { 
                domStyle.set('liveDemo', 'display', 'none'); 
                domClass.add('liveDemoSelection', 'pf_sh_c');
            }

        } else if (selection == 'liveDemo') {
            domClass.add('notificationSelection', 'pf_sh_c');
            domClass.add('profileSelection', 'pf_sh_c');
            domStyle.set('profile', 'display', 'none');
            domStyle.set('notifications', 'display', 'none');
            if (dom.byId('usersManagement')) { 
                domStyle.set('usersManagement', 'display', 'none'); 
                domClass.add('usersManagementSelection', 'pf_sh_c');
            }

	        domStyle.set('liveDemo', 'display', '');
            domClass.remove('liveDemoSelection', 'pf_sh_c');
            
        } else {
            domClass.add('notificationSelection', 'pf_sh_c');
            domClass.add('profileSelection', 'pf_sh_c');
            domStyle.set('profile', 'display', 'none');
            domStyle.set('notifications', 'display', 'none');
            if (dom.byId('liveDemo')) { 
                domStyle.set('liveDemo', 'display', 'none'); 
                domClass.add('liveDemoSelection', 'pf_sh_c');
            }
            
            domStyle.set('usersManagement', 'display', '');
            domClass.remove('usersManagementSelection', 'pf_sh_c');
            
            _uM_grid_loading = '0';
            uM_select('users');
        }
    });
}

function uN_navTnextAction(tNum, tmDNum) {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class'], function(dom, domStyle, domClass) {

        var dNum = dom.byId('navBarTControl_' + tNum).innerHTML;
        var dNum_next = parseInt(dNum) + parseInt('1');

        dom.byId('navBarTControl_' + tNum).innerHTML = dNum_next;

        domStyle.set('navTD_' + tNum + '_' + dNum, 'display', 'none');
        domStyle.set('navTD_' + tNum + '_' + dNum_next, 'display', 'block');

        var backN = 'navBarTBack_' + tNum;
        domStyle.set(backN, 'display', 'block');

        if ( dNum_next == tmDNum ) {
            var nextN = 'navBarTNext_' + tNum;
            domStyle.set(nextN, 'display', 'none');
            domClass.add(backN, 'posP_B');
            
        } else {
            domClass.remove(backN, 'posP_B');
        }
    });
} 

function uN_navTbackAction(tNum, tmDNum) {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class'], function(dom, domStyle, domClass) {

        var dNum = dom.byId('navBarTControl_' + tNum).innerHTML;
        var dNum_back = parseInt(dNum) - parseInt('1');

        dom.byId('navBarTControl_' + tNum).innerHTML = dNum_back;

        domStyle.set('navTD_' + tNum + '_' + dNum, 'display', 'none');
        domStyle.set('navTD_' + tNum + '_' + dNum_back, 'display', 'block');

        var nextN = 'navBarTNext_' + tNum;
        domStyle.set(nextN, 'display', 'block');

        var backN = 'navBarTBack_' + tNum;
        if ( dNum_back < tmDNum ) { domClass.remove(backN, 'posP_B'); }
        if ( dNum_back == '1' ) { domStyle.set(backN, 'display', 'none'); } 
    });
} 

function uN_expandAction(cNum, notNum) {

    require(['dojo/dom','dojo/dom-style','dojox/fx/scroll'], function(dom, domStyle) {

        var nextN = 'nextNotifications_' + cNum;
	    var backN = 'backNotifications_' + cNum;
	    
        var height = domStyle.get('containerNotifications_' + cNum, 'height');
        
        if ( height <= '240' ) {
            domStyle.set('containerNotifications_' + cNum, 'height', '310px');
            dom.byId('nextNotificationIcon_' + cNum).setAttribute('src', _base_path + '/int/js/custom/images/less.png');
            if (notNum > '8') {
                domStyle.set(nextN, 'visibility', 'visible');
	            domStyle.set(backN, 'visibility', 'visible');
            }

        } else {
            domStyle.set('containerNotifications_' + cNum, 'height', '210px');
            dom.byId('nextNotificationIcon_' + cNum).setAttribute('src', _base_path + '/int/js/custom/images/more.png');
            if (notNum > '8') {
                domStyle.set(nextN, 'visibility', 'hidden');
                domStyle.set(backN, 'visibility', 'hidden');
            }
        }

        if (notNum > '8' && domStyle.get(nextN, 'display') == 'none' && domStyle.get(backN, 'display') == 'none') { 
            domStyle.set(nextN, 'display', 'block'); 
        }
    });
}

function uN_nextAction(cNum, dNumT) {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojo/query'], function(dom, domStyle, domClass, query) {

        var dNum = dom.byId('notificationsDivisionControl_' + cNum).innerHTML;
        var dNum_next = parseInt(dNum) + parseInt('1');

        dom.byId('notificationsDivisionControl_' + cNum).innerHTML = dNum_next;

        query('#containerNotifications_' + cNum + ' tr.notificationsDivision.' + dNum).forEach(function(node, index, arr) {
            domClass.remove(node, 'nd_v');
	    });

        query('#containerNotifications_' + cNum + ' tr.notificationsDivision.' + dNum_next).forEach(function(node, index, arr) {
            domClass.add(node, 'nd_v');
	    });

        var backN = "backNotifications_" + cNum;
        domStyle.set(backN, 'display', 'block');

        if ( dNum_next == dNumT ) {
            var nextN = "nextNotifications_" + cNum;
            domStyle.set(nextN, 'display', 'none');
        }
    });
}

function uN_backAction(cNum, dNumT) {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojo/query'], function(dom, domStyle, domClass, query) {

        var dNum = dom.byId('notificationsDivisionControl_' + cNum).innerHTML;
        var dNum_back = parseInt(dNum) - parseInt('1');

        dom.byId('notificationsDivisionControl_' + cNum).innerHTML = dNum_back;

        query('#containerNotifications_' + cNum + ' tr.notificationsDivision.' + dNum).forEach(function(node, index, arr) {
            domClass.remove(node, 'nd_v');
	    });

        query('#containerNotifications_' + cNum + ' tr.notificationsDivision.' + dNum_back).forEach(function(node, index, arr) {
            domClass.add(node, 'nd_v');
	    });

        var nextN = "nextNotifications_" + cNum;
        domStyle.set(nextN, 'display', 'block');

        if ( dNum_back == '1' ) {
            var backN = "backNotifications_" + cNum;
            domStyle.set(backN, 'display', 'none');
        }
    });
}

function uN_admin_view() {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
    
        dom.byId('notificationsAdminControl').innerHTML = '2';
        
        domStyle.set('notAdminView', 'display', 'none');
        domStyle.set('notProfileView', 'display', 'block');
        
        domStyle.set('notM', 'display', 'none');
        domStyle.set('notC', 'display', 'none');
        domStyle.set('notM_Admin', 'display', 'block');
        domStyle.set('notC_Admin', 'display', 'block');
        
    });
}

function uN_profile_view() {

    require(['dojo/dom','dojo/dom-class','dojo/dom-style','dojo/query'], function(dom, domClass, domStyle, query) {
    
        dom.byId('notificationsAdminControl').innerHTML = '1';
        
        domStyle.set('notAdminView', 'display', 'block');
        domStyle.set('notProfileView', 'display', 'none');
        
        query('#notC > table').forEach(function(node, index, arr) {
            if(!domClass.contains(node, 'notificationsWelcome')) { 
                domStyle.set('notM', 'display', 'block');
            }
        });
        
        domStyle.set('notM', 'display', 'block');
        domStyle.set('notC', 'display', 'block');
        domStyle.set('notM_Admin', 'display', 'none');
        domStyle.set('notC_Admin', 'display', 'none');
    });
}

function uN_goForm(link) {
    window.location.href = link; 
}

function uN_select(num, id) {

    require(['dojo/dom','dojo/dom-class','dojo/dom-style'], function(dom, domClass, domStyle) {

        var view = dom.byId('notificationsAdminControl').innerHTML;

        for (var i=1; i<=num; i++) {
	        if (i == id) { 
                domClass.remove('notificationSelection_' + view + '_' + i, 'pf_sh_c');
                domStyle.set('frameNotifications_' + view + '_' + i, 'display', '');

            } else {
                domClass.add('notificationSelection_' + view + '_' + i, 'pf_sh_c');
                domStyle.set('frameNotifications_' + view + '_' + i, 'display', 'none');
            }
        }
    });
}

function uP_showPL() {
    uP_clearStatus();
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        domStyle.set('profilePL', 'display', '');
    });
}

function uP_hidePL() {
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        domStyle.set('profilePL', 'display', 'none');
    });
}

function uP_showStatus(tick, text) {

    require(['dojo/dom'], function(dom) {
    
        if (tick == 'false') {
            var src = './../int/js/custom/images/false.png';  
        } else {
            var src = './../int/js/custom/images/true.png';  
        }
        var icon = "<img width='13' height='13' src='" + src + "'></img>";
    
        dom.byId('profileStatus_image').innerHTML = icon;
        dom.byId('profileStatus_text').innerHTML = text;
        uP_hidePL();  
        cu_fadeIn('profileStatus_image');
        cu_fadeIn('profileStatus_text');             
    });
}

function uP_clearStatus() {
    cu_fadeQuickOut('profileStatus_image');
    cu_fadeQuickOut('profileStatus_text');
}




// FORMS




function handle_form(base_path, page, db_display, has_file_param, has_formatted_param) {

    dojo_modules = ['dojo/ready','dojo/parser','dojo/dom','dojo/dom-class','dojo/dom-style','dojo/_base/connect','dojo/on','dojo/cookie','dojo/json',
		    'dojo/keys','dijit/Menu','dojo/io/iframe','dijit/form/Form','dojox/html/_base','dojox/widget/DialogSimple','dijit/form/CheckBox',
                    'dijit/form/Select','dijit/form/ValidationTextBox','dijit/form/TextBox','dijit/form/Select','dijit/form/FilteringSelect',
                    'dijit/form/ComboBox','dijit/form/SimpleTextarea','dijit/form/NumberTextBox','dijit/form/Button','dijit/form/RadioButton',
                    'dijit/form/DateTextBox','dijit/form/TimeTextBox','dojo/date/locale','dijit/Dialog','dojo/_base/fx',
                    'dojox/form/CheckedMultiSelect','dijit/layout/ContentPane','dojox/validate/web'];

    if (has_file_param) { dojo_modules.push('custom/FileInput'); } 

    if (has_formatted_param) {

        dojo_editor_modules = ['dijit/Editor','dijit/_editor/plugins/TextColor','dijit/_editor/plugins/LinkDialog',
			                   'dijit/_editor/plugins/FullScreen','dijit/_editor/plugins/ViewSource'];

        for (var i=0; i<dojo_editor_modules.length; i=i+1){ 
	        dojo_modules.push(dojo_editor_modules[i]);     
	    }
    } 
    
    if (!db_display) { dojo_modules.push('dijit/layout/TabContainer'); }

    require(dojo_modules, function(ready, parser, dom, domClass, domStyle, connect, on, cookie, json, keys) {

        _base_path = base_path;
	    _page = page;
	    _db_display = db_display;
        _updating = '0'; 

        if (typeof _UMS_enabled == 'undefined') { 

	        _SSL_option = '0';  
    
   	        _is_logged = '0';
    	    _is_admin = '0';
    
    	    _is_demo = '0';
    	    _is_demo_active = '0';
    	    _demo_form = '';
    	    _demo_step = '';
        }

        ready(function() { 

            if (cookie('cookie_key')) {
                newValues = dojo.fromJson(cookie('cookie_key'));
                dijit.byId('Form').set('value',newValues);
                dojo.query('.widget.date').forEach(function(node, index, arr) {
                    var widget_id = node.getAttribute('id');
                    var id = widget_id.replace(/widget_/, '');
                    var value = dijit.byId(id).get('value');
                    if (value != null) {
                        var valueY = value.getFullYear();
                        if (valueY == '1970') { dijit.byId(id).set('value','null');  }
                    }
                });

                

                dojo.query('.input_editor').forEach(function(node, index, arr) {
                    var input_id = node.getAttribute('id');
                    var value = node.getAttribute('value');
                    var widget_id = 'editor_' + input_id;
                    var widget_value = dijit.byId(widget_id).get('value');
                    if (value != '' && widget_value == '') { dijit.byId(widget_id).set('value',value); } 
                });

                cookie('cookie_key', null, { path: '/', expires: -1 });
            } 

            renderWidgets('new');
            
            tabContainer = dijit.byId('tabContainerForm');
            if (tabContainer) {
                dojo.connect(tabContainer, 'selectChild', function(tabNode){
                    var tabId = tabNode.id;
                    renderChartTabSelection(tabId);
                });
            }
       
            if (!db_display) { setTimeout(function() { fM_hidePL(); }, 800); }
        });
    });
} 

function handle_response(has_formatted_param, has_table) {

    dojo_modules = ['dojo/ready','dojo/parser','dojo/dom','dojo/_base/connect','dojo/hash','dojo/io-query','dijit/form/Form',
                    'dojox/widget/DialogSimple','dijit/form/CheckBox','dijit/form/Select','dijit/form/ValidationTextBox','dijit/form/TextBox',
                    'dijit/form/Select','dijit/form/FilteringSelect','dijit/form/ComboBox','dijit/form/SimpleTextarea','dijit/form/NumberTextBox',
                    'dijit/form/Button','dijit/form/RadioButton','dijit/form/DateTextBox','dijit/form/TimeTextBox','dojo/date/locale',
                    'dojox/form/CheckedMultiSelect','dojo/domReady!'];       
 
    if (has_formatted_param) { dojo_modules.push('dijit/Editor'); }
    if (has_table) { dojo_modules.push('dojox/grid/DataGrid'); } 

    require(dojo_modules, function(ready, parser, dom, connect, hash, ioQuery) { 
    
        _db_display = 0;
        
        ready(function() {        
            renderWidgets('response'); 
            fM_hidePL(); 
        });
    });
}  

function handle_denied_form() {

    require(['dojo/ready','dojo/dom','dojo/parser','dojo/dom-style','dojo/dom-construct','dojo/on','dojo/_base/fx','dijit/Dialog',
             'dijit/registry','dojo/_base/array','dijit/form/Form','dijit/form/CheckBox','dijit/form/Select','dijit/form/FilteringSelect',
             'dijit/form/ComboBox','dijit/form/Button'], function(ready, dom, parser) {
             
        ready(function() { 
        
            var WTImageSrc = _base_path + '/int/js/custom/images/wrong_tick.png';

            cu_preloadImages([WTImageSrc]).done(function(images) { 
                fM_hidePL(); 
                cu_fadeIn('deniedForm');
            });
        });
    });
}

function fM_resetAction() {

    require(['dojo/dom','dojo/dom-class','dojo/on','dijit/Tooltip'], function(dom, domClass, on, Tooltip) {

        var form = dijit.byId('Form');
    
        iterFunction = function(widget) {
    
            var tooltip = dijit.byId('t_' + widget.id);
            if (tooltip) {
                Tooltip.hide(widget.id);
	            if (widget.type == 'text') {
		            domClass.remove('widget_' + widget.id, 'dijitTextBoxError dijitValidationTextBoxError dijitError');
		        } else if (widget.class == 'widget editor') {
			        domClass.remove(widget.id, 'dijitEditorError');
			    }
            }
        }
        
        dojo.forEach(form.getChildren(), iterFunction);
        
        dom.byId('Form').reset();
    });  
}

function fM_submitAction() {

    require(['dojo/dom','dojo/dom-construct','dojo/dom-class','dojo/dom-style','dojo/on','dojo/cookie',
             'dojox/fx/scroll'], function(dom, domConstruct, domClass, domStyle, on, cookie) {

        if (!dijit.byId('Form').validate()) {
            
            var form = dijit.byId('Form');
            
            var iWs = new Array();
	        iterFunction = function(widget) {
                try { var invalid = widget.isValid(); if (invalid == false) { iWs.push(widget); } }
                catch(err) { }
            }
	        
	        dojo.forEach(dijit.byId('Form').getChildren(), iterFunction);
	        
	        var iW = iWs[0];
	        var iWId = iW.id;
	        var iIdNode = dom.byId(iWId);
	        
	        while(!domClass.contains(iIdNode, 'container')) {
                iIdNode = iIdNode.parentNode;
                if (iIdNode == null) { return false }
            }

            var spanPosNode = iIdNode.previousSibling;
            var spanPosId = spanPosNode.getAttribute('id').toString();

	        var init_position = spanPosId;
	        
	        var numPos = spanPosId.replace(/initContainerPosition_/, '');
	        if (numPos < '3') { var init_position = 'gContents' }
            
	        dojox.fx.smoothScroll({
                node: init_position,
                win: window,
                duration: 200
            }).play();
            
	        return false;

        } else {
        
            _fValidation = true;
        
            if (typeof customValidation == 'function') {
                customValidation();
                if (!_fValidation) { fM_warningTooltip(_custom_nv_widget, 'iM'); }
            }

            if (_fValidation) { 
	            var form = dijit.byId('Form');
	            iterFunction = function(widget) {

                    if (widget.type == 'checkbox') {
                        var checked = widget.get('checked');
		                wRequired = widget.required;
		            
		                if (wRequired == 'true' && !checked) {		            
		                    _fValidation = false;
			                fM_warningTooltip(widget, 'mM'); 
                        }

                    } else if (widget.class == 'widget editor') {

                        var value = widget.get('value');
			            var node_value = domConstruct.toDom(value).innerHTML;

			            var value = value.replace(/\s{2,}/g, ' ');
			            var string = value.replace(new RegExp('(\<br \/\>)*', 'g'), '');

			            if (value != '' && node_value == '') { var value = ''; }
			            if (string.length === 0 || !string.trim()) { var value = ''; }

		                wRequired = widget.required;
		            
		                if (wRequired == 'true' && value == '') {		            
		                    _fValidation = false;
			                fM_warningTooltip(widget, 'mM'); 
                        }
                    }
                };
            
                dojo.forEach(form.getChildren(), iterFunction);
                
                if (_fValidation) { 
                
                    dijit.byId('submitButton').set('disabled','disabled');
                    domStyle.set('B_PL', 'visibility', 'visible');
                    domStyle.set('B_PL_T', 'visibility', 'visible');

	                var f = dom.byId('Form');
                    if (f.elements.length) {
                        var formJson = dojo.formToJson('Form');
                        var date = new Date();
                        var minutes = 1;
                        date.setTime(date.getTime() + (minutes * 60 * 10000));
                        cookie('cookie_key', formJson, { path: '/', expires: date });
                        dom.byId('Form').submit();
                    }
                }
            }
         }
    });    
} 

function fM_warningTooltip(widget, mode) {

    require(['dojo/dom','dojo/dom-class','dojo/on','dijit/Tooltip','dojox/fx/scroll'], function(dom, domClass, on, Tooltip) {
    
        if (mode == 'mM') {
            var msg = widget.missingMessage;
        } else {
            var msg = widget.invalidMessage;
        }

        var tooltip = dijit.byId('t_' + widget.id);
        if (!tooltip) {
            new Tooltip({
                id: 't_' + widget.id,
                connectId: 'label_' + widget.id,
                label: msg
            });
        }
        
	    var iWId = widget.id;
	    var iIdNode = dom.byId(iWId);
	        
	    while(!domClass.contains(iIdNode, 'container')) {
            iIdNode = iIdNode.parentNode;
            if (iIdNode == null) { return false }
        }

        var spanPosNode = iIdNode.previousSibling;
        var spanPosId = spanPosNode.getAttribute('id').toString();

	    var init_position = spanPosId;
	        
	    var numPos = spanPosId.replace(/initContainerPosition_/, '');
	    if (numPos < '3') { var init_position = 'gContents' }
        
        dojox.fx.smoothScroll({
            node: init_position,
            win: window,
            duration: 200
        }).play();
        
        if (widget.type == 'checkbox') {               
            on(dom.byId(widget.id), 'click', function() {
                var checked = widget.get('checked');
                if (checked) {
	                Tooltip.hide('label_' + widget.id);
	            } else {
	                Tooltip.show(msg, 'label_' + widget.id); 
	            }
		    });
		    
		    setTimeout(function() { Tooltip.show(msg, 'label_' + widget.id); }, 500);

        } else if (widget.class == 'widget editor') {

		    on(dijit.byId(widget.id), 'keydown', function(e) {
	            Tooltip.hide(widget.id);
		        domClass.remove(widget.id, 'dijitEditorError');
		    });
		    
		    setTimeout(function() { 
		        Tooltip.show(msg, widget.id); 
		        domClass.add(widget.id, 'dijitEditorError');
		    }, 500);
		     
		} else {
		    on(dom.byId(widget.id), 'keydown', function(e) {
	            Tooltip.hide(widget.id);
	            if (widget.type == 'text') {
		            domClass.remove('widget_' + widget.id, 'dijitTextBoxError dijitValidationTextBoxError dijitError');
		        }
		    });
		    
		    setTimeout(function() { 
		        Tooltip.show(msg, widget.id); 
		        if (widget.type == 'text') {
		            domClass.add('widget_' + widget.id, 'dijitTextBoxError dijitValidationTextBoxError dijitError');
		        }
		    }, 500);
		}  
    });
} 

function fM_deniedAccessMsg() {

    var wrongIcon = _base_path + '/int/js/custom/images/wrong_tick.png';
    var wrongImage = "<img width='40' src='" + wrongIcon + "'></img>";
    
    var msg1 = _nA_msg1;
    var msg2 = _nA_msg2;
    var d1 = "<td>" + msg1 + "</td>";
    var d2 = "<td>" + msg2 + "</td>";
    var data_ = "<table class='deniedForm'><tr><td class='deniedFormT'>" + wrongImage + "</td>";
    var data = data_ + "<td>" + d1 + "</td></tr></table><table class='deniedForm'><tr><td>" + d2 + "</td></tr></table></td></tr></table>";
    return data;
}

function fM_s_info(id, j, depth) {

    for (i = 0; i < depth; i++) {
	    var certD_det = 'certD' + id + '_det_' + i;
        var certD_id = 'certD' + id + '_id_' + i;

        require(['dojo/dom-style'], function(domStyle){
            if (i == j) {
                domStyle.set(certD_det, 'display', 'block');
                domStyle.set(certD_id, 'fontWeight', 'bold');
            } else {
                domStyle.set(certD_det, 'display', 'none');
                domStyle.set(certD_id, 'fontWeight', 'normal');
            }
        });
    }
}

function fM_hidePL() {
    require(['dojo/ready','dojo/dom','dojo/dom-style','dojo/_base/fx','dojo/fx','dojo/fx/easing'], function(ready, dom, domStyle, fx) {

        ready(function() { 
            if (dom.byId('preloader')) {
                fx.fadeOut({
                    node: 'preloader',
                    duration: 500,
                    onEnd: function() {
                        domStyle.set('preloader', 'visibility', 'hidden');
                        domStyle.set('preloader', 'height', '0');
                        if (dom.byId('customContents')) {
                            cu_fadeIn('customContents');
                        }
                    }
                }).play();
            }
        });
    });
}




// WIKI EDITION




function handle_wiki(base_path, page, preview) {

    require(['dojo/dom','dojo/_base/connect', 'dojo/hash', 'dojo/io-query'], function(dom, connect, hash, ioQuery) {
        connect.subscribe('/dojo/hashchange', handleWikihashState);
        function handleWikihashState() {
           if (!preview) {  
              window.location.href = base_path + '/' + page;
           } else {
              dom.byId('wiki_mode').setAttribute('name','back');
              dijit.byId('WikiManage').submit();
           }
        }
        var obj = { wiki: new Date().getTime() }
        hash(ioQuery.objectToQuery(obj));     
    });


    require(['dojo/ready','dojo/parser','dojo/dom','dojo/_base/xhr','dojo/_base/fx','dojo/on','dojo/io/iframe',
             'dijit/form/Form','dijit/Dialog','dojox/widget/DialogSimple','dijit/form/SimpleTextarea',
             'dojo/date/locale','dijit/form/Button','dijit/Menu','dijit/Editor'], 
    function(ready) { fM_hidePL(); });            
}




// SEARCH




function sM_init(base_path) {
    _base_path = base_path;
    
    require(['dojo/ready', 'dojo/dom', 'dojo/on', 'dojo/keys'], function(ready, dom, on, keys) {
        ready(function() {
            if (dom.byId('site-search-mixedresults')) {
                on(dom.byId('site-search-mixedresults'), 'keydown', function(e) {
                    var ev = e || window.event;
                    var key = ev.keyCode;
                    if (key == 13) {
                        ev.preventDefault(); 
                    sM_globalSearch();
                    }
                });
            }
        });
    });    
}

function sM_search() {
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        var toSearch = document.getElementById('find_id_a1').value;
        if ( toSearch != '' ) {
            domStyle.set('coherent_id_9','display','none');       
            window.location.href = _base_path + '/Search.html/?find=' + toSearch + '#output=' + toSearch;
        }
    });
}

function sM_hashState() {
    require(['dojo/dom','dojo/hash','dojo/io-query','dojo/_base/connect'], function(dom, hash, ioQuery, connect) {
        var toSearch = document.getElementById('find_id_b').value;
        var obj = ioQuery.queryToObject(hash());
        if (obj.output != toSearch) {
            document.getElementById('find_id_b').value = obj.output;
            sM_globalSearch();
        }
    });
}   

function sM_globalSearch() {
    require(['dojo/dom','dojo/dom-style','dojo/_base/xhr','dojo/hash','dojo/io-query','dojo/_base/connect'], 
    function(dom, domStyle, xhr, hash, ioQuery, connect) {
        var toSearch = document.getElementById('find_id_b').value;
        if ( toSearch != '' ) {
            connect.subscribe('/dojo/hashchange', sM_hashState);
            domStyle.set('coherent_id_71','display','');
            var w = document.getElementById('find_id_a1');
            if (w) { document.getElementById('find_id_a1').value = toSearch; }
            xhr.post({
                url: _base_path + '/Search.html',
                postData: {'find': toSearch, 'post': '1'},
                handleAs: 'text',
                load: function(data) {
                    dom.byId('search_contents').innerHTML = data;
                    domStyle.set('coherent_id_71','display','none');   
                    var obj = ioQuery.queryToObject(hash());
                    if (obj.output != toSearch) {
                       var obj = { output: toSearch }
                       hash(ioQuery.objectToQuery(obj));
                    }                 
                }
            });
        }
    });
}

function sM_globalClear(){
    document.getElementById('find_id_b').value = '';
    document.getElementById('find_id_b').focus();
}

function sM_searchInit() {
    require(['dojo/dom','dojo/dom-class','dojo/dom-style','dojo/query','dojo/on'], 

    function(dom, domClass, domStyle, query, on) {

        query('#topmenu .search').forEach(function(node, index, arr) {
           domClass.add(node, 'focused');
           var wrapper = document.getElementById('coherent_id_7');
           domClass.add(wrapper, 'searchmode');
           var mag_wrapper = document.getElementById('coherent_id_12');
           domClass.add(mag_wrapper, 'searchmode');
           query('#topmenu #div li a.top_link span').forEach(function(node, index, arr) { 
                var width = domStyle.get('nav','width');
                if (parseInt(width) > 800) {
                    domClass.add(node, 'searchmode');
                }
           });
           on(node, 'blur', function() {
               query('#topmenu .search').forEach(function(node, index, arr) {
                   domClass.remove(node, 'focused');
                   var wrapper = document.getElementById('coherent_id_7');
                   domClass.remove(wrapper, 'searchmode');
                   var mag_wrapper = document.getElementById('coherent_id_12');
                   domClass.remove(mag_wrapper, 'searchmode');
                   query('#topmenu #div li a.top_link span').forEach(function(node, index, arr) { 
                        domClass.remove(node, 'searchmode');
                   });
               });                           
	       });
           on(node, 'keyup', function(e) {
               var toSearch = document.getElementById('find_id_a1').value;
               domStyle.set('coherent_id_8','display','none');
               if (toSearch != '') {
                   domStyle.set('coherent_id_8','display','');
               } 
               var ev = e || window.event;
               var key = ev.keyCode;
               if (key == 13) {
                   domStyle.set('coherent_id_9','display','');
                   ev.preventDefault(); 
                   sM_search();
               }
           });
        });       
    });
}

function sM_clear() {
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        document.getElementById('find_id_a1').value = '';
        domStyle.set('coherent_id_8','display','none');
    });
}




// UTILS SCRIPTS




function cu_showWizard() {

    require(['dojo/ready','dojo/dom','dojo/dom-class','dojo/on'], function(ready, dom, domClass, on) {

        var handler = on(dom.byId('loginUserLink'), 'click', function() {
	        handler.remove();
            uL_dialog();
	    });

        if (dom.byId('demoHideButton')) {
            on(dom.byId('demoHideButton'), 'click', function() {
		        cu_hideWizard();
	        });
	    }

        var LogoImageSrc = _base_path + '/int/js/custom/images/Lognoter_logo.png';

	    cu_preloadImages([LogoImageSrc]).done(function(images) {
	        cu_fadeIn('democontents');
		    cu_fadeOut('wizardDisplay');
		    domClass.add('wizardDisplay', 'hidden');
        });
    });
}

function cu_hideWizard() {

    require(['dojo/ready','dojo/dom','dojo/dom-class','dojo/dom-style','dojo/on'], function(ready, dom, domClass, domStyle, on) {

        if (dom.byId('democontents') == null) { return }
        
        cu_fadeOut('democontents');

        cu_fadeIn('wizardDisplay');
        domClass.remove('wizardDisplay', 'hidden');
        on(dom.byId('wizardDisplay'), 'click', function() {
            cu_showWizard();
        });
    });
}

function cu_dlgShow(dlg) {

    require(['dojo/dom'], function(dom) { 
        dlg.show();
    });
}

function cu_fadeIn(node) {

    require(['dojo/dom','dojo/dom-style','dojo/_base/fx'], function(dom, domStyle, fx) {
        var fadeArgs = {
            node: node,
            duration: 800
        };
        fx.fadeIn(fadeArgs).play();
        
        if (dojo.isIE && (dojo.isIE <= 8)) {
            dom.byId(node).setAttribute('style', 'filter: alpha(opacity=100)');
        }
    });
}

function cu_fadeQuickIn(node) {

    require(['dojo/dom','dojo/dom-style','dojo/_base/fx'], function(dom, domStyle, fx) {
        var fadeArgs = {
            node: node,
            duration: 0
        };
        fx.fadeIn(fadeArgs).play();
        
        if (dojo.isIE && (dojo.isIE <= 8)) {
            dom.byId(node).setAttribute('style', 'filter: alpha(opacity=100)');
        }
    });
}

function cu_fadeOut(node) {

    require(['dojo/dom','dojo/dom-style','dojo/_base/fx'], function(dom, domStyle, fx) {
        var fadeArgs = {
            node: node,
            duration: 800
        };
        fx.fadeOut(fadeArgs).play();
        
        if (dojo.isIE && (dojo.isIE <= 8)) {
            dom.byId(node).setAttribute('style', 'filter: alpha(opacity=0)');
	        dom.byId(node).innerHTML = '';
        }
   });
}

function cu_fadeQuickOut(node) {

   require(['dojo/dom','dojo/dom-style','dojo/_base/fx'], function(dom, domStyle, fx) {
        var fadeArgs = {
            node: node,
            duration: 0
        };
        fx.fadeOut(fadeArgs).play();
        
        if (dojo.isIE && (dojo.isIE <= 8)) {
            dom.byId(node).setAttribute('style', 'filter: alpha(opacity=0)');
	        dom.byId(node).innerHTML = '';
        }
   });
}

function cu_wipeIn(node) {

    require(['dojo/dom','dojo/dom-style','dojo/fx'], function(dom, domStyle, fx) {
        var fadeArgs = {
            node: node,
            duration: 50
        };
        fx.wipeIn(fadeArgs).play();
    });
}

function cu_wipeOut(node) {

    require(['dojo/dom','dojo/dom-style','dojo/fx'], function(dom, domStyle, fx) {
        var fadeArgs = {
            node: node,
            duration: 50
        };
        fx.wipeOut(fadeArgs).play();
   });
}

function cu_slideHeader() {

    require(['dojo/ready','dojo/dom','dojo/dom-class','dojo/dom-style','dojo/dom-attr','dojo/query','dojo/_base/fx','dojo/NodeList-traverse'], 
    
    function(ready, dom, domClass, domStyle, domAttr, query, fx) {

        ready(function() {
            var slides = dom.byId('slideshow');
            if (slides) { setInterval(dojoSlideShow, 6000); }
        });

        function dojoSlideShow(){    
            var active = query('.active-image');
            active.forEach(function(node, index, arr) { 
                fx.fadeOut({
                    node: node,
                    duration: 800,
                    onEnd: function() {
                        domClass.remove(node, 'active-image');
                    }
                }).play();    
            });
            var next = active.next('img');
            if( next == '' ) { next = query('#slideshow img').first(); }
            next.forEach(function(node, index, arr) { 
                fx.fadeIn({
                    node: node,
                    duration: 800,
                    onEnd: function() {
                        domClass.add(node, 'active-image');
                    }
                }).play();
            });            
        }
    });     
}

function cu_slideLoadIndex(idx) {
    require(['dojo/dom','dojo/dom-class','dojo/dom-style','dojo/query','dojo/_base/fx',
             'dojo/fx'], function(dom, domClass, domStyle, query, baseFx, fx) {
             
        var img_node = query('table.header_images td')[idx-1];
        domClass.add(img_node, 'active-image');
        var banner_node = query('#slides-banners table td')[idx-1];
        domClass.add(banner_node, 'active-banner');
        var node = dom.byId('slides-banners');
        fx.chain([
            baseFx.fadeIn({ node: node })
        ]).play();
    }); 
}   

function cu_slideStartIndex(idx, total) {
    require(['dojo/dom','dojo/dom-class','dojo/query'], function(dom, domClass, query) {
        cu_slideCleanIndex();
        var img_node = query('table.header_images td')[idx-1];
        domClass.add(img_node, 'active-image');
    }); 
}  

function cu_slideCompleteIndex(idx, total) {
    require(['dojo/dom','dojo/dom-class','dojo/dom-style','dojo/query','dojo/_base/fx',
             'dojo/fx'], function(dom, domClass, domStyle, query, baseFx, fx) {
        cu_slideCleanIndex();
        var img_node = query('table.header_images td')[idx-1];
        domClass.add(img_node, 'active-image');
        var banner_node = query('#slides-banners table td')[idx-1];
        domClass.add(banner_node, 'active-banner');
        var node = dom.byId('slides-banners');
        var slideLeft = domStyle.get(node, 'left');
        fx.chain([
            baseFx.fadeIn({ node: node }),
        ]).play();
    }); 
}  

function cu_slideCleanIndex() { 
    require(['dojo/dom','dojo/dom-class','dojo/dom-style','dojo/query','dojo/_base/fx',
             'dojo/fx'], function(dom, domClass, domStyle, query, baseFx, fx) {
        var node = dom.byId('slides-banners');
        var slideLeft = domStyle.get(node, 'left');
        query('#slides-banners table td').forEach(function(node, index, arr) {
            domClass.remove(node, 'active-banner');
        });
        fx.chain([
            baseFx.fadeOut({ node: node }),
        ]).play();
        query('table.header_images td').forEach(function(node, index, arr) {
            var img_node = query('table.header_images td')[index];
            if (img_node && domClass.contains(img_node, 'active-image')) { domClass.remove(img_node, 'active-image'); }
        });
    });
}

function cu_tableHeader() {

    require(['dojo/ready','dojo/dom','dojo/dom-class','dojo/on','dojo/query','dojo/_base/fx',
             'dojo/mouse'], function(ready, dom, domClass, on, query, fx, mouse) {
             
        ready(function() {
             var table_header = query('table.header_images');
             if (table_header) {
	            query('table.header_images td').forEach(function(node, index, arr) {
	                on(dom.byId(node), mouse.enter, function() {
	                    fx.fadeIn({
                            node: node,
                        	duration: 50,
                            onEnd: function() { domClass.add(node, 'hover'); }
                     	}).play();
	                });
	                on(dom.byId(node), mouse.leave, function() {
	                    fx.fadeIn({
                            node: node,
                        	duration: 50,
                            onEnd: function() { domClass.remove(node, 'hover'); }
                     	}).play();
	                });
	            });
             }
        });   
    });
}

function cu_preloadEditMenuImages(arr) {
    var imagesEditMenuloaded = 0;
    var images = [];
    var arr = (typeof arr!='object')? [arr] : arr;
    
    function imageloadpost(){
        imagesEditMenuloaded++;
        if (imagesEditMenuloaded == arr.length) {
            postEditMenuaction(images);
        }
    }
    
    for (var i = 0; i < arr.length; i++) {
        images[i] = new Image();
        images[i].src = arr[i];
        images[i].onload = function() {
            imageloadpost();
        }
        images[i].onerror = function() {
            imageloadpost();
        }
    }
    
    return { 
        done:function(f) {
            postEditMenuaction=f || postEditMenuaction;
        }
    }
}

function cu_preloadImages(arr) {
    var imagesloaded = 0;
    var images = [];
    var arr = (typeof arr!='object')? [arr] : arr;
    
    function imageloadpost(){
        imagesloaded++;
        if (imagesloaded == arr.length) {
            postaction(images);
        }
    }
    
    for (var i = 0; i < arr.length; i++) {
        images[i] = new Image();
        images[i].src = arr[i];
        images[i].onload = function() {
            imageloadpost();
        }
        images[i].onerror = function() {
            imageloadpost();
        }
    }
    
    return { 
        done:function(f) {
            postaction=f || postaction;
        }
    }
}












function deleteSSLcache() {
    var agt = navigator.userAgent.toLowerCase();
	if (agt.indexOf('msie') != -1) {
	    document.execCommand('ClearAuthenticationCache','false');
	} else if (window.crypto && typeof window.crypto.logout == 'function'){
		window.crypto.logout();        
	}      
}

function youtubeTest() {
    var image = new Image();
    image.onload = function() {
        // The user can access youtube  
    };
    image.onerror = function() {
        // The user can't access youtube 
    };
    image.src = "http://youtube.com/favicon.ico";
}



