

proc AddTagToBeginningInMenus { w tag } {
}

proc CASelectMenu { w } {
}


proc ChangeAccelerators { { w .changeacc } } {
    global GIDDEFAULT

    InitWindow $w [_ "Change accelerators"] ChangeAcceleratorsWindowGeom ChangeAccelerators
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

    ttk::button $w.left -image [gid_themes::GetImage ArrowLeft.png small_icons]
    ttk::frame $w.middle
    ttk::scrollbar $w.middle.yscroll -command "$w.middle.list yview"
    #-relief sunken 
    ttk::scrollbar $w.middle.xscroll -orient horizontal \
	    -command "$w.middle.list xview"
	#-relief sunken 
    #pseudottk::
    tk::listbox $w.middle.list -width 1 -height 2 -yscroll "$w.middle.yscroll \
	     set" -xscroll "$w.middle.xscroll set" -relief sunken \
	     -selectmode extended -font FixedFont -width 10
    pack $w.middle.yscroll -side right -fill y
    pack $w.middle.xscroll -side bottom -fill x
    pack $w.middle.list  -expand yes -fill both

    ttk::button $w.right -image [gid_themes::GetImage ArrowRight.png small_icons]

    ttk::frame $w.acc
    ttk::label $w.acc.l -text [_ "Accelerator"]
    ttk::entry $w.acc.e
    # -relief sunken
    grid $w.acc.l $w.acc.e

    ttk::frame $w.buts -style BottomFrame.TFrame
    ttk::button $w.buts.select -text [_ "Select menu"] -command "CASelectMenu $w" -style BottomFrame.TButton
    ttk::button $w.buts.close -text [_ "Close"] -command "destroy $w" -style BottomFrame.TButton
    grid $w.buts.select $w.buts.close

    grid $w.left -row 0 -column 0
    grid $w.middle  -sticky nsew -row 0 -column 1
    grid $w.right -row 0 -column 2
    grid $w.acc -row 0 -column 3
    grid $w.buts -columnspan 4
    if { $::tcl_version >= 8.5 } { grid anchor $w.buts center }
    grid rowconf $w 0 -weight 1
    grid columnconf $w 1 -weight 1

}