
proc CommentsFillFromGiD { w } {
    global CommentsPriv

    set CommentsPriv(initializing) 1
    set aa [GiD_Info postprocess get comments]
    for { set i 1 } { $i<=3 } { incr i } {
	set CommentsPriv(comm$i) [lindex $aa [ expr $i + 1]]
	# if { $CommentsPriv(comm$i) == "" } {
	#     set CommentsPriv(active$i) 0
	# } else { set CommentsPriv(active$i) 1 }
    }
    if { [lindex $aa 0] == "yes" } {
	set CommentsPriv(active) 1
    } else {
	set CommentsPriv(active) 0
    }
    if { [lindex $aa 1] == "yes" } {
	set CommentsPriv(automatic) 1
    } else {
	set CommentsPriv(automatic) 0
    }

    if { "$CommentsPriv(donde)" == "PRE" } {
	set CommentsPriv(automatic) 0
    }
#     WarnWinText aa=--$aa--

    set CommentsPriv(initializing) 0
}

proc AcceptComments { w } {
    global CommentsPriv
    if { $CommentsPriv(active) == 0 } {
	GiD_Process escape escape escape utilities comments comments no escape
    } else {
	GiD_Process escape escape escape utilities comments comments yes
	for { set i 1 } { $i<=3 } { incr i } {
	    #if { $CommentsPriv(active$i) }
	    if { "$CommentsPriv(comm$i)" != ""} {
		GiD_Process Line$i $CommentsPriv(comm$i)
	    } else {
		GiD_Process Line$i {}
	    }
	}
	if { $CommentsPriv(automatic) == 1 } {
	    GiD_Process escape escape escape utilities comments automatic yes escape
	} else {
	    GiD_Process escape escape escape utilities comments automatic no escape
	}
    }
}

proc CommentsActiveChange { w what} {
    global CommentsPriv
    switch $what {
	main {
	    if { $CommentsPriv(active) == 0 } {
		$w.ch2 configure -state disabled
		for { set i 1 } { $i<=3 } { incr i } {
		    #set CommentsPriv(active$i) 0
		    #$w.fr1.ch$i configure -state disabled
		    $w.fr1.l$i configure -state disabled 
#-foreground grey60
		}
	    } else {
		$w.ch2 configure -state normal
		CommentsAutomaticChange $w $what
		for { set i 1 } { $i<=3 } { incr i } {
		    #$w.fr1.ch$i configure -state normal
		    #if { [$w.fr1.l$i get] != "" } {
		          #set CommentsPriv(active$i) 1
		          $w.fr1.l$i configure -state normal 
#-foreground black
		    #}
		}
	    }
	}
	default {
	    # if { $CommentsPriv(active$what) == 0 } {
	    #         $w.fr1.l$what configure -state disabled -foreground grey60
	    # } else {
	    #         $w.fr1.l$what configure -state normal -foreground black
	    # }
	}
    }
}

proc CommentsAutomaticChange { w what} {
    global CommentsPriv
    switch $what {
	main {
	    if { $CommentsPriv(automatic) == 0 } {
		for { set i 1 } { $i<=3 } { incr i } {
		    #$w.fr1.ch$i configure -state normal
		    #if { [$w.fr1.l$i get] != "" } {
		         #set CommentsPriv(active$i) 1
		         $w.fr1.l$i configure -state normal 
#-foreground black
		    #}
		}
		TipWin::Close "Comments fields"
	    } else {
		for { set i 1 } { $i<=3 } { incr i } {
		    #set CommentsPriv(active$i) 0
		    #$w.fr1.ch$i configure -state disabled
		    $w.fr1.l$i configure -state disabled 
#-foreground grey60
		}
		#if { !$CommentsPriv(initializing)} {
		#    TipWin::Create $w "Comments fields" "With automatic comments (in Post)\n"\
		#              "you can use following fields:\n"\
		#              "%an - analysis name\n"                  \
		#              "%sv - step value in analysis\n"                     \
		#              "%sn - step number in analysis\n"                     \
		#              "%ns - total number of steps in analysis\n"                     \
		#              "%vt - result visualization type\n"             \
		#              "%vf - vector factor\n"                     \
		#              "%rn - result name\n"                     \
		#              "%cn - component name\n"                     \
		#              "%da - deformation used analysis\n"             \
		#              "%ds - deformation used step value\n"    \
		#              "%dr - deformation used result\n"             \
		#              "%df - deformation used factor"
		#}
	    }
	}
	default {
	    #if { $CommentsPriv(active$what) == 0 } {
	    #        $w.fr1.l$what configure -state disabled -foreground grey60
	    #} else {
	    #        $w.fr1.l$what configure -state normal -foreground black
	    #}
	}
    }
}


proc CommentsW { { w .gid.wCommentsWW } } {
    global CommentsPriv
    #default values
    catch {
	set ::CommentsPriv(active) 1
	set ::CommentsPriv(automatic) 1
    }
    InitWindow $w [_ "Comments"] CommentsWindowGeom CommentsW
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

    set def_back [ $w cget -background]
     
    set CommentsPriv(donde) [GetCurrentPrePostMode]   
    if { ![info exists CommentsPriv(active)] } { set CommentsPriv(active) 0 }
    ttk::checkbutton $w.ch1 -text [_ "Active"] -variable CommentsPriv(active) \
	-onvalue 1 -offvalue 0
    if { ![info exists CommentsPriv(automatic)] } { set CommentsPriv(automatic) 0 }
    ttk::checkbutton $w.ch2 -text [_ "Automatic"] -variable CommentsPriv(automatic) \
	-onvalue 1 -offvalue 0
    set text "[_ "When using automatic comments (in Post)"]\n\
	[_ "you can use following fields"]:\n\
	[_ "%an - analysis name"]\n \
	[_ "%sv - step value in analysis"]\n \
	[_ "%sn - step number in analysis"]\n \
	[_ "%ns - total number of steps value in analysis"]\n \
	[_ "%vt - result visualization type"]\n \
	[_ "%vf - vector factor"]\n \
	[_ "%rn - result name"]\n \
	[_ "%cn - component name"]\n \
	[_ "%da - deformation used analysis"]\n \
	[_ "%ds - deformation used step value"]\n \
	[_ "%dr - deformation used result"]\n \
	[_ "%df - deformation used factor"]\n \
	[_ "%tcl() - evaluate a tcl expression, \n\tfor instance \"Correct step value: %tcl( expr %sv * 2.5 + 3)\""]"

    TipWin::CreateHelpButton $w.bh [_ "Automatic fields"] $text

    
    setTooltip $w.bh -text $text

    ttk::frame $w.fr1
    ttk::frame $w.but -style BottomFrame.TFrame 

    grid $w.ch1 -sticky w -column 1 -row 1
    if { "$CommentsPriv(donde)" == "POST" } {
	grid $w.ch2 -sticky w -column 2 -row 1
	grid $w.bh -sticky e -column 3 -row 1
    }
    grid $w.fr1 -sticky nsew -padx 3 -pady 3 -column 1 -row 2 -columnspan 3
    grid $w.but -sticky nsew -column 1 -row 3 -columnspan 3
    if { $::tcl_version >= 8.5 } { grid anchor $w.but center }
    grid columnconf $w 1 -weight 1
    grid rowconf $w 2 -weight 1


    for { set i 1 } { $i<=3 } { incr i } {
	ttk::label $w.fr1.txt$i -text [ concat [_ "Line"] " $i: "]
	ttk::entry $w.fr1.l$i -textvariable CommentsPriv(comm$i)
	
	grid $w.fr1.txt$i -column 1 -row $i
	grid $w.fr1.l$i -column 2 -row $i -sticky we
	
	grid columnconf $w.fr1 2 -weight 1
	grid rowconf $w.fr1 $i -weight 1
	#trace variable CommentsPriv(active$i) w "CommentsActiveChange $w $i ;#"
    }

    # marco de los botones
    ttk::button $w.but.apply -text [_ "Apply"] -style BottomFrame.TButton -command "AcceptComments $w" -takefocus 0         
    ttk::button $w.but.close -text [_ "Close"] -style BottomFrame.TButton -command "destroy $w" -takefocus 0 
    grid $w.but.apply $w.but.close -sticky ews -padx 5 -pady 5

    focus $w.fr1.l1


    trace variable CommentsPriv(active) w "CommentsActiveChange $w main ;#"
    if { "$CommentsPriv(donde)" == "POST" } {
	trace variable CommentsPriv(automatic) w "CommentsAutomaticChange $w main ;#"
    }

    CommentsFillFromGiD $w
    # para el trace
    set CommentsPriv(active) $CommentsPriv(active)

    bind $w <Return> "$w.but.apply invoke"
    bind $w <Alt-c> "$w.but.close invoke"
    bind $w <Escape> "$w.but.close invoke"
}
