#
# Tcl package index file
#

proc LoadLibrary_objarray { dir basename } {   
    if { $::tcl_platform(pointerSize) == 8} {
	set bits 64
    } else {
	set bits 32
    }
    set pref ""
    if { $::tcl_platform(platform) == "unix"} {
	set pref "lib"
    }
    set library ${pref}${basename}_${bits}[info sharedlibextension]    
    load [file join $dir $library] $basename
    #load {C:\gid project\gidvs\Debug\objarray.dll}
}

package ifneeded objarray 1.1 [list LoadLibrary_objarray $dir objarray]
