# Tcl package index file, version 1.0

global tcl_platform

set ::env(ITCL_LIBRARY) $dir

if { $tcl_platform(platform) == "windows"} {

    if {[package vsatisfies 8.0 [package provide Tcl]]} { 
	set add 80
    } else {
	set add {tx}
    }
    set ::env(ITCL_LIBRARY) $dir
    if {[info exists ::tcl_platform(debug)] && $::tcl_platform(debug) && \
	    [file exists [file join $dir itcl40${add}g.dll]]} {
	package ifneeded Itcl 4.0.0 [list load [file join $dir itcl40${add}g.dll] Itcl]
    } else {   
	package ifneeded Itcl 4.0.0 [list load [file join $dir itcl40${add}.dll] Itcl]
    }
    unset add
    
} else { 
    
    if {![package vsatisfies [package provide Tcl] 8.6]} {return}
    
    package ifneeded itcl 4.0.0 [list load [file join $dir "libitcl4.0.0.so"] itcl]
    package ifneeded Itcl 4.0.0 [list load [file join $dir "libitcl4.0.0.so"] itcl]
}